import Bladex
from math import pow
import GameText
import Damage
import CharStats
import Scorer
import Reference
import Auras
import pocimac
import darfuncs
import Actions
import ItemTypes
import whrandom
import B3DLib
import GenFX
import AuxFuncs
import MenuText
import Water
import AbreCam
import ObjStore
import EnemyCharTypes
import Enm_Def
import PhantonFX
import WizQuiverTypes
import MasklinTypes
import MasklinMagic


GameText.MapList ['WIZARDSDOMAIN'] = 'WizardsDomain'


##########################################################################################################################################################
###### Init Player key bindings, calibrate Scorer and all that stuff.............


MasklinTypes.InitMasklin()



######## intro stuff ####################################################################################################################################

LiveGame=1


def SetCamSave():
	global LiveGame
	if LiveGame==1:
		LiveGame=0
	else:
		cam=Bladex.GetEntity("Camera")
  		cam.PViewType=0
		print "Setting cam PV in saved game"

Bladex.AddScheduledFunc(Bladex.GetTime() + 2.0,SetCamSave,())


def ResetAttackMoves():

	# To fix bug in savegame where Data is applied before 
	# weapons are added to inventory and
	# unarmed moves are enabled.
	ents = Bladex.nEntities()
	for id in range(ents):
		per = Bladex.GetEntity(id)
		if per: 
			if per.Person:
				if per.Life>0 and per.Name!="Player1":
					try:
						per.Data.ResetCombat(per.Name)
						Reference.debugprint("RESET COMBAT: " + per.Name)
					except AttributeError:
						Reference.debugprint(per.Name+": Does not have ResetCombat attribute")

Bladex.AddScheduledFunc(Bladex.GetTime() + 3.0, ResetAttackMoves, ())

import intro

def InitIntro():
	cam=Bladex.GetEntity("Camera")
  	cam.PViewType=0
	Bladex.DeactivateInput()
	char=Bladex.GetEntity("Player1")
	cam=Bladex.GetEntity("Camera")
	cam.SType = 0 
	cam.TType = 0 
	cam.Position=-5149,-1604,-9310     
	cam.TPos=2419,-961,-15815 
	darfuncs.HideBadGuy("Player1")
	Bladex.AddScheduledFunc(Bladex.GetTime() + 2.2, intro.InitWidgets,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.0, AuxFuncs.FadeFrom, (0.4,1.8,))
  	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.2, ChangeMusic,("Intro1",))
  	
  	
EnterAct=0

def PressKeyEnter(EntityName):
	global EnterAct
	if EnterAct!=0:
		return
	QuitIntro()
	EnterAct=1
	
	
def ResetKeys():
	Bladex.RemoveBoundFunc("Use",PressKeyEnter)
   	Bladex.AddBoundFunc("Use",acts.DefArgWrapper ("Player1", Actions.StdUse))
   	
   

def RedefineKeys():
	import acts
	Bladex.AddBoundFunc("Use",acts.DefArgWrapper ("Player1", PressKeyEnter))
	Bladex.RemoveBoundFunc("Use",Actions.StdUse)
	
Bladex.AddScheduledFunc(Bladex.GetTime()+3.5,RedefineKeys,())



def ResetCam():
	cam=Bladex.GetEntity("Camera")
	cam.SetPersonView("Player1")
	cam.Cut()
	
def ShiftStandin():
	stdin=Bladex.GetEntity("ActorMasklin")
	stdin.Alpha=0 #so as not to be picked up in enemy scan
	darfuncs.HideBadGuy("ActorMasklin")
	
		
def QuitIntro():
	intro.DeactFrames()
	char=Bladex.GetEntity("Player1")
	char.Position=-4808, -1026, -5532
	char.Angle=3.3
	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.1, Bladex.DeactivateInput,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.3, Bladex.KillMusic,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.5, AuxFuncs.FadeFrom, (0.1,2.8,))
	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.6, ShiftStandin,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 2.2, darfuncs.UnhideBadGuy,("Player1",))
	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.7, ResetCam,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 1.2, Bladex.ActivateInput,())
	Bladex.AddScheduledFunc(Bladex.GetTime() + 3.0, Scorer.SetVisible, (1,))
	Bladex.AddScheduledFunc(Bladex.GetTime() + 3.5, ChangeMusic,("atm18",))
	Bladex.AddScheduledFunc(Bladex.GetTime() + 4.0, ResetKeys,())
  	char.Data.LevelupFunc=StartMatrix
  	
  
  
def BuddyDead(entity):
	GameText.WriteTextAux(entity+" Killed in Action", 5.0, 160,100,160,[],100)
	
def BuddyComingToHelp(entity):
	GameText.WriteTextAux(entity+" Coming to Help", 5.0, 160,100,160,[],100)
 
 
 
def DorcasDead():
	GameText.WriteTextAux("Dorcas Killed in Action", 5.0, 160,100,160,[],100)
 
############################################################################################################################################################
######## Adjust some enemy stats for test purposes

from CharData import CharMaxLifeValue
from CharData import CharDamageData
from CharData import CharDefenseData
from CharData import CharResistances
from CharData import CharExperienceCost
from CharData import CharExperienceReward
from CharData import CharAccuracy


CharMaxLifeValue['Minotaur']=     [  150,   250,   350,   500,   700,   950,   1250,  1600,  2100,  2700,  3800,  4500,  5400,  6500,  7700,  8800,  9600,  12000,  15000,  18000]     
CharExperienceReward['Minotaur']= [    60,     70,     90,    180,    360,    600,    1400,   2800,   5500,   10000,  24000,  50000,  80000, 152880, 200000, 450000, 570000, 1000000, 2010000, 2040000]
CharExperienceCost['Minotaur']=[    50,    100,    200,    400,    800,   1600,   3200,   6400,  12800,  25600,  51200, 102400, 204800, 409600, 819200,1638400,3276800,6553600,13107200,26214400]


CharMaxLifeValue['Ragnar']= [ 40,  80, 180, 380, 580,  780, 980, 1380, 1780, 2180, 2580, 2980, 3380, 3780, 4180, 4580, 4980, 5380, 5780, 6180]
CharExperienceReward['Ragnar']= [   100,    200,    400,   800,   1600,   3200,  6400,  12800,  25000,  35000,  45000, 60000, 75000, 90000, 120000, 150000, 200000, 240000, 260000, 280000]     


CharExperienceReward['ChaosKnight']=[    60,     80,     120,    180,    360,    600,    1400,   2800,   5500,   10000,  24000,  50000,  80000, 152880, 200000, 450000, 570000, 1000000, 2010000, 2040000]
CharMaxLifeValue['ChaosKnight']=    [  1000,   1500,   2000,   2800,   3500,  5000,  7000,  9000,  12000,  14000,  15000,  16000,  17000,  18000,  19000,  20000,  21000,  22000,  23000,  24000]


CharMaxLifeValue['Golem_stone']=    [  800,   1000,   1200,   1500,   1800,   2200,   2600,   3200,   4000,  5000,  6200,  7500,  9000,  12000,  16000,  20000,  24000,  27000,  30000,  35000]
CharExperienceReward['Golem_stone']=[    60,     80,     120,    180,    360,    600,    1400,   2800,   5500,   10000,  24000,  50000,  80000, 152880, 200000, 450000, 570000, 1000000, 2010000, 2040000]


CharMaxLifeValue['SpiderCrab']=         [    30,     45,     60,     75,     120,     150,     180,     240,     350,     420,     560,     680,     900,     1300,     1650,     2000,     2400,     3000,     4000,     5000]
CharDamageData['SpiderCrab']=           [    10,     15,     20,     25,     40,     45,     50,     55,     60,     65,     70,     75,     80,     85,     90,     95,    120,    150,    170,    190]
CharDefenseData['SpiderCrab']=          [     0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0]
CharExperienceCost['SpiderCrab']=       [     0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0]
CharExperienceReward['SpiderCrab']=     [     2,      8,     12,     16,     24,     48,     70,     90,    110,    180,    300,    500,    800,   1100,   1500,   3000,   4500,   6000,   8000,  10000]
CharResistances['SpiderCrab']=          {'Impale': 0.90, 'Venom': 1.00, 'Slash': 0.90, 'Crush': -0.30, 'Ice': 1.00, 'Fire': -1.00, 'Light': 1.00, 'Drain': 1.00}



CharMaxLifeValue['Spidersmall']=         [    30,     45,     60,     75,     120,     150,     180,     240,     350,     420,     560,     680,     900,     1300,     1650,     2000,     2400,     3000,     4000,     5000]
CharDamageData['Spidersmall']=           [    10,     15,     20,     25,     40,     45,     50,     55,     60,     65,     70,     75,     80,     85,     90,     95,    120,    150,    170,    190]
CharDefenseData['Spidersmall']=          [     0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0]
CharExperienceReward['Spidersmall']=     [     2,      8,     12,     16,     24,     48,     70,     90,    110,    180,    300,    500,    800,   1100,   1500,   3000,   4500,   6000,   8000,  10000]
CharResistances['Spidersmall']=          {'Impale': 0.90, 'Venom': 1.00, 'Slash': 0.70, 'Crush': -0.30, 'Ice': 1.00, 'Fire': -1.00, 'Light': 1.00, 'Drain': 1.00}


CharMaxLifeValue['Cos']=         [    30,     45,     60,     75,     120,     150,     180,     240,     350,     420,     560,     680,     900,     1300,     1650,     2000,     2400,     3000,     4000,     5000]
CharDamageData['Cos']=           [    10,     15,     20,     25,     40,     45,     50,     55,     60,     65,     70,     75,     80,     85,     90,     95,    120,    150,    170,    190]
CharDefenseData['Cos']=          [     0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0]
CharExperienceReward['Cos']=     [     2,      8,     12,     16,     24,     48,     70,     90,    110,    180,    300,    500,    800,   1100,   1500,   3000,   4500,   6000,   8000,  10000]
CharResistances['Cos']=          {'Impale': 0.50, 'Venom': 1.00, 'Slash': 0.60, 'Crush': 0.00, 'Ice': 1.00, 'Fire': -1.00, 'Light': 1.00, 'Drain': 1.00}



# Tmp resistances for NPC Dorcas
CharResistances['Fem1Wiz']=      {'Impale': 0.70, 'Slash': 0.85, 'Crush': 0.85, 'Fire': 0.00, 'Ice': 0.00, 'Venom': 0.40, 'Light': 0.00, 'Electric': 1.00, 'Acid': 0.00, 'Drain': 0.00}

Reference.DefaultSelectionData['Tablilla1']=(0.0,0.0, "")
Reference.DefaultSelectionData['Tablilla2']=(0.0,0.0, "")
Reference.DefaultSelectionData['Tablilla3']=(0.0,0.0, "")
Reference.DefaultSelectionData['Tablilla4']=(0.0,0.0, "")



Reference.EntitiesSelectionData["Libro2_60"]=(0.0,0.0,"")
Reference.EntitiesSelectionData["Libro_59"]=(0.0,0.0,"")
Reference.EntitiesSelectionData["Corona_1701"]=(0.0,0.0,"")
Reference.EntitiesSelectionData["Skull_1075"]=(0.0,0.0,"")
Reference.EntitiesSelectionData["Altar_1779"]=(0.0,0.0,"")
Reference.EntitiesSelectionData["PiedraInformativa_1786"]=(0.0,0.0,"")
Reference.EntitiesSelectionData["Gema_127"]=(0.0,0.0,"")

Reference.EntitiesSelectionData["FreezerDoorLeverStick"]=(8,4000.0,MenuText.GetMenuText("Freezer Door Lever"))

Reference.DefaultSelectionData['Gema']=(0.0,0.0, "")

Reference.DefaultObjectData['Tintero']=[Reference.OBJ_STANDARD,   0, 0, 2.0,  Reference.THR_SPINNING, []]



CharMaxLifeValue['Enano1']=     [   120,    220,    320,    420,    620,    820,   1020,   1420,   1820,   2220,   2620,   3020,   3420,   3820,   4220,   4620,   5020,   5420,   5820,   6220]
CharMaxLifeValue['Enano2']=     [   120,    220,    320,    420,    620,    820,   1020,   1420,   1820,   2220,   2620,   3020,   3420,   3820,   4220,   4620,   5020,   5420,   5820,   6220]
CharDamageData['Enano1']=       [     2,      3,      5,      7,      9,     11,     13,     15,     17,     19,     21,     23,     25,     27,     29,     31,     33,     35,     37,     39]
CharDamageData['Enano2']=       [     2,      3,      5,      7,      9,     11,     13,     15,     17,     19,     21,     23,     25,     27,     29,     31,     33,     35,     37,     39]
CharExperienceReward['Enano1']= [    40,     50,     60,    120,    240,    480,    960,   1920,   3840,   7680,  15360,  30720,  61440, 122880, 135000, 150000, 170000, 190000, 210000, 240000]
CharExperienceReward['Enano2']= [    40,     50,     60,    120,    240,    480,    960,   1920,   3840,   7680,  15360,  30720,  61440, 122880, 135000, 150000, 170000, 190000, 210000, 240000]
CharResistances['Enano1']=     {'Impale': 0.30, 'Slash': 0.30, 'Crush': 0.60, 'Fire': 0.00, 'Ice': 0.00, 'Venom': 0.80, 'Light': 0.00, 'Electric': 1.00, 'Acid': 0.00, 'Drain': 0.00}
CharResistances['Enano2']=     {'Impale': 0.30, 'Slash': 0.40, 'Crush': 0.70, 'Fire': 0.00, 'Ice': 0.00, 'Venom': 0.80, 'Light': 0.00, 'Electric': 1.00, 'Acid': 0.00, 'Drain': 0.00}


CharResistances['Barbarian_N']={'Impale': 0.20, 'Slash': 0.50, 'Crush': 0.80, 'Fire': 0.00, 'Ice': 0.00, 'Venom': 0.70, 'Light': 0.00, 'Electric': 1.00, 'Acid': 0.00, 'Drain': 0.00}

CharResistances['Amazon_N']={'Impale': 0.30, 'Slash': 0.60, 'Crush': 0.80, 'Fire': 0.00, 'Ice': 0.00, 'Venom': 0.70, 'Light': 0.00, 'Electric': 1.00, 'Acid': 0.00, 'Drain': 0.00}

CharResistances['Knight_N']={'Impale': 0.20, 'Slash': 0.40, 'Crush': 0.70, 'Fire': 0.00, 'Ice': 0.00, 'Venom': 0.70, 'Light': 0.00, 'Electric': 1.00, 'Acid': 0.00, 'Drain': 0.00}

CharResistances['Dwarf_N']={'Impale': 0.20, 'Slash': 0.50, 'Crush': 0.80, 'Fire': 0.00, 'Ice': 0.00, 'Venom': 0.80, 'Light': 0.00, 'Electric': 1.00, 'Acid': 0.00, 'Drain': 0.00}




if not Reference.HealthIncrease.has_key("CrabShell"):
	Reference.HealthIncrease["CrabShell"]=(50,0,Reference.POCIMAC_FOOD)
	
	
Reference.DefaultObjectData['CrabShell']=[Reference.OBJ_USEME]
Reference.DefaultSelectionData['CrabShell']=(0.0,0.0, "")
	
	
if not Reference.HealthIncrease.has_key("ProFishfinger"):
	Reference.HealthIncrease["ProFishfinger"]=(25,0,Reference.POCIMAC_FOOD)
	
Reference.DefaultObjectData['ProFishfinger']=[Reference.OBJ_USEME]
Reference.DefaultSelectionData['ProFishfinger']=(7.0,3000.0, "Fish Finger")
	
	
if not Reference.HealthIncrease.has_key("ProBanana"):
	Reference.HealthIncrease["ProBanana"]=(50,1,Reference.POCIMAC_FOOD) # Bananas cure poison
	
Reference.DefaultObjectData['ProBanana']=[Reference.OBJ_USEME]
Reference.DefaultSelectionData['ProBanana']=(7.0,3000.0, "Banana")



import SolidMask
Bladex.SetSolidMask('ProWood1',SolidMask.EX_CAMERA|SolidMask.EX_EYE)
Bladex.SetSolidMask('ProWood2',SolidMask.EX_CAMERA|SolidMask.EX_EYE)
Bladex.SetSolidMask('ProWood3',SolidMask.EX_CAMERA|SolidMask.EX_EYE)


Bladex.SetSolidMask('Estalact1',SolidMask.EX_FLOOR)
Bladex.SetSolidMask('Estalact2',SolidMask.EX_FLOOR)

Bladex.SetSolidMask('ProCobra',0)
Bladex.SetSolidMask('Cabane1',0)

Bladex.SetSolidMask('Baldosa_01',0)
Bladex.SetSolidMask('Baldosa_rota',0)

Bladex.SetSolidMask('Geoda',0)
Bladex.SetSolidMask('TronoEscarabeu',0)

###### Define NEW obj refs ( also needed in ActorsInit.py for savegame integrity) #####


# My version of the War Hammer (Hacha4) with better strike area. Also lesser defense penalty

Reference.DefaultObjectData['Hacha4Pro']=[Reference.OBJ_WEAPON, 55, -15, 2.5,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]

########################################################################################################################################################

def WriteCaptionT5(Txt,Hite=50,Time=5.0):
	GameText.AbortText()
	GameText.WriteTextAux(MenuText.GetMenuText(Txt),Time,145,200,200,[],Hite)


########################################################################################################################################################
####### Power Ball & FX

def GetPowerFX():
	time=Bladex.GetTime()
	ps=Bladex.CreateEntity("Player1Absorb", "Entity Particle System Dperson", 0, 0, 0)
	ps.PersonName="Player1"				
	ps.Time2Live      = 20
	ps.ParticleType   = "Llamita"
	ps.YGravity       = 0.0
	ps.Friction       = 0
	ps.PPS            = 1024
	ps.Velocity       = 0,0,0
	ps.NormalVelocity = -5
	ps.FollowFactor   = 1
	ps.DeathTime      = time+0.5
	
	

def SetMagicSector(name):
	Bladex.SetTriggerSectorFunc(name, "OnEnter", StartCharge)
	Bladex.SetTriggerSectorFunc(name, "OnLeave", StopCharge)



def SetRadialMagicSector(object_name, radius=500.0, floor_displ=1000.0, roof_displ=2000.0):
	x, y, z = Bladex.GetEntity(object_name).Position
	dx=radius/2.0
	dz=radius*((math.sqrt(3.0))/2.0)
	trsector_name=object_name+"_TrSectorMagic"
	Bladex.AddTriggerSector(trsector_name, "SectoresMagic", y+floor_displ, y-roof_displ, [(x+dx, z+dz), (x-dx, z+dz), (x-radius, z), (x-dx, z-dz), (x+dx, z-dz), (x+radius, z)])
	SetMagicSector(trsector_name)



def SparkyFire(entityname):
	fire=Bladex.GetEntity(entityname)
	sparx=Bladex.CreateEntity(entityname+"Sparx", "Entity Particle System D1", 0,0,400)
	sparx.ParticleType="SacredFX"
	sparx.Time2Live=16
	sparx.YGravity=0.0
	sparx.Friction=0
	sparx.PPS=512
	sparx.Velocity=0,1000,0
	sparx.RandomVelocity= -10
	sparx.DeathTime = Bladex.GetTime()+5.5
	fire.Link(sparx)
	Bladex.AddScheduledFunc(Bladex.GetTime()+15.0, SparkyFire,(entityname,))
	

def MakeFloorTorch(torchname,Intens=4.0):
	tor=Bladex.GetEntity(torchname)
	tor.CastShadows=0
	x,y,z=tor.GraspPos("Top")
	tor.Lights = [(Intens, 0.03125, (25, 146, 168))]
	torps=Bladex.CreateEntity(torchname+"_Flame","Entity Particle System D1",x,y,z)
	torps.ParticleType="CoolFlame"
	torps.PPS=100 
	torps.YGravity=-4000.0
	torps.Friction=0.12
	torps.Velocity=0.0, -1700.0, 0.0
	torps.RandomVelocity=20 #30
	torps.Time2Live=14


def PenduloLight(penduloname,Intens=45.0,PSkind="CoolFlame"):
	tor=Bladex.GetEntity(penduloname)
	tor.CastShadows=0
	x,y,z=tor.Position
	torlite=Bladex.CreateEntity(penduloname+"_Lite", "Entity Spot",x,y-4000,z)
	torlite.Color=40,40,225
	torlite.Intensity=Intens
	torlite.Precission=0.55
	torlite.Flick=0
	torlite.Visible=0
	torlite.CastShadows=0
	torps=Bladex.CreateEntity(penduloname+"_Flame","Entity Particle System D1",x,y-4000,z)
	torps.ParticleType="CoolFlame"
	torps.PPS=400 
	torps.YGravity=-4000.0
	torps.Friction=0.12
	torps.Velocity=0.0, -3000.0, 0.0
	torps.RandomVelocity=30 
	torps.Time2Live=20
	

def IceFire(entity,x,y,z):
	llamarada=Bladex.CreateEntity(entity+"_IcyFire", "Entity Particle System D1", x,y-800,z)
	llamarada.ParticleType="FlameCabezon"
	llamarada.YGravity=-4000.0
	llamarada.Friction=0.12
	llamarada.PPS=300
	llamarada.Velocity=0.0, -2500.0, 0.0
	llamarada.RandomVelocity=45.0
	llamarada.Time2Live=14
	llamaradalite=Bladex.CreateEntity(entity+"_IcyLite", "Entity Spot",x,y-1800,z)
	llamaradalite.Color=200, 200, 220
	llamaradalite.Intensity=2.0
	llamaradalite.Precission=0.55
	llamaradalite.Flick=0
	llamaradalite.Visible=0
	llamaradalite.CastShadows=0
	
	
def MakeIceFX(entityname):
	ent=Bladex.GetEntity(entityname)
	ent.Alpha=0.0
	Particles=Bladex.CreateEntity(entityname+"Particles", "Entity Particle System Dobj", 0, 0, 0)
	Particles.ObjectName=entityname
	Particles.ParticleType="Vaho"
	Particles.PPS=20
	Particles.Velocity=0.0, 0.0, 0.0
	Particles.NormalVelocity=0.0
	Particles.RandomVelocity=1.0
	Particles.YGravity=150
	Particles.Friction=0.02
	Particles.FollowFactor=0.0
	Particles.Time2Live=60
	
	
def IcyBlast():
	ps=Bladex.CreateEntity("IcyBlast", "Entity Particle System D1", 38802,2354,-54273)
	ps.ParticleType="IcyVapour"
	ps.YGravity=-3000.0
	ps.Friction=0.12
	ps.PPS=32
	ps.Velocity= -9000.0, -1500.0, 0.0
	ps.Time2Live=50
	ps.RandomVelocity=40
	ps.DeathTime = Bladex.GetTime() + 4.0
	

def PowerBallFX1(ballname):
	x,y,z=Bladex.GetEntity(ballname).Position
	ballps=Bladex.CreateEntity(ballname+"_CoolFX1","Entity Particle System D1",x,y,z)
	ballps.ParticleType="BladeSwordMissile"
	ballps.PPS=200 #400
	ballps.YGravity=0.0
	ballps.Friction=0.04
	ballps.RandomVelocity=-16.0
	ballps.FollowFactor=0.4
	ballps.Time2Live=20
	
	
def PowerBallFX2(ballname):
	ballaura= Bladex.CreateEntity(ballname+"_MagicAura","Entity Aura",pos[0],pos[1],pos[2])
	ballaura.SetAuraParams(10, 1, 1, 0, 0, 1)
	ballaura.SetAuraGradient(2, 0.9, 1.0, 1.0, 1.0, 0.1, 0.4, 0.8, 1.0, 0.9, 1.0)
	ballaura.SetAuraActive(1)
	ball=Bladex.GetEntity(ballname)
	ball.Link(ballaura)


def PowerBallFX3(ballname):
	ps3 = Bladex.CreateEntity(ballname+"CoolFX3", "Entity Particle System Dobj", 0,0,0)
	ps3.ObjectName=ballname
	ps3.ParticleType   = "EnergyDissip"    
	ps3.YGravity       = -600 
	ps3.Friction       = 1
	ps3.PPS            = 1024 
	ps3.Velocity       = 0,0,0 
	ps3.Time2Live      = 20 
	ps3.RandomVelocity = 20
	#ps3.DeathTime=Bladex.GetTime()+3.0


def PowerBallFX4(ballname):
	ps4=Bladex.CreateEntity(ballname+"Particles", "Entity Particle System Dobj", 0, 0, 0)
	ps4.ObjectName=ballname
	ps4.ParticleType="Vaho"
	ps4.PPS=100
	ps4.Velocity=0,0,0
	ps4.NormalVelocity=0.0
	ps4.RandomVelocity=1.0
	ps4.YGravity=150
	ps4.Friction=0.02
	ps4.FollowFactor=0.0
	ps4.Time2Live=60





InFreezer=0
breathnum=0

def Exhale (EntityName="Player1"):
	global breathnum
	global InFreezer
	if InFreezer:
		me = Bladex.GetEntity(EntityName)
		xtm = (3,6,10,)
		idx = whrandom.randint(0, len(xtm)-1)
		tvar = xtm[idx]
		interval=2.0+tvar
		if me.Life>0:
			end_time=Bladex.GetTime()+0.6
			node= me.GetNodeIndex("Head")
			x,y,z= me.GraspPos("ViewPoint")
			smoke=Bladex.CreateEntity(EntityName+"_Breath_"+str(breathnum),"Entity Particle System D1",x,y,z)
			smoke.ParticleType="Vaho"
			smoke.YGravity=-200    #   -1000.0
			smoke.Friction=0.12
			smoke.PPS=30
			smoke.DeathTime=end_time+1.0/60.0;
			vx,vy,vz=me.Rel2AbsVector(0,-1600,1000)
			smoke.Velocity=vx,vy,vz
			smoke.RandomVelocity=10.0
			me.LinkToNode(smoke,node)
			breathnum=breathnum+1
			Bladex.AddScheduledFunc(Bladex.GetTime()+interval,Exhale,(EntityName,))
			print EntityName+"_blowing smoke"
			me.Life=me.Life-3
		


def EnterFreezer(sector,entity):
	if entity=="Player1":
		global InFreezer
		if InFreezer==0:
			InFreezer=1
			Bladex.ExeMusicEvent(Bladex.GetMusicEvent("emptyloquesea"))
			Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, ChangeMusic,("IceCave",))
			Exhale()
			CierraFreezerDoor()
			char=Bladex.GetEntity("Player1")
			char.Data.RespawnPos=(171000, -8000, -70000)
			sectfreezer1inner.OnEnter=""
			sectfreezer1outer.OnEnter=LeaveFreezer
			
			
def LeaveFreezer(sector,entity):
	if entity=="Player1":
		global InFreezer
		if InFreezer==1:	
			InFreezer=0
			Bladex.ExeMusicEvent(Bladex.GetMusicEvent("emptyloquesea"))
			char=Bladex.GetEntity("Player1")
			char.Data.RespawnPos=(-4808, -1026, -5532)
			Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, ChangeMusic,("atm18",))
			sectfreezer1inner.OnEnter=EnterFreezer
			sectfreezer1outer.OnEnter=""


def LeaveFreezer2(sector,entity):
	if entity=="Player1":
		global InFreezer
		if InFreezer==1:	
			InFreezer=0
			Bladex.ExeMusicEvent(Bladex.GetMusicEvent("emptyloquesea"))
			Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, ChangeMusic,("atm4",))
			char=Bladex.GetEntity("Player1")
			char.Data.RespawnPos=(-4808, -1026, -5532)
			sectfreezer1inner.OnEnter=EnterFreezer
			sectfreezer1outer.OnEnter=""			
			

			
def ThawCrabs(sector,entity):
	per=Bladex.GetEntity(entity)
	if per.Kind=="Spidersmall":
		per.Life=0
	
	


Charging=0

def ChargeUp():
	global Charging
	if Charging==1:
		char=Bladex.GetEntity("Player1")
		char.Data.AddMagic(250)
		print "recharging"
		GetPowerFX()
		
		


def StartCharge(sector, entity):
	if entity!="Player1":
		return
	global Charging
	if Charging==0:
		Charging=1
	if not MasklinTypes.GotSwordPower(3):
		AddSwordPower(3)
		

def StopCharge(sector, entity):
	if entity!="Player1":
		return
	global Charging
	if Charging==1:
		Charging=0



### fast radiating blobs

def PowerBallFX1(ballname):
	x,y,z=Bladex.GetEntity(ballname).Position
	ballps=Bladex.CreateEntity(ballname+"_CoolFX1","Entity Particle System D1",x,y,z)
	ballps.ParticleType="BladeSwordMissile"
	ballps.PPS=200 
	ballps.YGravity=0.0
	ballps.Friction=0.04
	ballps.RandomVelocity=-16.0
	ballps.FollowFactor=0.4
	ballps.Time2Live=20
	
	
def PowerBallFX2(ballname):
	x,y,z=Bladex.GetEntity(ballname).Position
	ps2=Bladex.CreateEntity(ballname+"CoolFX2", "Entity Particle System D1", x, y, z)
	ps2.ParticleType="BlueMagicMissile"
	ps2.PPS=100
	ps2.YGravity=0.0
	ps2.Friction=0.04
	ps2.Velocity=0.0, 0.0, 0.0
	ps2.RandomVelocity=-5.0
	ps2.Time2Live=25


def PowerBallFX3(ballname):
	ps3 = Bladex.CreateEntity(ballname+"CoolFX3", "Entity Particle System Dobj", 0,0,0)
	ps3.ObjectName=ballname
	ps3.ParticleType   = "EnergyDissip"    
	ps3.YGravity       = -600 
	ps3.Friction       = 1
	ps3.PPS            = 1024 
	ps3.Velocity       = 0,0,0 
	ps3.Time2Live      = 20 
	ps3.RandomVelocity = 20
	#ps3.DeathTime=Bladex.GetTime()+3.0


def GiveMeLight(ObjectName, intens=2.0, r=240, g=128, b=28):
	obj=Bladex.GetEntity(ObjectName)
	obj.SelfIlum=-1
	x,y,z=obj.Position
	lite=Bladex.CreateEntity(ObjectName+"Luz", "Entity Spot",x,y,z)
	lite.Color=r, g, b
	lite.Intensity=intens
	lite.Precission=0.001
	lite.CastShadows=0
	lite.Flick=0
	lite.Visible=0

########################################################################################################################################################
#### Tomb

def MuereCaos(caosname):
	ck1 = Bladex.GetEntity(caosname)
	ck1.Data.PrepareDisappearance()
	ck1.Data.Disappear(caosname)
	AbreGate(tombgate1din)
	InitTombTrap()

def ParticulateAppears(PersonName = "Player1"):
	wps=Bladex.CreateEntity(PersonName+"WPS", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	wps.PersonName=PersonName
	wps.ParticleType="EnergyConc"
	wps.Time2Live=60
	wps.RandomVelocity=0
	wps.Velocity=0,0,0
	wps.NormalVelocity=-5.0
	wps.YGravity=0
	wps.DeathTime=Bladex.GetTime()+1.5	
	wps.PPS=600
	Bladex.GetEntity(PersonName).Alpha = 0.0
	PhantonFX.Delta = 0.015
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.0, PhantonFX.AppearsChar,(PersonName,))


def AppearsCK():
	ck1 = Bladex.GetEntity("ChaosKnight_1")
	lvl=Bladex.GetEntity("Player1").Level
	ck1.Level=lvl
	ck1.Life=CharStats.GetCharMaxLife(ck1.Kind,ck1.Level)
	CheckPlayerVisibility("ChaosKnight_1")
	darfuncs.UnhideBadGuy("ChaosKnight_1")
	Bladex.AddScheduledFunc(Bladex.GetTime()+15.0, darfuncs.UnhideBadGuy,("ChaosKnight_1",))
	ck1.Blind=1
	ck1.Deaf=1
	ck1.Alpha = 0.0
	ck1.Data.Appear()
	#ChaosAbreCam(chaosk1)
	ParticulateAppears("ChaosKnight_1")
	Actions.TurnToFaceEntityNow("ChaosKnight_1","Player1")
	


def InitTombTrap():
	rayS.Active=1
	rayN.Active=1
	rayS2.Active=1
	rayN2.Active=1
	sndrayo1.Play(91669,7936,86183,-1)
	
	
def MoveEstacas():
	Objects.DisplaceObject(est1din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(est2din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(est3din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(est4din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(est5din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "", "",(),RemoveBlock)


def RemoveBlock():
	block=Bladex.GetEntity("LapidaBarbaro_1586")
	block.Position=77707,10844,70511


########################################################################################################################################################
###### Aquire Sword Powerups



def HitGeoda(hit_entity, hitting_entity, xhit_point, yhit_point, zhit_point, ximpulse, yimpulse, zimpulse,wcx,wcy,wcz,wdx,wdy,wdz):
	obj=Bladex.GetEntity(hit_entity)
	if not obj:
		return	
	mod=B3DLib.Modulo(ximpulse, yimpulse, zimpulse)
	if mod<5000.0:
		return
	sparkdir=B3DLib.Normalize((-ximpulse, -yimpulse, -zimpulse))
	chispa=Bladex.CreateSpark("Chispa", xhit_point, yhit_point, zhit_point, sparkdir[0], sparkdir[1], sparkdir[2],0.5,3000,2000,0,100, 160, 120, 40, 30, 24, 0,800,10.0/60.0,1.0/60.0,1)
	obj.CatchOnFire(0,0,0)
	on_hit_info= Reference.MaterialOnHitInfo['Piedra']
	sound= on_hit_info[0]
	if sound:
		sound.Stop()
		sound.Play(xhit_point, yhit_point, zhit_point, 0)
		
	hitter=Bladex.GetEntity(hitting_entity)
	if hitter.Kind=="WizardSword":
		Bladex.AddScheduledFunc( Bladex.GetTime()+0.2,fCreateGolemBallRota,())
	
	

def fCreateGolemBallRota() :
	geodaTocha=Bladex.GetEntity("Geoda_1115")
	geodaTocha.HitFunc=None
	pos=geodaTocha.Position
	geodaTocha.SubscribeToList("Pin")
	geodaTocha.RemoveFromWorld()
	geodaTrozoA.Position = pos[0]-131.3	, pos[1]-60.9	,	pos[2]+701.6
	geodaTrozoB.Position = pos[0]-71.6	, pos[1]-517.3	,	pos[2]+51.4
	geodaTrozoC.Position = pos[0]+329.7	, pos[1]+88.3	,	pos[2]-83.4
	geodaTrozoD.Position = pos[0]-219.1	, pos[1]+253.4	,	pos[2]+362.2
	geodaTrozoE.Position = pos[0]-134.8	, pos[1]+64.8	,	pos[2]-686.6
	sndgeodeexplode3.Play(pos[0],pos[1],pos[2],0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.5, sndgeodeexplode1.Play,(pos[0],pos[1],pos[2],0,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.9, sndgeodeexplode2.Play,(pos[0],pos[1],pos[2],0,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.8, ExplodeGeoda,(pos,))

	
	
def ExplodeGeoda(pos):
	lite=Bladex.CreateEntity("GeodaLight", "Entity Spot",pos[0],pos[1],pos[2])
	lite.Color=25,19,13
   	lite.Intensity=10
   	lite.Precission=0.1
   	lite.CastShadows=0
   	lite.Visible=1
   	lite.Flick=1
  	lite.SizeFactor = 2.0
   	lite.AngVel=0.1
   	lite.GlowTexture="StarParticle"
	m=100   #250.0
	geodaTrozoA.Impulse( -131.3*m, -60.9 *m, +701.6*m )
	geodaTrozoB.Impulse( -71.6 *m, -517.3*m, +51.4 *m )
	geodaTrozoC.Impulse( +329.7*m, +88.3 *m, -83.4 *m )
	geodaTrozoD.Impulse( -219.1*m, +253.4*m, +362.2*m )
	geodaTrozoE.Impulse( -134.8*m, +64.8 *m, -686.6*m )
	geodaTrozoA.OnStopFunc=DestroyPiece
	geodaTrozoB.OnStopFunc=DestroyPiece
	geodaTrozoC.OnStopFunc=DestroyPiece
	geodaTrozoD.OnStopFunc=DestroyPiece
	geodaTrozoE.OnStopFunc=DestroyPiece
	char=Bladex.GetEntity("Player1")
	
	px,py,pz=char.GraspPos("R_Hand")
	ray= Bladex.CreateEntity("GeodaRay", "Entity ElectricBolt", pos[0],pos[1],pos[2])
	ray.Position= pos[0],pos[1],pos[2]
	ray.MaxAmplitude=1000.0
	#ray.MinSectorLength = 1000000
	ray.Target= px,py,pz
	ray.FixedTarget= 0
	ray.CoreGlowColor=255,196,128
	ray.InnerGlowColor=128,98,64
	ray.Active= 1
	ray.Damage=0
	
	flash = Bladex.CreateEntity("GeodaPS", "Entity Particle System Dobj", 0,0,0)
	flash.ObjectName=char.InvRight
	flash.ParticleType   = "FireEnergyDissip"
	flash.YGravity       = -600 
	flash.Friction       = 1
	flash.PPS            = 1024 
	flash.Velocity       = 0,0,0 
	flash.Time2Live      = 20 
	flash.RandomVelocity = 20
	flash.DeathTime=Bladex.GetTime()+6.0
	char.Wuea= Reference.WUEA_ENDED
	char.LaunchAnmType("hurt_f_big")
	AuxFuncs.SpotIntensityVariation(lite.Name,10.0,0.0,3.0,1)
	Bladex.AddScheduledFunc( Bladex.GetTime()+1.1,MakeSmoke,(pos,))
	Bladex.AddScheduledFunc( Bladex.GetTime()+1.0,ray.SubscribeToList,("Pin",))
	Bladex.AddScheduledFunc( Bladex.GetTime()+3.0,AddSwordPower,(1,))
	
	
def MakeSmoke(pos):
	Fuego=Bladex.CreateEntity("GeodaSmoke", "Entity Particle System D1", pos[0],pos[1]+200,pos[2])
	Fuego.ParticleType="DarkSmoke"
	Fuego.PPS=22
	Fuego.YGravity=0
	Fuego.Friction=0.0
	Fuego.Velocity=0,-1000,0
	Fuego.RandomVelocity=5.0
	Fuego.Time2Live=96
	Fuego.DeathTime=Bladex.GetTime()+8.5


def DestroyPiece(obj_name):
	pieza=Bladex.GetEntity(obj_name)
	x,y,z =  pieza.Position
	if pieza:
		Fuego=Bladex.CreateEntity(obj_name+"Smoken", "Entity Particle System D1", x,y,z)
		Fuego.ParticleType="DarkSmoke"
		Fuego.PPS=22
		Fuego.YGravity=0
		Fuego.Friction=0.0
		Fuego.Velocity=0,-500,0
		Fuego.RandomVelocity=5.0
		Fuego.Time2Live=96
		Fuego.DeathTime=Bladex.GetTime()+1.5
		RescalePiece(obj_name,pieza.Scale)


def RescalePiece(obj_name,Size):
	pieza = Bladex.GetEntity(obj_name)
	if Size<=0.01:
		pieza.SubscribeToList("Pin")
		return
	pieza.Scale = Size
	Bladex.AddScheduledFunc( Bladex.GetTime()+0.1, RescalePiece,(obj_name, Size-0.05) )
	
	
######## Ice Storm ###########################

def GiveIceCombo(ghostpointer,usefrom):
	char=Bladex.GetEntity("Player1")
	gp=Bladex.GetEntity(ghostpointer)
	if char.Kind=="Wizard_A":
		if MasklinTypes.IsHoldingSword():
			Actions.QuickTurnToFaceEntity("Player1","ColdFlamePointer")
			char.LaunchAnmType("fire3")
			char.AnmEndedFunc=GiveIceCombo2
			Bladex.AddScheduledFunc( Bladex.GetTime()+0.1,gp.SubscribeToList,("Pin",))
			
		else:
			Actions.ReportMsg("Take the Magic Sword in hand and try again")
		
	
def GiveIceCombo2(entity):
	char=Bladex.GetEntity("Player1")
	x,y,z=char.Position
	char.AnmEndedFunc=None
	flash = Bladex.CreateEntity("IceFlamePS", "Entity Particle System Dobj", 0,0,0)
	flash.ObjectName=char.InvRight
	flash.ParticleType   = "IceEnergyDissip"
	flash.YGravity       = -600 
	flash.Friction       = 1
	flash.PPS            = 1024 
	flash.Velocity       = 0,0,0 
	flash.Time2Live      = 20 
	flash.RandomVelocity = 20
	flash.DeathTime=Bladex.GetTime()+6.0
	sndgeodeexplode2.Play(x,y,z,0)
	Bladex.AddScheduledFunc( Bladex.GetTime()+3.0,AddSwordPower,(2,))
	
	
	
######### LightningRope #####################

StoneHit=0
	
def HitIceStone(hit_entity, hitting_entity, xhit_point, yhit_point, zhit_point, ximpulse, yimpulse, zimpulse,wcx,wcy,wcz,wdx,wdy,wdz):
	obj=Bladex.GetEntity(hit_entity)
	if not obj:
		return	
	mod=B3DLib.Modulo(ximpulse, yimpulse, zimpulse)
	if mod<5000.0:
		return
	sparkdir=B3DLib.Normalize((-ximpulse, -yimpulse, -zimpulse))
	chispa=Bladex.CreateSpark("Chispa", xhit_point, yhit_point, zhit_point, sparkdir[0], sparkdir[1], sparkdir[2],0.5,3000,2000,0,100, 160, 120, 40, 30, 24, 0,800,10.0/60.0,1.0/60.0,1)
	
	on_hit_info= Reference.MaterialOnHitInfo['Piedra']
	sound= on_hit_info[0]
	if sound:
		sound.Stop()
		sound.Play(xhit_point, yhit_point, zhit_point, 0)
	global StoneHit
	hitter=Bladex.GetEntity(hitting_entity)
	if hitter.Kind=="WizardSword":
		if StoneHit==0:
			StoneHit=1
			Bladex.AddScheduledFunc( Bladex.GetTime()+0.2, MeltStone,())
	
	
def MeltStone():
	rayS.Active=0
	rayN.Active=0
	rayS2.Active=0
	rayN2.Active=0
	sndrayo1.Stop()
	stone=Bladex.GetEntity("Piedra_Glm_ic_1577")
	stone.TimerFunc=DownScaleStone
	stone.SubscribeToList("Timer60")
	stone.SelfIlum=0.3
	Bladex.AddScheduledFunc( Bladex.GetTime()+0.5, LightningRopeComboFX,())
	Bladex.AddScheduledFunc( Bladex.GetTime()+3.2, AddSwordPower,(4,))
	global secttombexit
	secttombexit.OnEnter=OpenTombExitDoor
	
	
def OpenTombExitDoor(sector,entity):
	if entity=="Player1":
		tombexitdoor.OpenDoor()
		gol1=Bladex.GetEntity("Golem_stone_1673")
		lvl=Bladex.GetEntity("Player1").Level
		gol1.Level=lvl
		gol1.Life=CharStats.GetCharMaxLife(gol1.Kind,gol1.Level)
		gol1.UnFreeze()
		secttombexit.OnEnter=None

	

def DownScaleStone (obj_name, time):
	obj= Bladex.GetEntity(obj_name)
	obj.Scale=obj.Scale-0.002
	obj.Alpha=obj.Alpha-0.002 
	if obj.Scale<=0.0 or obj.Alpha<=0.0:
		obj.RemoveFromList("Timer60")
		obj.TimerFunc=""
		obj.RemoveFromWorld()
		obj.SubscribeToList("Pin")
	

def LightningRopeComboFX():
	char=Bladex.GetEntity("Player1")
	x,y,z=char.Position
	flash = Bladex.CreateEntity("StonePS", "Entity Particle System Dobj", 0,0,0)
	flash.ObjectName=char.InvRight
	flash.ParticleType   = "IceStoneEnergyDissip"
	flash.YGravity       = -600 
	flash.Friction       = 1
	flash.PPS            = 1024 
	flash.Velocity       = 0,0,0 
	flash.Time2Live      = 20 
	flash.RandomVelocity = 20
	flash.DeathTime=Bladex.GetTime()+6.0
	sndgeodeexplode2.Play(x,y,z,0)######
	
	
	
def AddSwordPower(pownum):
	char=Bladex.GetEntity("Player1")
	if pownum==1:
		MasklinTypes.AddSwordFIREcombo()
	elif pownum==2:
		MasklinTypes.AddSwordICEcombo()
	if pownum==3:
		MasklinTypes.AddSwordLIGHTcombo()
	elif pownum==4:
		MasklinTypes.AddSwordLIGHTNINGcombo()
	Scorer.SlideTBS(0)
	
########################################################################################################################################################
###### Aquire Spells

def RemoveBook(BookName):
	book=Bladex.GetEntity(BookName)
	char=Bladex.GetEntity("Player1")
	inv=char.GetInventory()
	inv.RemoveObject(BookName)
	inv.LinkRightHand("")
	book.SubscribeToList("Pin")
	


def DissapearBook(BookName):
	book=Bladex.GetEntity(BookName)
	flash = Bladex.CreateEntity("Flash1", "Entity Particle System Dobj", 0,0,0)
	flash.ObjectName=BookName
	flash.ParticleType   = "YellowEnergyDissip"
	flash.YGravity       = -600 
	flash.Friction       = 1
	flash.PPS            = 1024 
	flash.Velocity       = 0,0,0 
	flash.Time2Live      = 20 
	flash.RandomVelocity = 20
	flash.DeathTime=Bladex.GetTime()+2.0
	AuxFuncs.FadeObject(BookName,1.0,0.0,2.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.1,RemoveBook,(BookName,))


def AddSpell1():
	char=Bladex.GetEntity("Player1")
	char.Data.GetNewSpell(1)
	Ontake.DelOnTakeEvent("SpellBook1")
	DissapearBook("SpellBook1")
	
def AddSpell2():
	char=Bladex.GetEntity("Player1")
	char.Data.GetNewSpell(2)
	Ontake.DelOnTakeEvent("SpellBook2")
	DissapearBook("SpellBook2")

def AddSpell3():
	char=Bladex.GetEntity("Player1")
	char.Data.GetNewSpell(3)
	Ontake.DelOnTakeEvent("SpellBook3")
	DissapearBook("SpellBook3")
	
def AddSpell4():
	char=Bladex.GetEntity("Player1")
	char.Data.GetNewSpell(4)
	Ontake.DelOnTakeEvent("SpellBook4")
	DissapearBook("SpellBook4")
	
def AddSpell5():
	char=Bladex.GetEntity("Player1")
	char.Data.GetNewSpell(5)
	Ontake.DelOnTakeEvent("SpellBook5")
	DissapearBook("SpellBook5")

def AddSpell6():
	char=Bladex.GetEntity("Player1")
	char.Data.GetNewSpell(6)
	Ontake.DelOnTakeEvent("SpellBook6")
	DissapearBook("SpellBook6")

def AddSpell7():
	char=Bladex.GetEntity("Player1")
	char.Data.GetNewSpell(7)
	Ontake.DelOnTakeEvent("SpellBook7")
	DissapearBook("SpellBook7")
	print"Got spell book 7"

def AddSpell8():
	char=Bladex.GetEntity("Player1")
	char.Data.GetNewSpell(8)
	Ontake.DelOnTakeEvent("SpellBook8")
	DissapearBook("SpellBook8")

def AddSpell9():
	char=Bladex.GetEntity("Player1")
	char.Data.GetNewSpell(9)
	Ontake.DelOnTakeEvent("SpellBook9")
	DissapearBook("SpellBook9")


#########################################################################################################################################################
############# Doors


def DropStoneDust(x,y,z,Death=3.0):
	tierra1=Bladex.CreateEntity("Cristales", "Entity Particle System D1", x, y, z)
	tierra1.ParticleType="StoneDust"
	tierra1.PPS=64
	tierra1.YGravity=9800.0
	tierra1.Friction=0.1
	tierra1.Velocity=0, 6000,0
	tierra1.RandomVelocity=10.0
	tierra1.Time2Live=64
	tierra1.DeathTime=Bladex.GetTime()+Death	
	return tierra1


elevbarrier=1
elevatorstate=0     # down


def ElevatorIsUp():
	global elevatorstate
	
	elevatorstate=1
	Bladex.AddScheduledFunc(Bladex.GetTime()+8.0,DownElevator,())
	print "Elev is up"

def ElevatorIsDown():
	global elevatorstate
	elevatorstate=0
	print "Elev is down"


def UpElevator():
	global elevatorstate
	global elevbarrier 
	if elevatorstate==0:
		elevador.CloseDoor()
		print "Going up"
	else:
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,DownElevator,())
	if elevbarrier==1:
		barr=Bladex.GetEntity("CliffBackRoomBarrier")
		barr.Position=40446,50000,50903
		barr2=Bladex.GetEntity("CliffBackRoomBarrier2")
		barr2.Position=40446,50000,50903
		elevbarrier=0


def DownElevator():
	global elevatorstate
	if elevatorstate==1:
		elevador.OpenDoor()
		print "Going down"
		
		

def OpenBedroomDoor():
	bedroomdoor.OpenDoor()

def CloseBedroomDoor():
	bedroomdoor.CloseDoor()
	
	
Tknatt=0

def OpenFrontDoor():
	frontdoor.OpenDoor()
	global Tknatt
	if Tknatt==0:
		StartTraitorKnightAttack()
		Tknatt=1
		
		
def CloseFrontDoor():
	frontdoor.CloseDoor()


def OpenBathRoomDoor():
	bathroomdoor.OpenDoor()
	StartSkelAttack()

def CloseBathRoomDoor():
	bathroomdoor.CloseDoor()
	
	
CellarDoorOpen=0
	
def AbreCellarDoor():
	global CellarDoorOpen
	if CellarDoorOpen==0:
		cellardoor.OpenDoor()
		Bladex.AddScheduledFunc(Bladex.GetTime() + 1.0,RemoveKey,("CellarKey",))
		CellarDoorOpen=1



def OpenCavernDoor():
	caverndoor.OpenDoor()

def CloseCavernDoor():
	caverndoor.CloseDoor()
	

def OpenTombDoor(sector, entity):
	if entity=="Player1":
		tombdoor.OpenDoor()
		Bladex.AddScheduledFunc(Bladex.GetTime() + 5.0, AppearsCK,())
		Bladex.AddScheduledFunc(Bladex.GetTime() + 12.0,MoveEstacas,())
		secttombdoor.OnEnter=""




def CloseTombDoor():
	tombdoor.CloseDoor()



def AbreWashHouseDoor():
	washhousedoor.OpenDoor()



FreezerDoorOpen=0

def AbreFreezerDoor():
	Bladex.AddScheduledFunc(Bladex.GetTime() + 1.2,freezerdoor.OpenDoor,())
	Bladex.AddScheduledFunc(Bladex.GetTime() +1.5,IcyBlast,())

def CierraFreezerDoor():
	global FreezerDoorOpen
	if FreezerDoorOpen==1:
		freezerdoor.CloseDoor()
		FreezerDoorOpen=0
	else:
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,CierraFreezerDoor,())
		


def CheckFreezerDoor():
	global FreezerDoorOpen
	FreezerDoorOpen=1
	
	

def AbreGate(gate,d1=1800,d2=600):
        desplazamientos=(d1, d2)
       	vectores=((0.0, -1.0, 0.0), (0.0, -1.0, 0.0))
       	vel_iniciales=(500.0, 2000)
        vel_finales=(2000.0, 500)
        son_durante=(deslizrasanexo, deslizrasanexo)
        son_finales=("", golperasanexo)
        Objects.NDisplaceObject(gate, desplazamientos, vectores, vel_iniciales, vel_finales, (), son_durante, son_finales)
        if gate==towergatedin:
        	Bladex.AddScheduledFunc(Bladex.GetTime() + 1.0,RemoveKey,("TowerKey",))
        	barr=Bladex.GetEntity("TowerGateBarrier")
        	barr.Position=49803,40000,6433
        	
        	
        	
def CierraGate(gate,d1=1800,d2=600):
        desplazamientos=(d1, d2)
       	vectores=((0.0, 1.0, 0.0), (0.0, 1.0, 0.0))
       	vel_iniciales=(500.0, 2000)
        vel_finales=(2000.0, 500)
        son_durante=(deslizrasanexo, deslizrasanexo)
        son_finales=("", golperasanexo)
        Objects.NDisplaceObject(gate, desplazamientos, vectores, vel_iniciales, vel_finales, (), son_durante, son_finales)
	

# Ring the doorbell to tidy the place up
	
def RingDoorbell(gp,usefrom):
	char=Bladex.GetEntity("Player1")
	Actions.QuickTurnToFaceEntity("Player1","DoorbellPointer")
	char.LaunchAnmType("fire2")
	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.6,dingdong1.Play,(20166,5370,-16520,0,))
	CleanUp()
	


	
BridgeClosed=0


def GolpeFinCaveGridge():
	polvareda=Bladex.CreateEntity("PolvoGolpePuente", "Entity Particle System D2", 61000, 8000, 77000)
	polvareda.D=0.0, 0.0, 2500.0
	polvareda.ParticleType="StoneDust"
	polvareda.YGravity=0.0
	polvareda.Friction=0.2
	polvareda.PPS=900
	polvareda.DeathTime=Bladex.GetTime()+3.0/60.0
	polvareda.Velocity=0.0, -750.0, 0.0
	polvareda.RandomVelocity=40.0
	
	
	
	
def CloseCaveBridge(stick,sticker,x,y,z,xc,yc,zc,wcx,wcy,wcz,wdx,wdy,wdz):
	global BridgeClosed
	if BridgeClosed==0:
		blocN=Bladex.GetEntity("CaveBridgeBlockN")
		blocS=Bladex.GetEntity("CaveBridgeBlockS")
		Objects.DisplaceObject(blocNdin, 600.0, (0.0, 1.0, 0.0), 300.0, 300.0,  "", "", "", "",(),CloseCaveBridge2)
		Objects.DisplaceObject(blocSdin, 600.0, (0.0, 1.0, 0.0), 300.0, 300.0,"", sdoor2d, golpebloque)
		blocN.HitFunc = None
		blocS.HitFunc = None
	
	
def CloseCaveBridge2():
	Bladex.AddScheduledFunc(Bladex.GetTime() + 0.6,cavernbridge.CloseDoor,())
	

def AbreBridgeDoor1():
	bridgedoor1.OpenDoor()
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.3,DropStoneDust,(19000,5000,52250,10.0,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,DropStoneDust,(24000,5000,52250,11.0,))
	
	

OracleActive=1

def SetOracleVar():
	global OracleActive
	OracleActive=1


def DoNowt(gp, usefrom):
	pass


def HaveIGotEnough():
	char=Bladex.GetEntity("Player1")
	spells=char.Data.SpellBook
	swdpows=char.Data.SwordPowers
	if len(swdpows)>=4 and len(spells)>=9:
		return 1
	return 0


def AmIWorthy(gp, usefrom):
	char=Bladex.GetEntity("Player1")
	global OracleActive
	if OracleActive:
		OracleActive=0
		FadeFace()
		Bladex.KillMusic()
		Bladex.ExeMusicEvent(Bladex.GetMusicEvent("coro5"))
		Bladex.AddScheduledFunc(Bladex.GetTime() + 15.4,ResumeMusic,())
		if HaveIGotEnough():
			Bladex.AddScheduledFunc(Bladex.GetTime() + 1.4, WriteCaptionT5,("You have gained sufficent power\n Procede to the shrine.",120,))
			OpenExitEstacas()
			p=Bladex.GetEntity(gp)
			p.UseFunc=DoNowt
		else:
			Bladex.AddScheduledFunc(Bladex.GetTime() + 1.4, WriteCaptionT5,("You must gain more power before you can go further",120,))
		
		
		
		
def FadeFace():
	AuxFuncs.FadeObject("WizFace", 0.0, 1.0, 2.0)
	Bladex.AddScheduledFunc(Bladex.GetTime() + 8.0,AuxFuncs.FadeObject,("WizFace", 1.0, 0.0, 3.0,))
	Bladex.AddScheduledFunc(Bladex.GetTime() + 10.1,SetOracleVar,())
	
		
def OpenExitEstacas():
	Objects.DisplaceObject(exitestaca1din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(exitestaca2din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(exitestaca3din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(exitestaca4din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(exitestaca5din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(exitestaca6din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(exitestaca7din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	Objects.DisplaceObject(exitestaca8din, 4200.0, (0.0, 1.0, 0.0), 600.0, 600.0, "", "", "")
	block1=Bladex.GetEntity("ExitBarrier1")
	block2=Bladex.GetEntity("ExitBarrier2")
	block1.Position=168906,25464,-14600
	block2.Position=168906,25464,-6000
	
	
	
def RemoveKey(keyname):
	char=Bladex.GetEntity("Player1")
	inv=char.GetInventory()
	inv.RemoveKey(keyname)

#########################################################################################################################################################

def CreateCascada(Cascada,p,d,v,Time = 15,Grav = 13000,PPS = 500):
	cascada=Bladex.CreateEntity(Cascada, "Entity Particle System D2",p[0],p[1],p[2])
	cascada.D=d[0],d[1],d[2]
	cascada.ParticleType="AguaC"
	cascada.Friction=0.07
	cascada.RandomVelocity=10.0
	cascada.Velocity=v[0],v[1],v[2]
	cascada.PPS=PPS
	cascada.YGravity=Grav
	cascada.Time2Live=Time
	
	
def CreateCascada2(Cascada,p,d,v,Time = 16,Grav = 13000,PPS = 600):
	cascada=Bladex.CreateEntity(Cascada, "Entity Particle System D2",p[0],p[1],p[2])
	cascada.D=d[0],d[1],d[2]
	cascada.ParticleType="AguaC2"
	cascada.Friction=0.07
	cascada.RandomVelocity=10.0
	cascada.Velocity=v[0],v[1],v[2]
	cascada.PPS=PPS
	cascada.YGravity=Grav
	cascada.Time2Live=Time
	
	
def CreateCascada3(Cascada,p,d,v,Time = 15,Grav = 13000,PPS = 500):
	cascada=Bladex.CreateEntity(Cascada, "Entity Particle System D2",p[0],p[1],p[2])
	cascada.D=d[0],d[1],d[2]
	cascada.ParticleType="AguaC3"
	cascada.Friction=0.07
	cascada.RandomVelocity=10.0
	cascada.Velocity=v[0],v[1],v[2]
	cascada.PPS=PPS
	cascada.YGravity=Grav
	cascada.Time2Live=Time
	
	
def CreateSalpique(Salpique,p,v,):
	salpique=Bladex.CreateEntity(Salpique, "Entity Particle System D1", p[0],p[1],p[2])
	salpique.Velocity=v[0],v[1],v[2]
	salpique.ParticleType="Salpique"
	salpique.PPS=128
	salpique.YGravity=4900.0
	salpique.Friction=0.07
	salpique.RandomVelocity=20.0
	salpique.Time2Live=30
	
	
# Magic Well

AnointingWP=0

def GiveWeaponBlessing(ghostpointer, use_from):
	char=Bladex.GetEntity("Player1")
	global AnointingWP
	if AnointingWP:
		return
	gpr=Bladex.GetEntity(ghostpointer)
	if char.Kind=="Wizard_A":
		rwp=Bladex.GetEntity(char.InvRight)
		if rwp:
			if rwp.Kind in ("ProStaff1","WizardSword"):
				if rwp.Data.Anointed:
					Actions.ReportMsg("This Weapon has already been Anointed")
					return
				Actions.QuickTurnToFaceEntity("Player1","MagicWellPointer")
				char.LaunchAnmType("fire_g")
				AnointingWP=1
				char.AnmEndedFunc=GiveWeaponBlessing2
			else:
				Actions.ReportMsg("This Weapon is not worthy")
		else:
			Actions.ReportMsg("Take your Weapon in hand and try again")
	
	
def GiveWeaponBlessing2(entity):
	char=Bladex.GetEntity("Player1")
	global AnointingWP
	rwp=Bladex.GetEntity(char.InvRight)
	if rwp:
		try:
			rwp.Data.Anointed=1
		except:
			pass
		print "Magic weapon anointed"
		WeaponTwinkle(rwp.Name)
		AnointingWP=0
		sndluz.Play(138599,14449,27805,0)



def WeaponTwinkle(ObjName):
	wps=Bladex.CreateEntity(ObjName+"TwinkleStars", "Entity Particle System Dobj", 0.0, 0.0, 0.0)
	wps.ObjectName=ObjName
	wps.ParticleType="LucesCools"
	wps.Time2Live=16
	wps.RandomVelocity=0
	wps.Velocity=0,0,0
	wps.NormalVelocity=2
	wps.YGravity=0
	wps.PPS=9
	Bladex.GetEntity(ObjName).SelfIlum = -1
	Bladex.AddScheduledFunc(Bladex.GetTime()+7.0, WeaponDeTwinkle,(ObjName,))

def WeaponDeTwinkle(ObjName):
	wps=Bladex.GetEntity(ObjName+"TwinkleStars")
	if wps:
		wps.DeathTime=Bladex.GetTime()
		Bladex.GetEntity(ObjName).SelfIlum = 0
		
		
def SetWellExclusionZoneTrigger(name):
	Bladex.SetTriggerSectorFunc(name, "OnEnter", KeepAway)
	
	
	
def KeepAway(sctor, entity):
	if entity=="Player1":
		print "Entering well area"
		return

	intruder=Bladex.GetEntity(entity)
	if intruder.Person:
		if intruder.Life>0:
			per.LaunchAnmType("hurt_f_big")
			print "Yoooooweeee"


	
#########################################################################################################################################################
#### Magic Rings

Ringsact=0

def StopRings(sector,entity):
	if entity=="Player1":
		global Ringsact
		if Ringsact==1:
			ring1=Bladex.GetEntity("AnilloFoso1")
			ring1.RemoveFromList("Timer15")
			ring1.TimerFunc=""
			Ringsact=0
		
		

def MoveRing1(ent_name, time):
	r1=Bladex.GetEntity("AnilloFoso1")
	ht=r1.Position[1]
	xpos=r1.Position[0]
	ypos=r1.Position[2]
	if ht>-20000:
		r1.Position=xpos,ht-100,ypos
	else:
		r1.Position=xpos,30000,ypos
		ChargeUp()


def MoveRing2(ent_name, time):
	r2=Bladex.GetEntity("AnilloFoso2")
	ht=r2.Position[1]
	xpos=r2.Position[0]
	ypos=r2.Position[2]
	if ht>-20000:
		r2.Position=xpos,ht-100,ypos
	else:
		r2.Position=xpos,30000,ypos
		ChargeUp()
		
		
def MoveRing3(ent_name, time):
	r3=Bladex.GetEntity("AnilloFoso3")
	ht=r3.Position[1]
	xpos=r3.Position[0]
	ypos=r3.Position[2]
	if ht>-20000:
		r3.Position=xpos,ht-100,ypos
	else:
		r3.Position=xpos,30000,ypos
		ChargeUp()
		
	
def MoveRing4(ent_name, time):
	r4=Bladex.GetEntity("AnilloFoso4")
	ht=r4.Position[1]
	xpos=r4.Position[0]
	ypos=r4.Position[2]
	if ht>-20000:
		r4.Position=xpos,ht-100,ypos
	else:
		r4.Position=xpos,30000,ypos
		ChargeUp()
		
		
	
def MoveRing5(ent_name, time):
	r5=Bladex.GetEntity("AnilloFoso5")
	ht=r5.Position[1]
	xpos=r5.Position[0]
	ypos=r5.Position[2]
	if ht>-20000:
		r5.Position=xpos,ht-100,ypos
	else:
		r5.Position=xpos,30000,ypos
		ChargeUp()



def StartRings(sector,entity):
	if entity=="Player1":
		global Ringsact
		if Ringsact==0:
			ring1=Bladex.GetEntity("AnilloFoso1")
			ring1.SubscribeToList("Timer15")	
			ring1.TimerFunc=MoveRing1
			ring2=Bladex.GetEntity("AnilloFoso2")
			ring2.SubscribeToList("Timer15")	
			ring2.TimerFunc=MoveRing2
			ring3=Bladex.GetEntity("AnilloFoso3")
			ring3.SubscribeToList("Timer15")	
			ring3.TimerFunc=MoveRing3
			ring4=Bladex.GetEntity("AnilloFoso4")
			ring4.SubscribeToList("Timer15")	
			ring4.TimerFunc=MoveRing4
			ring5=Bladex.GetEntity("AnilloFoso5")
			ring5.SubscribeToList("Timer15")	
			ring5.TimerFunc=MoveRing5
			Ringsact=1


def MakeRingPS(RingName):
	ring=Bladex.GetEntity(RingName)
	ring.CastShadows=0
	ring.Alpha=0.0
	ps=Bladex.CreateEntity(RingName+"PS", "Entity Particle System Dobj", 0.0, 0.0, 0.0)
	ps.ObjectName=RingName
	ps.ParticleType="EnergyDissip"   #"EnergyRingAzul"
	ps.PPS=100
	ps.YGravity=-50.0
	ps.Friction=0.0
	ps.Velocity=0.0, 0.0, 0.0
	ps.RandomVelocity=1.0
	ps.NormalVelocity=0.0
	ps.Time2Live=60



#########################################################################################################################################################
##### Crows

crownum=0

def CreateCrow(pos,fps,orient):
	global crownum
	cuervovolando1=Bladex.CreateEntity("CuervoVolando"+str(crownum), "Crw",pos[0],pos[1],pos[2])
	cuervovolando1.Orientation=orient
	cuervovolando1.CastShadows=0
	cuervovolando1.Actor=1
	cuervovolando1.Animation="Crw_act11"
	cuervovolando1.FPS=fps
	cuervovolando1.SendSectorMsgs=0
	cuervovolando1.TurnOn()
	crownum=crownum+1
	print "Crow made"

def CreatePerchingCrow(entity,fps,pos,orient):
	crow=Bladex.GetEntity(entity)
	crow.Position=pos           
	crow.Orientation=orient                                   
	crow.Actor=1
	crow.Animation="Crw_pic"
	crow.FPS=fps
	crow.SendSectorMsgs=0
	crow.TurnOn()
	
	
#########################################################################################################################################################
################## Music


Currentmusic=""
		
def ChangeMusic(music):
	Bladex.KillMusic()
	Bladex.ExeMusicEvent(Bladex.GetMusicEvent(music))
	global Currentmusic
	Currentmusic=music
	print"Changing Music...."
	
	
def ResumeMusic():
	global Currentmusic
	Bladex.KillMusic()
	if Currentmusic!="":
		Bladex.ExeMusicEvent(Bladex.GetMusicEvent(Currentmusic))

  
def ResetMusic(sector, entity):
	if entity=="Player1":
		global Currentmusic
		if Currentmusic!="atm18":
			global InFreezer
			if InFreezer:
				Currentmusic="IceCave"
			else:
				Currentmusic="atm18"
			Bladex.ExeMusicEvent(Bladex.GetMusicEvent(Currentmusic))



def ChangeToDarkMusic(sector, entity):
	if entity=="Player1":
		global Currentmusic
		print "Dark"
		if Currentmusic=="atm18":
			print "Ch2DarkMusic"
			Bladex.ExeMusicEvent(Bladex.GetMusicEvent("emptyloquesea"))
			Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, ChangeMusic,("atm4",))
		
			
			
def ChangeToLightMusic(sector, entity):
	if entity=="Player1":
		global Currentmusic
		print "Light"
		if Currentmusic=="atm4":
			print "Ch2LightMusic"
			Bladex.ExeMusicEvent(Bladex.GetMusicEvent("emptyloquesea"))
			Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, ChangeMusic,("atm18",))
		
			
def ResetMusicOnRespawn():
	global Currentmusic
	if Currentmusic!="atm18":
		Bladex.KillMusic()
		global InFreezer
		if InFreezer:
			Bladex.AddScheduledFunc(Bladex.GetTime()+20.0, ChangeMusic,("IceCave",))
		else:
			Bladex.AddScheduledFunc(Bladex.GetTime()+20.0, ChangeMusic,("atm18",))



def SetMusicRestore():
	char=Bladex.GetEntity("Player1")
	pjdata=char.Data
	if pjdata:
		char.Data.DeathFunc=ResetMusicOnRespawn
	
Bladex.AddScheduledFunc(Bladex.GetTime()+3.0,SetMusicRestore,())
	
	
##########################################################################################################################################################
####### Enemy Generator


def CheckPlayerVisibility(entity):
	per=Bladex.GetEntity(entity)
	char=Bladex.GetEntity("Player1")
	if char.Data.Invisible:
		per.SeeFunc=MasklinTypes.SeeAllExceptPlayer
	
	
def HideMe(entity):
	per=Bladex.GetEntity(entity)
	per.Alpha=0.0
	darfuncs.HideBadGuy(entity)
	
def UnhideMe(entity):
	per=Bladex.GetEntity(entity)
	per.Alpha=1.0
	darfuncs.UnhideBadGuy(entity)
	
"""
def CheckUnhideSkelArchers(sector, entity):
	if entity=="Player1":
		lvl=Bladex.GetEntity("Player1").Level+1
		if lvl>=5:
			UnhideMe("SkeletonArcher1")
			UnhideMe("SkeletonArcher2")
			sectsklarc.OnEnter=None
"""


Enemynum=0


Shieldholders=["Knight_Traitor","Ork","Great_Ork","Ragnar","Skeleton"]


Spawnpos={}
Spawnpos["Default"]=[(51111.6756607, -1102.07162089, 748.624188506),
	  	 (43480.2960265, -1086.05434343, 7277.26162287),
	         (19324.9372829, -1102.98428528, -30491.2700373),
	         (24434.812982, -1092.21234939, -30830.3080756),
	         (55810.1034369, 6005.50292876, -350.012528948),
	         (67664.5838419, 5896.46694968, 10426.1075031),
	         (66213.3269656, 5904.02760159, 6010.96178789),
	         (-5655.05104003, 7898.26610514, -16980.5653072),
	         (-15628.4789228, 8537.2224337, -22056.2287424),
	         (-15609.5918154, 8993.35361541, -8147.3394585),
	         (-16354.6694244, 9861.03601674, -3738.25323379),
	         (14634.8292923, 5904.49670337, -19907.3187676),
	  	 (28833.8997192, 5885.87891657, -18837.7444949)]
Spawnpos["Knight_Traitor"]=[(51111, -1102, 748),
	         (43480, -1086, 7277),
	         (19324, -1102, -30491),
	         (24434, -1092, -30830),
	         (55810, 6005, -350),
	         (67664, 5896, 10426),
	         (66213, 5904, 6010),
	         (-5655, 7898, -16980),
	         (-15628, 8537, -22056),
	         (-15609, 8993, -8147),
	         (-16354, 9861, -3738),
	         (14634, 5904, -19907),
	  	 (28833, 5885, -18837),
	  	 (37129,-999,-746),
		 (39960,-1003,6566),
		 (35801,-1001,6357),
		 (47799,-993,1091),
                 (21302,-1015,-24175),
		 (22050,-1013,-30641),
	         (21728,-814,-37410),]
Spawnpos["Minotaur"]=[(67816.5849283, 5844.73737891, 6676.62805663),
	   	 (67707.5037406, 5813.83963775, 9761.98418174),
	  	 (72506.7924343, 5848.97542847, 16111.2026617),
	  	 (72326.7837409, 5952.2301544, 7090.74649828),
	  	 (70566.299198, 5944.73736511, 10418.9127765)]
Spawnpos["Ork"]=[(-78182.7800051, 16973.7880511, 52873.438158),
                 (-86506.6833886, 18969.9437619, 49365.1651623),
                 (-96217.7869121, 20473.2874173, 54307.8979068),
                 (-82085.2027851, 17738.204257, 51831.9421349),
                 (-78628.7410881, 16982.2920439, 68896.8162559),
                 (-68946.5703215, 16972.110311, 74804.6399109),
                 (-74221.4436272, 14404.949518, 91698.8591596),
                 (-76830.0398352, 14075.7058401, 98043.3558114),
                 (-79698.8474452, 15000.2402372, 106329.626096),
                 (-79698.8474452, 15000.2402372, 106329.626096),
                 (-77105.3161375, 14448.1730139, 110043.942952),
                 (-77307.7652202, 14500.2983252, 99132.8819192),
                 (-71614.0879636, 16982.4768547, 79517.8368497)]
Spawnpos["Great_Ork"]=[(-77924.4893197, 16944.7373645, 69055.1729529),
                 (-71019.501538, 16943.2759172, 78706.9655886),
                 (-77091.615561, 14119.8430774, 111386.136877),
                 (-68245.2151121, 16951.8349716, 74631.1359983),
                 (-77772.99043, 16955.8771819, 51538.3708059)]
Spawnpos["Ragnar"]=[(-2250, 8000, -20000),
                 (35000, -1100, 0),
                 (-15628, 8537, -22056),
	         (-15609, 8993, -8147),
                 (20571, -1038, -30449)]
Spawnpos["Skeleton"]=[(11186.3024216, -1726.54922966, 9517.15478075),
                      (11115.9712045, -733.713557504, 3918.5671204),
                      (16236.5695902, -930.711701872, 515.967894877),
                      (25533.5564475, -938.246494795, -8236.75195214),
                      (6705.56179561, -926.54921652, -3674.80786303)]


Weps={}  
Weps["Knight_Traitor"]=["Gladius","Maza","Hacha5","Espadaromana","Orksword","Orksword","Espadaelfica","Maza2","QueenSword","HookSword","Espadacurva","EgyptSword","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
Weps["Minotaur"]=      ["Garrote","Garrote","Maza","Maza","Garropin","Garropin","Martillo","Martillo","Martillo2","Hachacarnicero","Hachacarnicero","Hachacarnicero","Hachacarnicero","Mazapiedra","Mazapiedra","Mazapiedra","Mazapiedra","Mazapiedra","Martillo3","Martillo3"]
Weps["Ork"]=           ["Gladius","Maza","Hacha3","Espadaromana","Garropin","Orksword","Espadaelfica","Maza2","QueenSword","HookSword","Espadacurva","EgyptSword","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
Weps["Great_Ork"]=     ["Gladius","Maza","Maza","Espadaromana","Garropin","Hacha4","Espadaelfica","Maza2","QueenSword","HookSword","Espadacurva","EgyptSword","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]
Weps["Ragnar"]=        ["ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword","ProWolfSword"]
Weps["Skeleton"]=      ["Gladius","Maza","Hacha3","Espadaromana","Garropin","Orksword","Espadaelfica","Maza2","QueenSword","HookSword","Espadacurva","EgyptSword","Dagesse","Cimitarra","Katana","Maza3","DoubleSword","DoubleSword","Espadafilo","Espada"]



Shields=["Escudo5","Escudo5","Escudo2","Escudo2","Escudo1","Escudo1","Escudo1","KingShield","KingShield","KingShield","Escudo8","Escudo8","Escudo9","Escudo9","Escudo3","Escudo4","Escudo4","Escudo7","Escudo6","Escudo6"]



WolfSwordDamage=[5, 8, 12, 18, 25, 35, 45, 60, 75, 95, 120, 145, 175, 200, 220, 250, 300, 380, 500, 750]
WolfSwordDef=   [0, -3, -5, -10, -15, -20, -25, -30, -35, -40, -45, -50, -55, -60, -65, -70, -75, -80, -85,-90]




def GetWeaponType(type,lvl):
	global Weps   
	if Weps.has_key(type):
		wps=Weps[type]
		if lvl<=19:
			WPTYPE=wps[lvl]
		else:
			WPTYPE=wps[19]
  	else:
  		WPTYPE="Cazo"
	return WPTYPE


def GetShieldType(lvl):
	global Shields
	if lvl>19:
		SHTYPE=Shields[19]
	else:
		SHTYPE=Shields[lvl]
	return SHTYPE
	
	
	
	
def CallMyReplacement(PersonKind):
	char=Bladex.GetEntity("Player1")
	lvl=char.Level
	rep=""
	if PersonKind=="Enano1":
		rep=Bladex.GetEntity("Tukaram")
		rep.Level=lvl+1
		WizardAllyTypes.AllyBarbarianLevelUpFunc("Tukaram")
		rep.Data.ResetCombat("Tukaram")
		char.Data.AllyList.append("Tukaram")
		rep.Life=CharStats.GetCharMaxLife(rep.Kind,rep.Level)
		BuddyDead("Ernie")
	elif PersonKind=="Barbarian_N":
		rep=Bladex.GetEntity("Zoe")
		rep.Level=lvl+1
		WizardAllyTypes.AllyAmazonLevelUpFunc("Zoe")
		rep.Data.ResetCombat("Zoe")
		char.Data.AllyList.append("Zoe")
		rep.Life=CharStats.GetCharMaxLife(rep.Kind,rep.Level)
		BuddyDead("Tukaram")
	elif PersonKind=="Amazon_N":
		rep=Bladex.GetEntity("Sargon")
		rep.Level=lvl+1
		WizardAllyTypes.AllyKnightLevelUpFunc("Sargon")
		char.Data.AllyList.append("Sargon")
		rep.Life=CharStats.GetCharMaxLife(rep.Kind,rep.Level)
		BuddyDead("Zoe")
	elif PersonKind=="Knight_N":
		rep=Bladex.GetEntity("Naglfar")
		rep.Level=lvl+1
		WizardAllyTypes.AllyDwarfLevelUpFunc("Naglfar")
		char.Data.AllyList.append("Naglfar")
		rep.Life=CharStats.GetCharMaxLife(rep.Kind,rep.Level)
		BuddyDead("Sargon")
	elif PersonKind=="Dwarf_N":
		BuddyDead("Naglfar")
		rep=""
	else:
		rep=""
	if rep != "":
		Bladex.AddScheduledFunc(Bladex.GetTime()+28.0,BuddyComingToHelp,(rep.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+30.0,PlaceAlly,(rep.Name,))
		
	
	
def AssignData(entity):
	newenemy=Bladex.GetEntity(entity)
	if newenemy.Kind=="Ork" or newenemy.Kind=="Great_Ork":
		newenemy.Data=EnemyCharTypes.EnemyOrk(newenemy)
	elif newenemy.Kind=="Minotaur":
		newenemy.Data=EnemyCharTypes.EnemyMinotaur(newenemy)
	elif newenemy.Kind=="Knight_Traitor" or newenemy.Kind=="Dark_Knight":
		newenemy.Data=EnemyCharTypes.EnemyTraitorKnight(newenemy)
	elif newenemy.Kind=="Ragnar":
		newenemy.Data=EnemyCharTypes.EnemyRagnar(newenemy)
	elif newenemy.Kind=="Skeleton":
		newenemy.Data=EnemyCharTypes.EnemySkeleton(newenemy)
	else:
		print"No Data Available for new enemy"
		
		
def StartOrkAttack(sector,entity):
	if entity !="Player1":
		return
	CheckPlayerVisibility("StartOrk1")
	CheckPlayerVisibility("StartOrk2")
	CheckPlayerVisibility("StartOrk3")
	CheckPlayerVisibility("StartOrk4")
	darfuncs.UnhideBadGuy("StartOrk1")
	darfuncs.UnhideBadGuy("StartOrk2")
	darfuncs.UnhideBadGuy("StartOrk3")
	darfuncs.UnhideBadGuy("StartOrk4")
	PlaceEnemy("StartOrk1")
	PlaceEnemy("StartOrk2")
	PlaceEnemy("StartOrk3")
	PlaceEnemy("StartOrk4")
	sectork.OnEnter=None
		
		
		
def StartRagnarAttack(sector, entity):
	if entity=="Player1":
		CheckPlayerVisibility("StartRagnar1")
		darfuncs.UnhideBadGuy("StartRagnar1")
		PlaceEnemy("StartRagnar1")
		sectragnar.OnEnter=None
		
		
def StartTraitorKnightAttack():
	CheckPlayerVisibility("StartKnight3")
	CheckPlayerVisibility("StartKnight2")
	CheckPlayerVisibility("StartKnight1")
	darfuncs.UnhideBadGuy("StartKnight1")
	darfuncs.UnhideBadGuy("StartKnight2")
	darfuncs.UnhideBadGuy("StartKnight3")
	PlaceEnemy("StartKnight1")
	PlaceEnemy("StartKnight2")
	PlaceEnemy("StartKnight3")
		
		
		
def StartMinoAttack(sector,entity):
	if entity !="Player1":
		return
	darfuncs.UnhideBadGuy("StartMino")
	CheckPlayerVisibility("StartMino")
	PlaceEnemy("StartMino")
	sectmin.OnEnter=None
	
	
	
def SetEnemyFuncs(entity):
	en=Bladex.GetEntity(entity)
	en.Data.DeathFunc=NextEnemy
	en.Data.DeathArgs=(en.Kind,)
	if en.Kind in ("Ork","Great_Ork"):
		en.ActionAreaMin=pow( 2,0 ) 
		en.ActionAreaMax=pow( 2,1 ) 
	
	
Skelsact=0
	
def StartSkelAttack():
	global Skelsact
	if Skelsact==0:
		darfuncs.UnhideBadGuy("StartSkeleton")
		Bladex.GetEntity("StartSkeleton").Alpha=1
		Skelsact=1


def NextEnemy(EntityKind):
	delay=5.0
	if EntityKind=="Minotaur":
		delay=30.0
	Bladex.AddScheduledFunc(Bladex.GetTime()+delay,CreateEnemy,(EntityKind,))



def CreateEnemy(EntityKind="Knight_Traitor"):
	print "creating enemy"
	global Spawnpos
	global Enemynum
	global EneWeaponList
	global Shieldholders
	
	en=Bladex.CreateEntity("Enemy_"+str(Enemynum),EntityKind,0,20000,0,"Person")
	lvl=Bladex.GetEntity("Player1").Level
	en.Level=lvl
	rwp=Bladex.CreateEntity(en.Name+"RightWeapon",GetWeaponType(EntityKind,lvl),0,20000,0,"Weapon")
	if EntityKind=="Minotaur" and rwp.Kind in ("Maza","Garrote","Martillo","Martillo2","Martillo3"):
		rwp.Scale=1.5
	else:
		rwp.Scale=1.0
	if rwp.Kind=="ProWolfSword":
		global WolfSwordDamage
		global WolfSwordDef
		if lvl<=19:
			damfact=WolfSwordDamage[lvl]
			deffact=WolfSwordDef[lvl]
		else:
			damfact=1000
			deffact=-120
		Reference.EntitiesObjectData[rwp.Name]=Reference.DefaultObjectData[rwp.Kind]  
		Reference.EntitiesObjectData[rwp.Name][1]= damfact
		Reference.EntitiesObjectData[rwp.Name][2]= deffact	
	try:
		ItemTypes.ItemDefaultFuncs(rwp)
	except:
		print"unknown weapon in Item Types"
		pass
	EneWeaponList.append(rwp.Name)
	Actions.TakeObject(en.Name,rwp.Name)
	EneWeaponList.append(rwp.Name)
	if EntityKind in Shieldholders:
		sh=Bladex.CreateEntity(en.Name+"Shield",GetShieldType(en.Level),0,20000,0,"Weapon")
		sh.Scale=1.0
		Sparks.MakeShield(sh.Name)
		EneWeaponList.append(sh.Name)
		Actions.TakeObject(en.Name,sh.Name)
	MasklinTypes.AddToPersonList(en.Name)
	AssignData(en.Name) 
	SetEnemyFuncs(en.Name)
	en.SendTriggerSectorMsgs=1
	darfuncs.HideBadGuy(en.Name)
	en.Alpha=0
	en.CastShadows=0
	PlaceEnemy(en.Name)
	Enemynum=Enemynum+1
	
	
def PlaceEnemy(enemyname):
	en=Bladex.GetEntity(enemyname)
	if en.Alpha>0.9:
		en.Alpha=0
	if Spawnpos.has_key(en.Kind):
		positions=Spawnpos[en.Kind]
	else:
		positions=Spawnpos["Default"]
	pos=positions[whrandom.randint(0, len(positions)-1)]
	en.Position=pos[0], pos[1], pos[2]
	en.Angle=B3DLib.GetEntity2EntityAngle(en.Name, "Player1")
	darfuncs.HideBadGuy(enemyname)
	if ConcealedAppear(pos,en.Name)==1:
		CheckPlayerVisibility(en.Name)
		darfuncs.UnhideBadGuy(enemyname)
		en.Alpha=1.0
		en.CastShadows=1
		en.SetOnFloor()
		Bladex.AddScheduledFunc(Bladex.GetTime() + 2.0,SeekPlayer,(enemyname,))
		Reference.debugprint("All clear - enemy ready to fight")
	else:	
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,PlaceEnemy,(enemyname,))
		Reference.debugprint("position not good - next try in a mo.")
	
	
	
AllySpawnpos=[(15479,6006,-21036),
	      (22298,5401,-12566),
              (26990,5301,-7522),
              (36884,6102,2361),
              (55294,6221,-563),
              (72349,6000,9287),
              (36327,6005,-11866)]
	
	
	
	
	
def PlaceAlly(enemyname):
	en=Bladex.GetEntity(enemyname)
	if en.Alpha>0.9:
		en.Alpha=0
	pos=AllySpawnpos[whrandom.randint(0, len(AllySpawnpos)-1)]
	en.Position=pos[0], pos[1], pos[2]
	en.Angle=B3DLib.GetEntity2EntityAngle(en.Name, "Player1")
	darfuncs.HideBadGuy(enemyname)
	if ConcealedAppear(pos,en.Name)==1:
		darfuncs.UnhideBadGuy(enemyname)
		en.Alpha=1.0
		en.CastShadows=1
		en.SetOnFloor()
		Bladex.AddScheduledFunc(Bladex.GetTime() + 2.0,SeekPlayer,(enemyname,))
		Reference.debugprint("All clear - Ally ready to fight")
	else:	
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.2,PlaceEnemy,(enemyname,))
		Reference.debugprint("position not good for Ally- next try in a mo.")
	
	
	
def ConcealedAppear(pos,entity):
	en=Bladex.GetEntity(entity)
	char=Bladex.GetEntity("Player1")
	dist=B3DLib.GetXZDistance("Player1",en.Name)
	if dist >4000:
		# check not in Player sight
		if not en.CanISee(char) and not char.CanISee(en):
			things=Bladex.GetEntitiesAt(pos[0],pos[1],pos[2],3000)
			# check that another en is not already in my position
			clear=1
			for id in things:
				possibleen=Bladex.GetEntity(id)
				if possibleen.Person and possibleen.Name!=en.Name:
					if possibleen.Life>0:
						print "Trying to do it, but",id,"is already in my position."
						clear=0
			else:
				if clear==1:
					return 1
				else:
					return 0
		else:
			print "I can't appear here. I can be seen."
			return 0
	else:
		return 0
		
		
def SeekPlayer(entity):
	en=Bladex.GetEntity(entity)
	char=Bladex.GetEntity("Player1")
	x,y,z=char.Position
	ax,ay,az=36000,5800,-8000
	if en.AstarState<>Enm_Def.ASTAR_SOLVED:
		if en.Kind in ("Ork","Great_Ork"):
			return
		if en.Kind=="Minotaur":
			en.GoTo(ax,ay,az)
		else:
			en.GoToSneaking=1
			en.GoTo(x,y,z)	
		
		
def ReplaceMe(entity):
	en=Bladex.GetEntity(entity)
	ax,ay,az=en.Data.GuardPosition
	ang=en.Data.GuardAngle
	kind=en.Kind
	AAmax=en.Data.AAsec
	AAmin=en.Data.AAprim
	lvl=Bladex.GetEntity("Player1").Level
	Bladex.AddScheduledFunc(Bladex.GetTime()+180.0, MakeReplacement, (AAmax,AAmin,ax,ay,az,ang,lvl,kind,))
	

def MakeReplacement(AAmax,AAmin,ax,ay,az,ang,lvl=1,kind="Skeleton"):
	global Enemynum
	nuen=Bladex.CreateEntity("Skeleton_Archer"+`Enemynum`,kind,0,30000,0,"Person")
	nuen.Angle=ang
	nuen.Level=lvl
	inv=nuen.GetInventory()
	nuenwp=Bladex.CreateEntity(nuen.Name+"WP","Garrote",0, 0, 0,"Weapon")
	Actions.TakeObject(nuen.Name,nuenwp.Name)
	nuenbw=Bladex.CreateEntity(nuen.Name+"BW","Arco",0, 0, 0,"Weapon")
	inv.AddBow(nuenbw.Name)
	ItemTypes.ItemDefaultFuncs(nuenbw)
	nuenqv=Bladex.CreateEntity(nuen.Name+"BW","Carcaj",0, 0, 0,"Weapon")
	WizQuiverTypes.QuiverTypeFuncs(nuenqv)
	inv.AddQuiver(nuenqv.Name)
	nuenqv.Data.ArrowsLeft=10
	Enemynum=Enemynum+1
	AssignData(nuen.Name)
	nuen.Data.AAsec=AAmax
	nuen.Data.AAprim=AAmin
	nuen.Data.GuardPosition=ax,ay,az
	nuen.Data.GuardAngle=ang
	nuen.Data.DeathFunc=ReplaceMe
	nuen.Data.DeathArgs=(nuen.Name,)
	darfuncs.HideBadGuy(nuen.Name)
	PlaceMeIfSafe(nuen.Name,ax,ay,az,ang,AAmax,AAmin)
	


def PlaceMeIfSafe(entityname,ax,ay,az,ang,AAmax,AAmin):
	en=Bladex.GetEntity(entityname)
	en.Position=ax,ay,az
	en.Angle=ang
	darfuncs.HideBadGuy(en.Name)
	pos=ax,ay,az
	if ConcealedAppear(pos,en.Name):
		CheckPlayerVisibility(en.Name)
		darfuncs.UnhideBadGuy(en.Name)
		en.Alpha=1.0
		en.CastShadows=1
		en.SetOnFloor()
		# setting action areas on respawned ens is not entirely reliable...
		en.Data.SetActionArea()
	else:
		print "Pos no good - next try 30sec...."
		en.Position=0,30000,0
		Bladex.AddScheduledFunc(Bladex.GetTime()+60.0,PlaceMeIfSafe,(entityname,ax,ay,az,ang,AAmax,AAmin,))
		
		
		
Crabpos=[(72922.5650997,7457.87098034,-41331.2538593),
         (85832.9478646,3861.56164959,-43133.513252),
         (97037.6415184,-2138.43835041,-50883.2708469),
         (145089.807542,-6138.43883995,-54104.8403636),
         (147158.553055,3861.56164959,-44483.8273605),
         (142055.041344,3861.56164959,-35714.5883119),
         (130200.59935,7861.56164959,-30744.5188626),
         (120906.995969,1861.56165002,-52668.9967369),
         (104936.355152,1861.56116048,-50811.922047)]
		
		
Crabnum=0
		
		
def CrabDED():
	global Crabnum
	shellnums = (1,2,3,4,5,6,7,8)
	idx = whrandom.randint(0, len(shellnums)-1)
	shellsize = shellnums[idx]
	lvl=Bladex.GetEntity("Player1").Level
	nucrab=EnemyCharTypes.CreateSpiderCrab("IceCrab"+`Crabnum`,(0,50000,0),0,lvl+1,shellsize)
	nucrab.Data.Deathfunc=CrabDED
	Crabnum=Crabnum+1
	Bladex.AddScheduledFunc(Bladex.GetTime()+5.0, PlaceCrab,(nucrab.Name,))
	
	
def PlaceCrab(crabname):
	global Crabpos
	crab=Bladex.GetEntity(crabname)
	pos=Crabpos[whrandom.randint(0, len(Crabpos)-1)]
	crab.Position=pos[0], pos[1], pos[2]
	crab.Angle=B3DLib.GetEntity2EntityAngle(crab.Name, "Player1")
	darfuncs.HideBadGuy(crabname)
	if ConcealedAppear(pos,crab.Name)==1:
		CheckPlayerVisibility(crab.Name)
		darfuncs.UnhideBadGuy(crabname)
		crab.Alpha=0.0
		crab.CastShadows=0
		crab.SetOnFloor()
		Reference.debugprint("All clear - enemy ready to fight")
	else:	
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,PlaceCrab,(crabname,))
		Reference.debugprint("position not good - next try in a mo.")
	
	
def UnhideTroll1(sector, entity):
	if entity != "Player1":
		return
	troll1=Bladex.GetEntity("Troll_Dark_1")
	rwp= Bladex.GetEntity(troll1.InvRight)
	lvl=Bladex.GetEntity("Player1").Level
	troll1.Level=lvl
	troll1.Life=CharStats.GetCharMaxLife(troll1.Kind,troll1.Level)
	if rwp:
		global WolfSwordDamage
		global WolfSwordDef
		damfact=45
		deffact=-30
		if lvl<=19:
			damfact=WolfSwordDamage[lvl]
			deffact=WolfSwordDef[lvl]
		else:
			damfact=1000
			deffact=-120
		Reference.EntitiesObjectData[rwp.Name]=[Reference.OBJ_WEAPON, damfact, deffact, 2.8,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
		#Reference.EntitiesObjectData[rwp.Name][1]= damfact
		#Reference.EntitiesObjectData[rwp.Name][2]= deffact	
	CheckPlayerVisibility("Troll_Dark_1")
	darfuncs.UnhideBadGuy("Troll_Dark_1")
	secttroll.OnEnter=None
	
	
def ActIceGolem(sector, entity):
	if entity=="Player1":
		icegol=Bladex.GetEntity("IceGolem")
		lvl=Bladex.GetEntity("Player1").Level
		icegol.Level=lvl
		icegol.Life=CharStats.GetCharMaxLife(icegol.Kind,icegol.Level)
		icegol.UnFreeze()
		CheckPlayerVisibility(icegol.Name)
		secticegol.OnEnter=None
	
	
#########################################################################################################################################################
### Go To Next Map

NextMap=""


def AppearsTablet(tabletname):
	aura= Auras.MakeAura (tabletname,5.0,(25,1.0,1.0,1,0,0), (),(),(2,  0.8,0.8,1.0, 1.0, 0.6  , 0.0,0.0,1.0, 0.0, 1.0))
	wps=Bladex.CreateEntity(tabletname+" TwinkleStar", "Entity Particle System Dobj", 0.0, 0.0, 0.0)
	wps.ObjectName=tabletname
	wps.ParticleType="LucesCools"
	wps.Time2Live=16
	wps.RandomVelocity=0
	wps.Velocity=0,0,0
	wps.NormalVelocity=2
	wps.YGravity=0
	wps.PPS=5
	Bladex.GetEntity(tabletname).SelfIlum = 0.3
	AuxFuncs.FadeObject(tabletname,0.0,1.0,2.5)


def MasklinMagicallyDisappearing():
	TimeEffect=5.0
	time=Bladex.GetTime()
	char=Bladex.GetEntity("Player1")
	char.Alpha=1.0
	char.RasterMode="Read"
	AuxFuncs.FadeObject("Player1", 1.0, 0.01, TimeEffect)
	if char.InvLeft<>"":
		obj=Bladex.GetEntity(char.InvLeft)
		obj.RasterMode="Read"
		AuxFuncs.FadeObject(char.InvLeft, obj.Alpha, 0.01, TimeEffect)
		obj.CastShadows=0
	if char.InvRight<>"":
		obj=Bladex.GetEntity(char.InvRight)
		obj.RasterMode="Read"
		AuxFuncs.FadeObject(char.InvRight, obj.Alpha, 0.01, TimeEffect)
		obj.CastShadows=0
	if char.InvLeftBack<>"":
		obj=Bladex.GetEntity(char.InvLeftBack)
		obj.RasterMode="Read"
		AuxFuncs.FadeObject(char.InvLeftBack, obj.Alpha, 0.01, TimeEffect)
		obj.CastShadows=0
	if char.InvRightBack<>"":
		obj=Bladex.GetEntity(char.InvRightBack)
		obj.RasterMode="Read"
		AuxFuncs.FadeObject(char.InvRightBack, obj.Alpha, 0.01, TimeEffect)
		obj.CastShadows=0
	AuraParams0=(240, 0.01, 1.0, 0, 1, 1)
	AuraParams1=(50 , 1.0 , 1.0, 0, 1, 1)
	AuraParams2=(50 , 0.01, 1.0, 0, 1, 1)
	AuraGradient0=(2,  0.2, 0.4, 0.8, 1.0, 0.2  ,  0.0, 0.2, 0.8, 0.0, 0.7)
	AuraGradient1=(2,  0.8, 0.9, 1.0, 1.0, 0.2  ,  0.0, 0.2, 0.9, 0.1, 1.0)
	aura=Auras.MakeAura("Player1", TimeEffect, AuraParams2, (), (), AuraGradient0)
	aura.Data.AddEvent (time+TimeEffect/2.0, AuraParams1, (), (), AuraGradient1)
	aura.Data.AddEvent (time+TimeEffect, AuraParams0, (), (), AuraGradient0)
	ps=Bladex.CreateEntity("PSPersonMagicallyAppearing", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	ps.PersonName="Player1"
	ps.ParticleType="EnergyDissip"
	ps.PPS=200
	ps.YGravity=0.0
	ps.Friction=0.0
	ps.Velocity=0.0, 0.0, 0.0
	ps.RandomVelocity=0.5
	ps.NormalVelocity=2.0
	ps.Time2Live=60
	ps.DeathTime=time+TimeEffect/3.0

	

def InitExit(object,usefrom):
	char=Bladex.GetEntity("Player1")
	ob=Bladex.GetEntity(object)
	ob.RemoveFromWorld()
	global NextMap
	NextMap=ob.Name[-1]
	print "Set Map var to ",NextMap
	Bladex.DeactivateInput()
	Scorer.SetVisible(0)
	import MagicScorer
	MagicScorer.MscorerHide()	
	Bladex.KillMusic()
	Bladex.ExeMusicEvent(Bladex.GetMusicEvent("coro5"))
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, AuxFuncs.FadeTo,(9.0,0.0,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.0,MasklinMagicallyDisappearing,())
	Bladex.AddScheduledFunc(Bladex.GetTime()+6.5, WriteCaptionT5,("Masklin has left the Map",140,4.0))
	Bladex.AddScheduledFunc(Bladex.GetTime()+11.9, Exit,())
	

def Exit():
	global NextMap
	if NextMap=="":
		Bladex.LoadLevel("Casa")
		print "Loading Casa map"
		return
	import os
	import WizGotoMapVars
	# check follow-on maps are actually installed.....
	if NextMap=="1":
		if not os.path.exists ("../../Maps/RuinsWiz/Cfg.py"):
			Bladex.LoadLevel("Casa")
		else:
			WizGotoMapVars.EndOfLevel("RuinsWiz")
	elif NextMap=="2":
		if not os.path.exists ("../../Maps/DwarfWiz/Cfg.py"):
			Bladex.LoadLevel("Casa")
		else:
			WizGotoMapVars.EndOfLevel("DwarfWiz")	
	elif NextMap=="3":
		if not os.path.exists ("../../Maps/BarbWiz/Cfg.py"):
			Bladex.LoadLevel("Casa")
		else:
			WizGotoMapVars.EndOfLevel("BarbWiz")	
	elif NextMap=="4":
		if not os.path.exists ("../../Maps/KnightWiz/Cfg.py"):
			Bladex.LoadLevel("Casa")
		else:
			WizGotoMapVars.EndOfLevel("KnightWiz")
	else:
		Bladex.LoadLevel("Casa")
		print "No Next Map Selected"





def SetRuinsMapNext(sector,entity):
	if entity=="Player1":
		gp=Bladex.CreateEntity("SouthPointer1","GhostPointer", 160000,2100,131778)
		gp.Static=1
		gp.UseFunc= InitExit
		darfuncs.SetHint(gp,"Tablet")
		tab=Bladex.GetEntity("Tablilla_South1")
		AppearsTablet(tab.Name)
		sectShrineSouth.OnEnter=None
		sectShrineEast.OnEnter=None
		sectShrineNorth.OnEnter=None
		sectShrineWest.OnEnter=None
		CheckIAmNormal()
	

def SetDwarfMapNext(sector,entity):
	if entity=="Player1":
		gp=Bladex.CreateEntity("EastPointer2","GhostPointer", 160714,2100,132508)
		gp.Static=1
		gp.UseFunc= InitExit
		darfuncs.SetHint(gp,"Tablet")
		tab=Bladex.GetEntity("Tablilla_East2")
		AppearsTablet(tab.Name)
		sectShrineSouth.OnEnter=None
		sectShrineEast.OnEnter=None
		sectShrineNorth.OnEnter=None
		sectShrineWest.OnEnter=None
		CheckIAmNormal()
		
	
def SetBarbMapNext(sector,entity):
	if entity=="Player1":
		gp=Bladex.CreateEntity("NorthPointer3","GhostPointer", 159994,2100,133228)
		gp.Static=1
		gp.UseFunc= InitExit
		darfuncs.SetHint(gp,"Tablet")
		tab=Bladex.GetEntity("Tablilla_North3")
		AppearsTablet(tab.Name)
		sectShrineSouth.OnEnter=None
		sectShrineEast.OnEnter=None
		sectShrineNorth.OnEnter=None
		sectShrineWest.OnEnter=None
		CheckIAmNormal()
		
	
def SetKnightMapNext(sector,entity):
	if entity=="Player1":
		gp=Bladex.CreateEntity("WestPointer4","GhostPointer", 159257,2100,132480)
		gp.Static=1
		gp.UseFunc= InitExit
		darfuncs.SetHint(gp,"Tablet")
		tab=Bladex.GetEntity("Tablilla_West4")
		AppearsTablet(tab.Name)
		sectShrineSouth.OnEnter=None
		sectShrineEast.OnEnter=None
		sectShrineNorth.OnEnter=None
		sectShrineWest.OnEnter=None
		CheckIAmNormal()
	
	
def CheckIAmNormal():
	char=Bladex.GetEntity("Player1")
	if char.Data.Poisoned:
		char.Data.UnVenom()
	if char.MeshName=="Werewolf":
		char.Data.Recover("Player1")

	
	
def KillEnemy(sector, entity):	
	per=Bladex.GetEntity(entity)
	if per and per.Person:
		if per.Life>0 and MasklinTypes.CheckIfAlly(entity) and per.Name != "Player1":
			per.Life=-1
			
def StartMatrix():
	if Actions.StatR("Player1")==Actions.RA_NO_WEAPON or Actions.StatL("Player1")==Actions.LA_BOW:
		#starting Matrix when in bow mode upsets PV. 
		return
	darfuncs.StartMatrixFX()
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,darfuncs.StopMatrixFX,())
	
			
		
# I like this view 8)
			
def CheckPV():	
	char=Bladex.GetEntity("Plaver1")
	try:
		cam= Bladex.GetEntity("Camera")
		if char.Data.LastPViewType!=None:
			cam.PViewType= me.Data.LastPViewType
			me.Data.LastPViewType= None
		else:
			cam.PViewType=0
	except AttributeError:
		pass
		
		
		
#########################################################################################################################################################
########## Cleaning. (this is not 100% reliable for some strange reason)
########## * Moving unwanted stuff to remote dump is better than permanently deleting with 'SubscribeToList("Pin")
########## as this will preserve savegame integrity for previously-owned weapons.


Cleaning=0

def ResetCleaningInterval():
	global Cleaning
	Cleaning=0


def CleanUp():
	global Cleaning
	if Cleaning==0:
		RemoveDroppedWeapons()
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.5, CleanTheCrap,())
		Cleaning=1
		Bladex.AddScheduledFunc(Bladex.GetTime()+10, ResetCleaningInterval,())



def MoveMeOutOfTheWay(thing):
	global EneWeaponList
	ewp=Bladex.GetEntity(thing)
	if ewp.Position[1]<49000:
		ewp.Position=0,50000,0
		Reference.debugprint("MOVING: " + ewp.Name)
		if ewp.Name in EneWeaponList:
			EneWeaponList.remove(ewp.Name)
		try:
			if ewp.Data.brkobjdata:
				brkobj = ewp.Data.brkobjdata
				bitnums=brkobj.n_piezas
				for i in bitnums:
					frag=Bladex.GetEntity(ewp.Name+"Pieza"+`i+1`)
					if frag:
						Reference.debugprint("MOVING FRAGMENT : " + frag.Name)
						frag.Position=0,50000,0
		except:
			pass
		
		
def RemoveDroppedWeapons():
	global EneWeaponList
	for id in EneWeaponList:
		ewp=Bladex.GetEntity(id)
		if ewp:
			if not ewp.Parent:
				MoveMeOutOfTheWay(ewp.Name)
					
		
def CleanTheCrap():
	ObjStore.CheckStore()
	ents = Bladex.nEntities()
	for id in range(ents):
		obj = Bladex.GetEntity(id)
		if obj:
			if obj.Kind == "Entity Pool" or obj.Kind[:4] == "Limb":
				global savedlimbs
				if obj.Name not in savedlimbs:
					obj.RemoveFromWorld()
					obj.SubscribeToList("Pin")
					Reference.debugprint("CLEANED: " + obj.Name)
	
	Reference.debugprint("CLEANED ALL THE CRAP")
		
		

#########################################################################################################################################################
#########################################################################################################################################################
####### Temp Funcs for testing



def WritePos():
	char=Bladex.GetEntity("Player1")
	x=int(char.Position[0])
	y=int(char.Position[1])
	z=int(char.Position[2])
	file = open("../../BODLoader/Mods/WizardsDomain/pos.txt","a")
        file.write("("+str(x)+","+str(y)+","+str(z)+")"+"\n")
        
        file.close()
        
        
Bladex.AddInputAction("WritePos", 0)
Bladex.AddBoundFunc("WritePos", WritePos)
Bladex.AssocKey("WritePos", "Keyboard", "I", 1)





def GoToHall():
	per=Bladex.GetEntity("Player1")
	per.Position=160000,3600,118000


	
def MoreMagic():
	char=Bladex.GetEntity("Player1")
	char.Data.AddMagic(500)


Bladex.AddInputAction("MoreMagic", 0)
Bladex.AddBoundFunc("MoreMagic", MoreMagic)
Bladex.AssocKey("MoreMagic", "Keyboard", "N", 1)

posnum=1

def GetPlayerPos():
	global posnum
	char=Bladex.GetEntity("Player1")
	x,z,y=char.Position
	print"Player Position ",posnum,x,z,y
	posnum=posnum+1
	
	
Slomo=0

def ToggleSlomo():
	global Slomo
	if Slomo==0:
		Slomo=1
		Bladex.SetTimeSpeed(0.2)
		Slomo=1
		print"Slomo on"
	else:
		Slomo=0	
		Bladex.SetTimeSpeed(1.0)
		Slomo=0	
		print"Slomo off"


def InitEB():
	import EBrowser
	print "EBStart"



Scoreron=1

def HideScorer():
	global Scoreron
	if Scoreron==1:
		Scorer.SetVisible(0)
		Scoreron=0
	else:
		Scorer.SetVisible(1)
		Scoreron=1




if Reference.PYTHON_DEBUG >= 1:
	Bladex.AddInputAction("HideScorer", 0)
	Bladex.AddBoundFunc("HideScorer", HideScorer)
	Bladex.AssocKey("HideScorer", "Keyboard", "B", 1)

	Bladex.AddInputAction("GoToHall", 0)
	Bladex.AddBoundFunc("GoToHall", GoToHall)
	Bladex.AssocKey("GoToHall", "Keyboard", "J", 1)

	Bladex.AddInputAction("InitEB", 0)
	Bladex.AddBoundFunc("InitEB", InitEB)
	Bladex.AssocKey("InitEB", "Keyboard", "X", 1)

	Bladex.AddInputAction("GetPlayerPos", 0)
	Bladex.AddBoundFunc("GetPlayerPos", GetPlayerPos)
	Bladex.AssocKey("GetPlayerPos", "Keyboard", "V", 1)

	Bladex.AddInputAction("ToggleSlomo", 0)
	Bladex.AddBoundFunc("ToggleSlomo", ToggleSlomo)
	Bladex.AssocKey("ToggleSlomo", "Keyboard", "U", 1)
