import Bladex
import Ally_Def
import WizardAllyTypes
import Reference
import AuxTran
import AniSound
import pdb
import BCopy
import math
import whrandom
import Actions
import CharStats
import AuxFuncs
import B3DLib
import Damage
import GameText
import Sounds
import GameStateAux
import Interpolator
import InitDataField
import Ally_Def
import AllyCombat


TRUE = 1==1
FALSE = not TRUE


class BadgerAlly (WizardAllyTypes.AllyChar):

	Ownername="Player1"
	bitesound=None
	
	
	def __init__(self, me):		
		WizardAllyTypes.AllyChar.__init__(self, me)
		
		me.AddAnmEventFunc("Spit",self.ExtraZap)	
		
		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = -1.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 20.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		self.bitesound=Bladex.CreateSound("..\\..\\Sounds\\bugbite-bone.wav", "BiteSound")
		self.bitesound.Volume=1
		self.bitesound.Scale=1.0
		self.bitesound.MinDistance= 5000
		self.bitesound.MaxDistance=15000
		
		
		
	
	# Functions for loading and saving state
	def __getstate__(self):		
		NPCPerson_state=WizardAllyTypes.AllyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["BadgerAlly"]=(self.Ownername, self.bitesound.Name)
		return NPCPerson_state		

	def __setstate__(self,parm):
		WizardAllyTypes.AllyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["BadgerAlly"]			
			self.Ownername=parms[0]
			self.bitesound=Bladex.GetSound(parms[1])
			me=Bladex.GetEntity(self.Name)
			me.AddAnmEventFunc("Spit",self.ExtraZap)	
		
	
		
	def ResetSounds(self, EntityName):
		Bladex.ReadBitMap("../../Maps/WizardsDomain/NUFiles/NUBadgerStuff/BadgerIcon.bmp","BadgerIcon")
		Reference.EnemiesScorerData[self.Name]=("BadgerIcon","Bgr")	




	def ResetCombat (self,EntityName):
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.BlockingPropensity = 0.0
			me.AttackList = BCopy.deepcopy(BadgerAllyAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0
			self.AttackNPCTime = 10


	
	def OnKilledEnemy(self,KilledEntityName):
		print KilledEntityName," I have been Badgered!!!"
		WizardAllyTypes.AllyChar.OnKilledEnemy(self,KilledEntityName)
		me=Bladex.GetEntity(self.Name)
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		maxlife=CharStats.GetCharMaxLife(me.Kind, me.Level)
		reward=int(maxlife/100)
		if me.Life+reward>=maxlife:
			me.Life=maxlife
		else:
			me.Life=me.Life+reward
		if self.Ownername:
			owner=Bladex.GetEntity(self.Ownername)
			if owner.Life>0:
				if owner.Kind=="Wizard_A":
					owner.Data.GetAllyMagicReward(KilledEntityName)
					print "Wizard getting Magic reward from Badger kill"
	

	
	def ExtraZap(self, EntityName, EventName):
		me = Bladex.GetEntity(EntityName)
		if self.EnemyName:
			en=Bladex.GetEntity(self.EnemyName)
			print "Badger biting ",self.EnemyName
			dist = B3DLib.GetXZDistance(en.Name, EntityName)
			if dist<700:
				if en:
					if en.Life<(CharStats.GetCharMaxLife(en.Kind,en.Level)/10):
						en.Life=0
						self.OnKilledEnemy(en.Name)
					else:
						lvl=me.Level+1
						bitedamage=lvl*60
						en.Life=en.Life-bitedamage
						if en.Life<0:
							self.OnKilledEnemy(en.Name)
						else:
							en.LaunchAnmType("hurt_f_big")
					x,y,z=me.Position
					self.bitesound.Play(x,y,z, 0)
					

			

BadgerAllyAttackData = [
           # attacks:
            [AllyCombat.ATTACK, 0.02, ("GA",),             100.0, 600.0, 1500.0, 0.35],
            [AllyCombat.ATTACK, 0.60, ("SP",),             100.0, 400.0, 1000.0, 0.35],
            
           # inner zone moves:
            [AllyCombat.MOVE,   0.25, AllyCombat.FearFire,     100.0, 1700.0, 2500.0, 0.05],
]
