import Bladex
import Ally_Def
import WizardAllyTypes
import Reference
import AuxTran
import AniSound
import pdb
import BCopy
import math
import whrandom
import Actions
import CharStats
import AuxFuncs
import B3DLib
import Damage
import GameText
import Sounds
import GameStateAux
import Interpolator
import InitDataField
import Ally_Def
import AllyCombat
import AniSoundCat
import GenFX

TRUE = 1==1
FALSE = not TRUE


class CatAlly (WizardAllyTypes.AllyChar):

	Ownername="Player1"
	ClawName=None
	CatDamage=[]

	def __init__(self, me):		
		WizardAllyTypes.AllyChar.__init__(self, me)
		
		self.Ownername="Player1"
		self.ClawName=None
		
		# constant
		self.CatDamage=[3,8,15,25,32,45,60,80,100,130,175,220,275,340,400,480,550,630,700,800]
		
		me.ImDeadFunc=self.ImDeadFunc
		
		
		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = -1.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 20.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
	
	
	def ResetSounds(self, EntityName):
		AniSoundCat.AsignarSonidosCat(EntityName)
		Bladex.ReadBitMap("../../Maps/WizardsDomain/NUFiles/NUCatStuff/CatIcon.bmp","CatIcon")
		Reference.EnemiesScorerData[self.Name]=("CatIcon","Cat")	



	def SetMyDamage(self):
		me = Bladex.GetEntity(self.Name)
		lvl=me.Level
		dam=3
		if lvl>19:
			dam=1000
		else:
			dam=self.CatDamage[lvl]
		if self.ClawName:
			Reference.EntitiesObjectData[self.ClawName]=[Reference.OBJ_STANDARD,  dam,  0, 1.0,  Reference.THR_SPINNING,[]]
			print "Cat CLAW damge updated"
		else:
			Reference.EntitiesObjectData[me.Name]=[Reference.OBJ_WEAPON,  dam,  0, 1.0,  Reference.THR_SPINNING,[]]
			

	def ImDeadFunc (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		WizardAllyTypes.AllyChar.NewImDeadFunc(self,EntityName)
		
		if self.ClawName:
			rclaw=Bladex.GetEntity(self.ClawName)
			rclaw.Alpha=0
			rclaw.CastShadows=0
			rclaw.RemoveFromWorld()
			
	
	def GetClaw(self):
		me = Bladex.GetEntity(self.Name)
		inv=me.GetInventory()
		claw=Bladex.CreateEntity(self.Name+"Claw","ProWolfClaw",0,0,0,"Weapon")
		claw.Alpha=0
		claw.CastShadows=0
		claw.RasterMode  ="AdditiveAlpha"
		claw.RasterMode  ="Read"
		self.ClawName=claw.Name
		inv.AddWeapon(claw.Name)
		inv.LinkRightHand(claw.Name)
		self.SetMyDamage()
		self.ResetCombat(self.Name)
		
		

	def ResetCombat (self,EntityName):
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.BlockingPropensity = 0.0
			me.AttackList = BCopy.deepcopy(CatAllyAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0
			self.AttackNPCTime = 10


	def OnKilledEnemy(self,KilledEntityName):
		me=Bladex.GetEntity(self.Name)
		Reference.debugprint (self.Name+": I have killed "+KilledEntityName)
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		if KilledEntityName=="Player1":
			Reference.debugprint ("Ally Char: oooops! I have killed the Player")
			return
		maxlife=CharStats.GetCharMaxLife(me.Kind, me.Level)
		reward=int(maxlife/20)
		if me.Life+reward>=maxlife:
			me.Life=maxlife
		else:
			me.Life=me.Life+reward
		if self.Ownername:
			owner=Bladex.GetEntity(self.Ownername)
			if owner.Life>0:
				if owner.Kind=="Wizard_A":
					owner.Data.GetAllyMagicReward(KilledEntityName)
					print "Wizard getting Magic reward from Cat kill"
		if self.OnGuard:
			Bladex.AddScheduledFunc(Bladex.GetTime()+ 3.5,self.GoBackToPost,(self.Name,))
		else:
			Bladex.AddScheduledFunc(Bladex.GetTime()+ 3.5, self.LookAround, (self.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 4.5, self.DoINeedADrink,(self.Name,))
		
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		import Scorer
		
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			
			GenFX.LevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or thrown weapons and.. You are death!
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
				if self.Poisoned:
					self.UnVenom ()
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
			self.SetMyDamage()
			print "Leveled UP -> ", me.Name
	


	# Functions for loading and saving state
	def __getstate__(self):		
		NPCPerson_state=WizardAllyTypes.AllyChar.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["CatAlly"]=(self.Ownername,self.ClawName)
		return NPCPerson_state		

	def __setstate__(self,parm):
		WizardAllyTypes.AllyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["CatAlly"]			
			self.Ownername=parms[0]
			self.ClawName=parms[1]


CatAllyAttackData = [
           # attacks:
            [AllyCombat.ATTACK, 0.60, ("GA",),             100.0, 500.0, 1500.0, 0.35],
            [AllyCombat.ATTACK, 0.02, ("GB",),             100.0, 500.0, 1500.0, 0.35],
            [AllyCombat.ATTACK, 0.25, ("SP",),             100.0, 500.0, 1500.0, 0.35],
            
           # inner zone moves:
            [AllyCombat.MOVE,   0.25, AllyCombat.FearFire,     100.0, 1700.0, 2500.0, 0.05],
]
