import Bladex
import Enm_Def
import Reference
import AllyCombat
import Combat
import AniSound
import BCopy
import math
import whrandom
import Actions
import Interpolator
import CharStats
import ItemTypes
import AuxFuncs
import Sparks
import Objects
import InitDataField
import B3DLib
import Damage
import darfuncs
import ObjStore
import GameText
import MenuText
import Ally_Def
import AllyCombat
import EnemyTypes
import Basic_Funcs
import GameStateAux
import GenFX
import ScorerActions
import Change
import InitDataField




TRUE = 1==1
FALSE = not TRUE


W_FLAG_1H=0     #One handed _whatever_ weapon
W_FLAG_2W=1	#Two handed sword
W_FLAG_AXE=2	#Two handed axe
W_FLAG_SP=3     #Two handed spear


PI = math.pi
TWOPI = PI*2

CHOOSE_FIRST  = -1
CHOOSE_SECOND =  1
CHOOSE_EITHER =  0

ROUTE_WATCH=0  #Watch mode
ROUTE_BAY=1    #Performing a bay route
ROUTE_CHASE=2  #Chase a character
ROUTE_SINGLE=3 #Following a single route (going to just a point)
ROUTE_BOWING=4 #Bowing (OR trying to bow) an enemy





def AmIArmed(entity):
	per=Bladex.GetEntity(entity)
	wp=Bladex.GetEntity(per.InvRight)
	if wp:
		print entity+": I am holding wep - returning true"
		return TRUE
	print entity+": I am NOT holding wep - returning false"
	return FALSE
		


def CheckIfAlly (EntityName):
	me=Bladex.GetEntity(EntityName)
	if me:				
		try:
	           enemyName=me.Data.EnemyName
	           return FALSE                  # returns TRUE for enemies of Player
	        except AttributeError:  
	 	   return TRUE



def DumpMe(entity):
	per=Bladex.GetEntity(entity)		
	per.Position=0,30000,0
		
def RemoveMyCorpse(PersonName, dx, dz):
	wps=Bladex.CreateEntity(PersonName+"WPS", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	wps.PersonName=PersonName
	wps.ParticleType="EnPolvo"
	wps.Time2Live=64
	wps.RandomVelocity=0
	wps.Velocity=dx,300,dz
	wps.NormalVelocity=2.0
	wps.YGravity=-300
	wps.DeathTime=Bladex.GetTime()+1.5
	wps.PPS=300
	me = Bladex.GetEntity(PersonName)
	me.Alpha=1.00
	me.RasterMode="Read"
	me.CastShadows=0
	AuxFuncs.FadeObject(PersonName, 1.00, 0.0, 4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, DumpMe,(me.Name,))
	
	
def RemoveMyWeapon(WeaponName):
	wp = Bladex.GetEntity(WeaponName)
	wp.Alpha=1.00
	wp.RasterMode="Read"
	wp.CastShadows=0
	AuxFuncs.FadeObject(WeaponName, 1.00, 0.0, 4.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, DumpMe,(wp.Name,))
	
	
	
	
def ConsiderSwitchToSwords(EntityName):
	me=Bladex.GetEntity(EntityName)
	if me and me.Life>0 and me.ActiveEnemy:
		if not AmIArmed(EntityName):
			me.Data.DrawWeapons(EntityName)
			return 1
		return 0
	return 0	

###########################################################################################################################################################

KatanaWepHit=[5, 9, 16, 28, 40, 50, 70, 90, 120, 145, 175, 210, 250, 300, 380, 440, 530, 600, 670, 750]
WepHit=[3, 5, 10, 18, 25, 35, 45, 65, 85, 100, 120, 150, 180, 220, 270, 330, 400, 480, 540, 700]
WepDef=[0, -3, -5, -10, -15, -20, -25, -30, -35, -40, -45, -50, -55, -60, -65, -70, -75, -80, -85,-90]


TwinWeapons=["ProRHWep2","ProRHWep3","ProRHWep4","ProBlade5"]
Weapons2H=["ProKatana1"]




# Only dedicated Dorcas weapons will be upgraded




def SetWeaponsDamage(entityname):
	global KatanaWepHit
	global WepHit
	global WepDef
	global TwinWeapons
	global Weapons2H
	per=Bladex.GetEntity(entityname)
	if per.Kind != "Fem1Wiz":
		return
	
	lvl=per.Level
	inv=per.GetInventory()
	if lvl >=19:
		icedamR=3000
		firedamR=3000
	else:
		icedamR=per.Data.IceDamage[lvl]
		firedamR=per.Data.FireDamage[lvl]
	if not Reference.EntitiesObjectData.has_key(entityname):
		 Reference.EntitiesObjectData[entityname]=Reference.DefaultObjectData[per.Kind]
	if lvl>19:
		HITPOW=WepHit[19]
	else:
		HITPOW=WepHit[lvl]
	Reference.EntitiesObjectData[entityname][1]=HITPOW
	
	ldwp=Bladex.GetEntity(per.Data.DummyLHEdgeName)
	if ldwp:
		if lvl>19:
			WEPOW=WepHit[19]
			WEPDEF=WepDef[19]
			
		else:
			WEPOW=WepHit[lvl]
			WEPDEF=WepDef[lvl]
			
		Reference.EntitiesObjectData[ldwp.Name]=[Reference.OBJ_WEAPON, WEPOW, 0, 1.0,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,],["Electric",+1.0]]
		per.Data.SetLHDamage(per.Name) ## To set correct special damage
	
	
	for x in range(inv.nWeapons):
		weapon_name = inv.GetWeapon(x)
		wp=Bladex.GetEntity(weapon_name)
		wptype=wp.Kind
		if wp and wp.Kind in TwinWeapons:
			if lvl>19:
				WEPOW=WepHit[19]
				WEPDEF=WepDef[19]
			else:
				WEPOW=WepHit[lvl]
				WEPDEF=WepDef[lvl]
			Reference.EntitiesObjectData[wp.Name]=[Reference.OBJ_WEAPON, WEPOW, WEPDEF, 4.0,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,],["Nothing",+1.0]]
			if wptype=="ProRHWep3":
				Reference.EntitiesObjectData[wp.Name][6]=["Ice",+icedamR]
				print "Setting Ice damage on RH Ice sword"
			elif wptype=="ProRHWep4":
				Reference.EntitiesObjectData[wp.Name][6]=["Fire",+firedamR]
				print "Setting Ice damage on LH Ice sword"
					
			print wp.Name," Upgraded"
			
			
		elif wp.Kind in Weapons2H:
			if lvl>19:
				WEPOW=KatanaWepHit[19]
				WEPDEF=WepDef[19]
			else:
				WEPOW=KatanaWepHit[lvl]
				WEPDEF=WepDef[lvl]
			Reference.EntitiesObjectData[wp.Name]=[Reference.OBJ_WEAPON, WEPOW, WEPDEF, 1.0,  Reference.THR_SPINNING, [Reference.W_FLAG_2W,Reference.PI,2000,750,16000,0,Reference.GolpeArmaEscudoMetal]]
	
	



###########################################################################################################################################################

Bladex.AddParticleGType("NPCLevelUpParticle","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 
		aux=traux**0.5
	else:
		traux=i/25.0 
		aux=traux**2.0
	r=255
	g=255
	b=255
	a=255.0*traux
	size=200.0*aux
	Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)



###########################################################################################################################################################

def AllyDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded):
	# Only Masklin uses healing powers.....
	try:
		if WeaponName[:7] == "ProHeal":
			#print "I am being healed not damaged"
			if per.Life<CharStats.GetCharMaxLife(victim.Kind, victim.Level):
				victim.Life=CharStats.GetCharMaxLife(victim.Kind, victim.Level)
				if victim.Data.Poisoned:
					victim.Data.UnVenom ()
				#print VictimName," I have been healed"
			return
	except:
		print "Weird stuff in Damage Func"
	if AttackerName:
		attacker=Bladex.GetEntity(AttackerName)
		if attacker and attacker.Person: 
			if not CheckIfAlly(AttackerName):
				return
		if AttackerName=="Player1" and WeaponName:
			if WeaponName[:6]=="Entity":
				return
			wp=Bladex.GetEntity(WeaponName)
			try:
				weaponData = Reference.DefaultObjectData[wp.Kind]
			except KeyError:
				weaponData = Reference.EntitiesObjectData[WeaponName]
				
			if weaponData and len (weaponData) > 6:
				if weaponData[6][0]=="Venom":
					print "I have been poisoned by Player1 but I am Immune"
					return	
		
				
	Damage.CalculateDamage(VictimName, AttackerName, WeaponName, DamageType, DamageZone, DamageNode, x, y, z, Shielded)


##########################################################################################################################################################


class DorcasAllyChar (Ally_Def.NPCAlly):

	DeathFunc=None
	DeathArgs=()
	NPCLevelUpParticleData=[]
	LevelupFunc=None
	LevelupArgs=()
	Combatant=0
	Dusted=1
	OnGuard=0
	GuardPoint=50.0,-1000.0,50.0
	GuardLookPoint=0.0,0.0
	Agenum=0
	ThrowingObject=0
	
	def __init__(self, me):
		
		Ally_Def.NPCAlly.__init__(self, me)
	
		me.ImDeadFunc=self.NewImDeadFunc
		me.DamageFunc=AllyDamage
		
		self.NPCLevelUpParticleData=[]
		self.Combatant=0
		self.OnGuard=0
		self.GuardPoint=0,0,0
		self.GuardLookPoint=0,0
		self.Agenum=0
		self.ThrowingObject=0
		
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0 
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.NPCLevelUpParticleData.append(a)
			self.NPCLevelUpParticleData.append(size)
			Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
		
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=1.0
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		
		
		
		
		
		
	def NewImDeadFunc (self,EntityName):
		print EntityName+": NEW ImDeadFunc"
		me=Bladex.GetEntity(EntityName)
		rwp=Bladex.GetEntity(me.InvRight)
		lwp=Bladex.GetEntity(me.InvLeft)
		try:
			Ally_Def.NPCAlly.StdImDead(self,EntityName)
		except:
			pass
		if self.Dusted:
			Bladex.AddScheduledFunc(Bladex.GetTime()+32,RemoveMyCorpse,(EntityName,100,0,))
			if rwp:
				Reference.EntitiesSelectionData[rwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+35,RemoveMyWeapon,(rwp.Name,))
			if lwp:
				Reference.EntitiesSelectionData[lwp.Name]=()
				Bladex.AddScheduledFunc(Bladex.GetTime()+36,RemoveMyWeapon,(lwp.Name,))
		if self.DeathFunc:
			apply(self.DeathFunc,self.DeathArgs)
	
	
	
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		if not self.Dusted:
			return
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+20, RemoveMyWeapon,(obj_name,))
	
	
	
	def StdSeeEnemyUnreachable(self,EntityName,check1aaTo2aa=1):
		me = Bladex.GetEntity(EntityName)
		if self.IsArcher():
			return
		Ally_Def.NPCAlly.StdSeeEnemyUnreachable(self,EntityName)
	
	
	
	

	def StdChaseFailed(self,EntityName, oldActionMode):	
		me = Bladex.GetEntity(EntityName)
		if self.IsArcher():
			return 
		Ally_Def.NPCAlly.StdChaseFailed(self,EntityName,oldActionMode)
	
	
	def StopAttackingNPC (self,EntityName):
		if self.AttackingNPC:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life>0:
			     	ename=self.MyGetEnemyName()
			     	if ename:
					enemy = Bladex.GetEntity(ename)
					if not enemy:                                        
						print EntityName+": Cannot access handle to Player, in StopAttackingNPC()"
						Bladex.AddScheduledFunc(Bladex.GetTime() + self.AttackNPCTime, self.StopNPCsAttacking,(EntityName,))
						return
					if ename=="Player1" and self.IsArcher(): 
						print EntityName+": Why am I attacking the Player???"
						return
						
					#print EntityName+": Stopping attacking "+self.MyGetEnemyName()+" at time: "+`Bladex.GetTime()`
					Damage.DropInvalidObjectsOnImpact (EntityName)
					me.Wuea=Reference.WUEA_ENDED
					me.InterruptCombat()
					if me.SetEnemy(enemy):
						self.AttackingNPC=FALSE
						MaxCombatDist = Bladex.GetCharType(me.CharType,me.CharTypeExt).MaxCombatDist
						if me.SQDistance2(enemy) < (MaxCombatDist*MaxCombatDist) or me.CanISee(enemy):
							me.SetActiveEnemy(enemy)
							me.Chase(enemy, me.ActionAreaMax)
							if me.GetActionMode()==ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)
						else:
							me.LaunchWatch()
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.LaunchAnmType("attack_look",1)
						self.CheckToJoin (EntityName)
					else:
						print EntityName+": Cannot SetEnemy to Player, in StopAttackingNPC()"
						Bladex.AddScheduledFunc(Bladex.GetTime() + self.AttackNPCTime, self.StopNPCsAttacking,(EntityName,))
						return


		
	def LookAround90(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		self.ResetCombat(EntityName)###########
		inv=me.GetInventory()
		if inv.HasBow or self.OnGuard:	
			return
		trand= whrandom.randint(1,12)
		tvar=10+trand
		if self.Asleep:
			angle = me.Angle+PI*0.5
			if angle >= TWOPI:
				angle = angle - TWOPI
			me.Face(angle)
			Bladex.AddScheduledFunc(Bladex.GetTime()+ tvar, self.LookAround90,(EntityName,))
		
		
	def GetMyBowOut(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		inv= me.GetInventory()
		life = me.Life
		if life > 0.0:		
			left_type= Reference.GiveObjectFlag(me.InvLeft)
			if left_type != Reference.OBJ_BOW:
				me.SwitchToBow()
				if inv.GetSelectedWeapon() != me.InvRight and inv.GetSelectedWeapon() != me.InvLeft:
					# Launch the swap weapons animation
					out= ScorerActions.CB_WeaponOutX(EntityName,0)
					if not out:
						me.AnmEndedFunc= ScorerActions.CB_WeaponOutX
					Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, self.GetMyBowOut,(EntityName,),EntityName+"ReGetMyBowOut")

		
	
		
	def CheckDirection(self, EntityName):
		me=Bladex.GetEntity(self.Name)
		if self.OnGuard and not me.InCombat:
			Actions.TurnToFacePos(EntityName,self.GuardLookPoint[0],self.GuardLookPoint[1])
			self.GetMyBowOut(EntityName)
		#if me.RouteEndedFunc:
		#	me.RouteEndedFunc=None	
		print "checking I am looking right way ",EntityName
				
	
	
	
	
	
	def AmIAtMyPost(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if self.OnGuard:
			gx,gy,gz=self.GuardPoint
			for pname in Bladex.GetEntitiesAt(gx,gy,gz, 1000):
				ent=Bladex.GetEntity(pname)
				if ent and ent.Person:
					if ent.Life>0:
						if ent.Name==me.Name:
							print EntityName+": I am already near my post "
							return 1
						else:
							print EntityName+": I cannot return to post as someone is in the way "
							return 1
			return 0
	
	
	
	def GoBackToPost(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if self.OnGuard and not me.InCombat:
		
			if not self.AmIAtMyPost(EntityName):
				me.GoTo(self.GuardPoint[0],self.GuardPoint[1],self.GuardPoint[2])
				me.RouteEndedFunc=self.CheckDirection
				print EntityName+": I am returning to my post"
			else:
				self.CheckDirection(EntityName)
		
		
		
		
	def SetGuardPoint(self,lx=0.0,ly=0.0):
		me=Bladex.GetEntity(self.Name)
		x,y,z=me.Position
		self.GuardPoint=x,y,z
		self.GuardLookPoint=lx,ly
		
		
		
	def StdEnemyDead(self,EntityName):
		Ally_Def.NPCAlly.StdEnemyDead(self,EntityName)
		me=Bladex.GetEntity(EntityName)
		Reference.debugprint(EntityName+": My enemy is really dead.He he ! - py")
		newene= self.CheckForBadGuys()
		if newene and not me.InCombat:
			Actions.TurnToFaceEntity(EntityName, newene)
		else:
			if self.OnGuard:
				Bladex.AddScheduledFunc(Bladex.GetTime()+ 2.5, self.GoBackToPost,(EntityName,))
		

					
	def LookAround(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.RouteEndedFunc:
			me.RouteEndedFunc=None
		if me.Life>0:
			if not me.InCombat:
				if self.OnGuard and not self.CheckForBadGuys():
					self.GoBackToPost(EntityName)
					#me.RouteEndedFunc=self.CheckDirection(EntityName)
				else:
					nearene=self.CheckForBadGuys()
					if nearene:
						Actions.TurnToFaceEntity(me.Name,nearene)
						print "Looking to enemy"
					else:
						Actions.Turn180(me.Name)
					
					
				
	def DoINeedADrink(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		if me.Life>0:
			if not me.InCombat:
				AllyCombat.UsePotion(EntityName)

	

				
				
				
	def IsValidEnemy (self, entity):
		me=Bladex.GetEntity(self.Name)
		if entity.Person and entity.Life >0 and entity.Name != self.Name and entity.Name != "Player1" and not AllyCombat.CheckAlly (entity.Name) and (me.CanISee(entity)):
			return TRUE
		else:
			return FALSE
	

	
	def MyGetEnemyName (self):
		me=Bladex.GetEntity(self.Name)
	        if not self.EnemyName or Bladex.GetEntity(self.EnemyName).Life <=0:
                   	pjp = me.Position
		   	enemyList=[]
		   	pj_dir=me.Rel2AbsVector(0.0,-1.0,0.0)
			pjp=me.Position
			for ename in Bladex.GetEnemiesVisibleFrom(pjp,50000,pj_dir,0.0):
                       		ene=Bladex.GetEntity(ename)
                       		if self.IsValidEnemy(ene):
                         		enemyList.append(ene.Name)
                   	if len (enemyList) == 0: 
                   		#print "no baddies"
                   		self.EnemyName=None
                   		return None
                   	enemyList.sort(self.ChooseNearest)
                   	self.EnemyName=enemyList[0]
		enemy=Bladex.GetEntity(self.EnemyName)
		if self.EnemyName == "Player1": # This should not happen.....
			return None
                me.SetEnemy(enemy)
		return self.EnemyName		
	
	
	"""
	def StdEnterClose(self,EntityName):
		Ally_Def.NPCAlly.StdEnterClose(self,EntityName)
		self.RaiseAlarm(EntityName)
	"""
	
	def RaiseAlarm(self,EntityName):
		# called when an ally engages an enemy. Make all other allies turn to face enemy if they are not busy....
		me=Bladex.GetEntity(EntityName)
		print "Alarm raised by ",me.Name
		x,y,z=me.Rel2AbsPoint(0,2000,0)
		px,py,pz=me.Position
		for aname in Bladex.GetEntitiesAt(px,py,pz, 40000):
			ally=Bladex.GetEntity(aname)
                        if ally and ally.Person:
                		if ally.Life>0 and not ally.Blind and ally.Alpha>0.9 and not CheckIfAlly(ally.Name) and ally.Name!=me.Name and ally.Name!="Player1":
                			
                			dist=B3DLib.GetXZDistance(EntityName, ally.Name)
					if not ally.CanISee(me) and not ally.InCombat and not ally.Data.OnGuard and ally.Data.Combatant:
					
						if dist>12000 and dist <40000:
							ally.GoToJogging=1
							if ally.AstarState<>Ally_Def.ASTAR_SOLVED and not me.GetActionMode()!=Ally_Def.ROUTE_CHASE:
								ally.GoTo(x,y,z)
								me.RouteEndedFunc=self.LaunchMyWatch
								print ally.Name," I am responding to alert from ",me.Name
						else:
							Actions.TurnToFaceEntity(ally.Name,me.Name)
							me.RouteEndedFunc=self.LaunchMyWatch
							print ally.Name," I have been alerted"
	
	
	
	

	def StdSeeTheEnemy(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		life = me.Life
		if life > 0.0:		
			if not self.MyGetEnemyName(): 
				return
			#Reference.debugprint (EntityName + ": Who goes there!")
			
			ene=Bladex.GetEntity(self.MyGetEnemyName())
			if ene:
				if self.IsValidEnemy(ene):
					#Reference.debugprint (EntityName + " I see "+ene.Name+". - I will CARVE him up!")
					if self.Asleep:
						self.WakeMeUp(EntityName)
				me.LookAtEntity(ene.Name)
			
				#Just in case we were doing a wait animation
				if me.GetActionMode() == Ally_Def.ROUTE_BAY:	
					me.Wuea=Reference.WUEA_ENDED

				self.CheckToJoin(EntityName)
				if me.GetActionMode()!=Ally_Def.ROUTE_CHASE:
					self.StdStartChase(EntityName)
				
				if me.GetActionMode()==Ally_Def.ROUTE_BOWING: 
					if self.AimPressed:
						angle= Reference.TARGET_ANGLE_MAX- me.Accuracy*(Reference.TARGET_ANGLE_MAX-Reference.TARGET_ANGLE_MIN)
						if me.AimOffTarget<angle:
							print "Releasing Arrow"
							Actions.TestReleaseArrow(EntityName)
					else: 
						if me.Wuea!=Reference.WUEA_WAIT:
							print "Drawing Bow"
							Actions.TestDrawBow (EntityName)
				elif me.Aim or Actions.CurrentlyBowing(EntityName):
					me.Wuea=Reference.WUEA_ENDED
					Actions.EndBowMode(EntityName)
					me.SetOnFloor()
			else:
				print (EntityName + ": Cannot get a handle on me")
	
		
				

	
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		# launch appropriate hurt anim
		if self.Asleep:
			self.WakeMeUp(EntityName)
		
		Basic_Funcs.PlayerPerson.RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded)
		
		if AttackerName and AttackerName != 'BWorld' and AttackerName != EntityName:
			me = Bladex.GetEntity(EntityName)
			if me and me.Life > 0:
				#####################################################################
				# consider getting furious
				#chartype = Bladex.GetCharType(me.CharType,me.CharTypeExt)
				#if me.Life <= CharStats.GetCharMaxLife(me.Kind, me.Level)*0.25 and whrandom.random() < self.ChanceOfFuryOnHurt:
				#	self.GetFurious (EntityName)
				# consider attacking attacker back
				#damage_factor = DamagePoints / (me.Life+DamagePoints)
				#if damage_factor > me.Data.DamageFactorNone:
				#	# Only if I'm still alive... Death events handled apart
				####################################################################
				#Reference.debugprint(EntityName+": Im being attacked by "+AttackerName)
					
				if self.EnemyName and self.EnemyName != AttackerName:
					#Reference.debugprint(AttackerName+": Is NOT my current enemy")
					attacker = Bladex.GetEntity(AttackerName)
					##########################################
					
					
					#if attacker and (self.AttacksOwnKind or attacker.Kind != me.Kind):
					if attacker and CheckIfAlly(attacker.Name) and attacker.Name != "Player1": 
						if self.Asleep:
							self.WakeMeUp(EntityName)
						
						Reference.debugprint(EntityName+": I will respond")
						# Only attack NPCs if not already, otherwise we get multiple scheduled funcs
						if (not attacker.Data.NPC) or (not self.AttackingNPC):
							#Reference.debugprint("attacker.Data.NPC: "+ `attacker.Data.NPC`+ ", self.AttackingNPC: " + `self.AttackingNPC`)
								
							Damage.DropInvalidObjectsOnImpact (EntityName)
							me.Wuea=Reference.WUEA_ENDED
							me.InterruptCombat()
							me.SetEnemy(attacker)
							me.SetActiveEnemy(attacker)
							me.Chase(attacker, me.ActionAreaMax)
							if me.GetActionMode()==Enm_Def.ROUTE_CHASE and self.IsArcher():
								self.Switch2MeleeWeapons(EntityName)		
	
	
	
	
	
	
	def CheckForBadGuys(self):
		me=Bladex.GetEntity(self.Name)
		mypos=me.Position
		localenemylist=[]
		for ename in Bladex.GetEntitiesAt(mypos[0],mypos[1],mypos[2], 20000):
                	ene=Bladex.GetEntity(ename)
                	if ene:
                		if ene.Person:
                			if ene.Life>0 and ene.Alpha>0.9 and CheckIfAlly(ene.Name) and ene.Name!=me.Name and ene.Name!="Player1":
                				localenemylist.append(ene.Name)
                if len (localenemylist) == 0: 
                   	return None
		localenemylist.sort(self.ChooseNearest)
                return localenemylist[0]
	
	
	def ChooseNearest (self,entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)
		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST
		me=Bladex.GetEntity(self.Name)
		val = me.SQDistance2(p1) - me.SQDistance2(p2)

		if val < 0:
			return CHOOSE_FIRST
		elif val > 0:
			return CHOOSE_SECOND
		else:
			return CHOOSE_EITHER

	

	def LookForAnotherOpponent(self,EntityName):
		Reference.debugprint(EntityName+": I am looking for another opponent")
		me = Bladex.GetEntity(EntityName)
		if me.InCombat:
			return
		self.LaunchMyWatch (EntityName)
		mep=me.Position
		allyenelist=[]
		ents=Bladex.GetEntitiesAt(mep[0],mep[1],mep[2], 25000)
		for ename in ents:
			en=Bladex.GetEntity(ename)
			if en.Person:
				if self.IsValidEnemy(en) and en.Name != me.Name:
					allyenelist.append(en.Name)
		if len (allyenelist) == 0: 
                   	return 
                allyenelist.sort(self.ChooseNearest)
                nearest=Bladex.GetEntity(allyenelist[0])
                if nearest and not me.InCombat:
			me.GoToJogging=0
			me.GoTo(nearest.Position[0],nearest.Position[1],nearest.Position[2])
			print EntityName+" I have found a new enemy and I am going to sort the bugger out "
					
                    				
                    				
	
	def StdDelayNoSeen(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		if me.Life > 0:
			if not self.MyGetEnemyName():
				if (not self.Asleep) and (not me.Blind):
					if me.Aim or Actions.CurrentlyBowing(EntityName):
						me.Wuea=Reference.WUEA_ENDED
						Actions.EndBowMode(EntityName)
						me.SetOnFloor()
					Reference.debugprint(EntityName+": Im in NEWStdDelayNoSeen")
					me.StopLooking()
					self.PutMeToSleep(EntityName)
					if not self.EnemyName and not self.OnGuard:
						self.LookForAnotherOpponent(EntityName)
						
					else:
						self.LookAround(EntityName)
						
					Reference.debugprint(EntityName+": I have got bored and dropped off to sleep")		
					
					if me.GetActionMode() != Ally_Def.ROUTE_CHASE:
						if me.GetActionMode() != Ally_Def.ROUTE_SINGLE and me.GetActionMode() != Ally_Def.ROUTE_BAY:
							Reference.debugprint(EntityName+": I am not chasing")
							self.LaunchMyPatrol(EntityName)
					else:
						Reference.debugprint(EntityName+": I am chasing")
						if me.AstarState<>Ally_Def.ASTAR_SOLVED:
							# Face enemy as much as possible
							lastseenpos = me.EnemyLastSeen
							me.StartLooking(lastseenpos[0], lastseenpos[1], lastseenpos[2])
							if Actions.IsFacingPos(EntityName, lastseenpos[0], lastseenpos[2]):
								self.LaunchMyWatch (EntityName)
						else:
							Actions.TurnToFacePos(EntityName, lastseenpos[0], lastseenpos[2])
							me.RouteEndedFunc=self.LaunchMyWatch
			else:
				Reference.debugprint(EntityName+": I can't go to sleep yet, I have an enemy")
		
		
		
				
	def PutMeToSleep(self,EntityName):
		if not self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=1  
			self.Asleep = TRUE

	def WakeMeUp(self,EntityName):
		if self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=0  
			self.Asleep = FALSE
			
			
	def ReturnToStart(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		me.GoTo(self.GuardPoint[0],self.GuardPoint[1],self.GuardPoint[2])
		Reference.debugprint(EntityName+": I am going back to start")
	

	
	
	
	
	
	# Functions for loading and saving state
	def __getstate__(self):	
		NPCPerson_state=Ally_Def.NPCAlly.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["DorcasAllyChar"]=(GameStateAux.SaveFunctionAux(self.DeathFunc),
						      self.DeathArgs,
		                                      GameStateAux.SaveFunctionAux(self.LevelupFunc),
		                                      self.LevelupArgs,
		                                      self.Combatant,
		                                      self.Dusted,
		                                      self.OnGuard,
		                                      self.GuardPoint,
		                                      self.Agenum,
		                                      self.ThrowingObject)
		return NPCPerson_state
	
	def __setstate__(self,parm):
		Ally_Def.NPCAlly.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["DorcasAllyChar"]
			GameStateAux.LoadFunctionAux(parms[0],self,"DeathFunc")
			self.DeathArgs=parms[1]
			GameStateAux.LoadFunctionAux(parms[2],self,"LevelupFunc")
			self.LevelupArgs=parms[3]
			self.Combatant=parms[4]
			self.Dusted=parms[5]
			self.OnGuard=parms[6]
		        self.GuardPoint=parms[7]
		        self.Agenum=parms[8]
		        self.ThrowingObject=parms[9]
		       
			
		self.NPCLevelUpParticleData=[]
		for i in range(30):
			if i>25:
				traux=(30.0-i)/5.0 
				aux=traux**0.5
			else:
				traux=i/25.0
				aux=traux**2.0
			r=255
			g=255
			b=255
			a=255.0*traux
			size=200.0*aux
			self.NPCLevelUpParticleData.append(a)
			self.NPCLevelUpParticleData.append(size)
		Bladex.SetParticleGVal("NPCLevelUpParticle",i,r,g,b,a,size)
				
		self.lupsnd1=Bladex.CreateSound("..\\..\\Sounds\\aparicion-escudo.wav", "LUPSnd1")
		self.lupsnd1.Volume=1.0
		self.lupsnd1.MinDistance=10000
		self.lupsnd1.MaxDistance=30000	
		me=Bladex.GetEntity(self.Name)
		me.ImDeadFunc=self.NewImDeadFunc
		
		

##########################################################################################################################################################


class NPCDorcas (DorcasAllyChar):

	
	IceDamage=[3,5,10,20,30,40,50,60,80,110,150,200,260,380,500,600,750,900,1500,2000]
	FireDamage=[3,5,10,20,30,40,50,60,80,110,150,200,260,380,500,600,750,900,1500,2000]
	DummyLHEdgeName=""

	def __init__(self, me):
		DorcasAllyChar.__init__(self, me)
		
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		
		
		me.AddAnmEventFunc("StartL_Weapon",self.StartLWepDamage)
		me.AddAnmEventFunc("StopL_Weapon",self.StopLWepDamage)		
		
		self.IceDamage=[3,5,10,20,30,40,50,60,80,110,150,200,260,380,500,600,750,900,1500,2000]
		self.FireDamage=[3,5,10,20,30,40,50,60,80,110,150,200,260,380,500,600,750,900,1500,2000]
		
		self.DummyLHEdgeName=""
		
		self.AttachLHEdge()
		
		
	def ResetSounds(self, EntityName):
		me=Bladex.GetEntity(EntityName)
		import AniSoundDorcas
		AniSoundDorcas.AsignarSonidosDorcas(EntityName)
		Bladex.ReadBitMap("../../Maps/WizardsDomain/NUFiles/NUDorcasStuff/DorcasIcon.bmp","DorcasIcon")
		Reference.EnemiesScorerData[self.Name]=("DorcasIcon","Dor")	
		
	
	
	def SetLHDamage(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		extravenomdam=me.Level+1
		lvl=me.Level
		if lvl >=19:
			icedam=3000
			firedam=3000
		else:
			icedam=self.IceDamage[lvl]
			firedam=self.FireDamage[lvl]
		lwp=Bladex.GetEntity(me.InvLeft)
		if lwp:
			Lkind=lwp.Kind
			if self.DummyLHEdgeName:
				if Lkind=="ProLHWep2":
					Reference.EntitiesObjectData[self.DummyLHEdgeName][6]=["Venom",+extravenomdam]
					print "Setting Venom damage on dummy edge"
				elif Lkind=="ProLHWep3":
					Reference.EntitiesObjectData[self.DummyLHEdgeName][6]=["Ice",+icedam]
					print "Setting Ice damage on dummy edge"
				elif Lkind=="ProLHWep4":
					Reference.EntitiesObjectData[self.DummyLHEdgeName][6]=["Fire",+firedam]
					print "Setting Fire damage on dummy edge"
	
	
	
	
	def OnKilledEnemy(self,KilledEntityName):
		Reference.debugprint ("Ally Char: I have killed something!")
		KilledEntity=Bladex.GetEntity(KilledEntityName)
		if KilledEntity is None:
			return
		if KilledEntity.Name=="Player1":
			Reference.debugprint ("Ally Char: I have killed the Player")
			return
		me=Bladex.GetEntity(self.Name)
		
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 3.5, self.LookAround, (self.Name,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 4.5, self.DoINeedADrink,(self.Name,))
		me.PartialLevel=me.PartialLevel+CharStats.GetCharExperienceReward(KilledEntity.CharType,KilledEntity.Level)
		LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
		import Scorer
		if me.PartialLevel>=LevelLimit and me.Life>0:
			while me.PartialLevel>=LevelLimit:
				me.PartialLevel=me.PartialLevel-LevelLimit
				me.Level=me.Level+1
				LevelLimit=CharStats.GetCharExperienceCost(me.CharType,me.Level)
			maxlevel=CharStats.GetMaxLevel()
			maxsize=50+(140/maxlevel)*me.Level 
			maxPPS=120+(600/maxlevel)*me.Level 
			maxint=0.5+(4.5/maxlevel)*me.Level 
			AuraParams=(5, 0, 1, 0, 0, 1)
			AuraGradient=(2, 0.4, 0.6, 1.0, 0.5, 0.0, 0.1, 0.2, 1.0, 0.0, 0.8)
			AuraVar1Args=(5, maxsize, 0, 1, 0.5)
			AuraVar2Args=(maxsize, 5, 1, 0, 1.0)
			PSParams=(self.NPCLevelUpParticleData, "NPCLevelUpParticle", 30, 50, 150, 255, maxPPS, -600, 0.0, 2, 2, 0.4, 30, 0.5)
			GenFX.LevelUpFX(me.Name, 1, AuraParams, AuraGradient, AuraVar1Args, AuraVar2Args, PSParams, maxint, "Timer15", 15)
			if me.Life >0: # If an enemy death by poison or trowed weapons and.. You are death!
				me.ResetWounds()
				me.Life = CharStats.GetCharMaxLife(me.Kind, me.Level)
			self.lupsnd1.Play(me.Position[0],me.Position[1],me.Position[2],0)
			
			SetWeaponsDamage(self.Name)
			self.SetLHDamage(self.Name)
			
			if self.LevelupFunc:
				apply(self.LevelupFunc,self.LevelupArgs)
				me=Bladex.GetEntity(self.Name)
				print "Applying Level Up Func -> ", me.Name
				
					

	def ResetCombat (self,EntityName):		
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 100
			
			self.ChanceOfFuryOnHurt = 0.25
			self.ChanceOfFuryOnLeaderDeath = 1.00
			rwp=me.InvRight
			if rwp:
				print EntityName+"_Holding_"+rwp
				
				inv= me.GetInventory()
				if inv.HoldingShield: 
					me.BlockingPropensity = 1.0
					me.RangeDefenceCapable = TRUE
					print"I have a shield"
				else: 
					me.BlockingPropensity = 0.0
					me.RangeDefenceCapable = FALSE
					
				if Bladex.GetEntity(rwp).Kind in ("ProRHWep2","ProRHWep3","ProRHWep4"):
					me.AttackList = BCopy.deepcopy(DorcasTwinHandedAttackData)
					print"Dorcas Twin Sword Moves enabled"
					return

				flag=Reference.GiveWeaponFlag(rwp)
				if flag==Reference.W_FLAG_1H:
					me.AttackList = BCopy.deepcopy(DorcasOneHandedAttackData)
					print"Dorcas Sword Moves enabled"
					
				if flag==Reference.W_FLAG_2W:
					me.AttackList = BCopy.deepcopy(DorcasTwoHandedAttackData)
					print"Dorcas 2H Sword Moves enabled"
			
				if flag==Reference.W_FLAG_SP:
					me.AttackList = BCopy.deepcopy(DorcasSpearAttackData)
					print"Dorcas Spear Moves enabled"
			else:
				print EntityName+"_Holding nothing"
				                                                                      #if self.WeaponsStowed:
				me.AttackList = BCopy.deepcopy(DorcasUnarmedAttackData)
				print"Dorcas Unarmed Moves enabled"
				
					
			
			
			
			
	def StdEnterClose(self,EntityName):
		Ally_Def.NPCAlly.StdEnterClose(self,EntityName)
		self.RaiseAlarm(EntityName)
		self.DrawWeapons(EntityName)
		print "Dorcas entering close combat"
					
		
	def StowWeapons(self, EntityName):
		if AmIArmed(EntityName):
			me = Bladex.GetEntity(EntityName)
			Actions.StdToggleWeapons(EntityName)
			Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,self.ResetCombat,(EntityName,))
			print "Dorcas stowing weapons"
			
		
	def DrawWeapons(self, EntityName):
		print "Dorcas draw weapons"
		if not AmIArmed(EntityName):
			me = Bladex.GetEntity(EntityName)
			Actions.StdToggleWeapons(EntityName)
			Bladex.AddScheduledFunc(Bladex.GetTime()+1.0,self.ResetCombat,(EntityName,))
			print "Dorcas weapons drawn"
		
		
	def WakeMeUp(self,EntityName):
		Reference.debugprint(EntityName+": I am waking up")
		if self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=0  
			self.Asleep = FALSE	
		if not AmIArmed(EntityName):
			self.DrawWeapons(EntityName)
				
				
	def PutMeToSleep(self,EntityName):
		Reference.debugprint(EntityName+": I am going to sleep")
		if not self.Asleep:
			me = Bladex.GetEntity(EntityName)
			me.Blind=1  
			self.Asleep = TRUE
			self.LookAround90(EntityName)
			if not me.InCombat and AmIArmed(EntityName):
				self.StowWeapons(EntityName)
				Reference.debugprint(EntityName+": I am not busy so I will sheathe my weapon")
		
		

	def AttachLHEdge(self):
		me = Bladex.GetEntity(self.Name)
		dedge=Bladex.CreateEntity(self.Name+"DummyEdge","ProLHWep2Edge",58700.0,-960.0,380.0, "Weapon")
		dedge.Alpha=0.0
		dedge.RasterMode="Read"
		dedge.RasterMode="AdditiveAlpha"
		dedge.CastShadows=0
		# Fem1Wiz -Dorcas - has extra Anchor in mesh -Blade_Anchor_21
		me.LinkAnchors("21",dedge,"1H_R")
		self.DummyLHEdgeName=dedge.Name
		


	def StartLWepDamage(self, EntityName, EventName):
		ledge=Bladex.GetEntity(self.DummyLHEdgeName)
		if ledge:
			ledge.MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
			ledge.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
		
		
	def StopLWepDamage(self, EntityName, EventName):
		ledge=Bladex.GetEntity(self.DummyLHEdgeName)
		if ledge:
			ledge.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
			ledge.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
			Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, self.StopLAfterInterupt,())



	def StopLAfterInterupt(self):
		print "Damage OFF again"
		ledge=Bladex.GetEntity(self.DummyLHEdgeName)
		if ledge:
			ledge.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
			ledge.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)



	# Functions for loading and saving state
	def __getstate__(self):	
		NPCAlly_state=DorcasAllyChar.__getstate__(self)
		if(NPCAlly_state[0]!=1):
			return NPCAlly_state
		NPCAlly_state[1]["NPCDorcas"]=(self.DummyLHEdgeName)
		return NPCAlly_state
	
	
	def __setstate__(self,parm):
		DorcasAllyChar.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["NPCDorcas"]
			self.WeaponsStowed=parms[0]
			DummyLHEdgeName=parms[1]
			me=Bladex.GetEntity(self.Name)
			me.AddAnmEventFunc("StartL_Weapon",self.StartLWepDamage)
			me.AddAnmEventFunc("StopL_Weapon",self.StopLWepDamage)		
			self.IceDamage=[3,5,10,20,30,40,50,60,80,110,150,200,260,380,500,600,750,900,1500,2000]
			self.FireDamage=[3,5,10,20,30,40,50,60,80,110,150,200,260,380,500,600,750,900,1500,2000]




			
DorcasTwinHandedAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
            
            					
	    [AllyCombat.ATTACK, 0.20,("GM1_1H",),500.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.20,("GM2_1H",),500.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM3_1H",),500.0, 1800.0, 2500.0, 0.35],            
	    [AllyCombat.ATTACK, 0.20,("GM4_1H",),500.0, 1800.0, 2500.0, 0.35],             
	    [AllyCombat.ATTACK, 0.05,("GI_1H",), 500.0, 1800.0, 2500.0, 0.35],
					
	    [AllyCombat.ATTACK, 0.05,("GM91_1H",),0.0, 1000.0, 2200.0, 0.35],	
	    [AllyCombat.ATTACK, 0.05,("GM92_1H",),200.0, 1000.0, 2200.0, 0.35],	
	    [AllyCombat.ATTACK, 0.05,("GM93_1H",),200.0, 1000.0, 2200.0, 0.35],	
	    [AllyCombat.ATTACK, 0.05,("GM94_1H",),200.0, 1000.0, 2200.0, 0.35],
	    [AllyCombat.ATTACK, 0.05,("GM95_1H",),800.0, 1200.0, 2500.0, 0.35],	
	    [AllyCombat.ATTACK, 0.05,("GM96_1H",),800.0, 1200.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.02,("GM91_1H","GM37_1H"),800.0, 1200.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM3_1H",) ,500.0, 1200.0, 2500.0, 0.35],            
	    [AllyCombat.ATTACK, 0.02,("GM4_1H",),500.0, 1200.0, 2500.0, 0.35],              
]		
		
			
			
DorcasOneHandedAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.30,("GM1_1H",),500.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.20,("GM2_1H",),500.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM3_1H",),500.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.20,("GM4_1H",),500.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.05,("GI_1H",), 500.0, 1800.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM23_1H",),500.0, 1200.0, 2200.0, 0.35],
	
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]		
		
			
			
DorcasTwoHandedAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            #[AllyCombat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.15,("GI_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM4_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM2_2H",),500.0, 1000.0, 2500.0, 0.35],      
	    [AllyCombat.ATTACK, 0.10,("GM3_2H",),500.0, 1000.0, 2500.0, 0.35],      
	    [AllyCombat.ATTACK, 0.15,("GM1_2H",),500.0, 1000.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.15,("GM23_2H",),500.0, 1000.0, 2800.0, 0.35],    
	    [AllyCombat.ATTACK, 0.12,("GM1_2H","GM9_2H",),500.0, 1000.0, 2800.0, 0.35],    
	    [AllyCombat.ATTACK, 0.12,("GM2_2H","GM10_2H",),500.0, 1000.0, 2800.0, 0.35],    
	    [AllyCombat.ATTACK, 0.05,("GM3_2H","GM8_2H",),500.0, 1000.0, 2800.0, 0.35],   
	    [AllyCombat.ATTACK, 0.12,("GM4_2H","GM11_2H",),500.0, 1000.0, 2800.0, 0.35], 
	    [AllyCombat.ATTACK, 0.05,("GI_2H","GM12_2H",),500.0, 1000.0, 2800.0, 0.35], 
	    
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]		
		
			
			
DorcasSpearAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.25, AllyCombat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.8, ("GM15_SP",),1200.0, 1600.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.8, ("GM10_SP",),1200.0, 1600.0, 2500.0, 0.35],
	    [AllyCombat.ATTACK, 0.05, ("GI_SP",) ,1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.05, ("GMI_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.05, ("GM8_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.05, ("GM6_SP",),1200.0, 1800.0, 2500.0, 0.35], 
	    [AllyCombat.ATTACK, 0.05, ("GM3_SP",),1200.0, 1800.0, 2500.0, 0.35], 
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]		
		
		
DorcasUnarmedAttackData = [
           # inner zone blocks:
            [AllyCombat.BLOCK,  0.08, (),                   500.0, 1000.0, 3000.0, 0.35],
            [AllyCombat.BLOCK,  0.05, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [AllyCombat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [AllyCombat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.35, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [AllyCombat.BLOCK,  0.10, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
            [AllyCombat.ATTACKDOWN, 0.90, ("STAIRS",),         1200.0, 1400.0, 2500.0, 0.35],
            
             # outer zone moves:
            [AllyCombat.MOVE,   0.06, "tr",                5001.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, "tl",                5002.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.15, "tb",                5003.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.05, "tf",                5004.0, 7000.0, 9000.0, 0.50, 1],
            [AllyCombat.MOVE,   0.06, AllyCombat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            [AllyCombat.MOVE,   0.05, ConsiderSwitchToSwords,       1800.0, 3500.0,9000.0, 0.35],
            
            [AllyCombat.ATTACK, 0.8, ("GM21_NO",),500.0, 1000.0, 1500.0, 0.35],
	    [AllyCombat.ATTACK, 0.8, ("GM22_NO",),500.0, 1000.0, 1500.0, 0.35],
	    [AllyCombat.ATTACK, 0.8, ("GM23_NO",),500.0, 1000.0, 1500.0, 0.35],
            
            # inner zone moves:
            [AllyCombat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.35],
            [AllyCombat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.35],
            
           # dodges:
            [AllyCombat.DODGE,  0.25, "d_r",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.25, "d_l",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.DODGE,  0.00, "d_b",                500.0, 1200.0, 2800.0, 0.35],
            [AllyCombat.ATTACK, 0.60, "RespectDistance",      0.0,  500.0, 1000.0, 0.30, 1],
]		
			