import Bladex
import ItemTypes
import Sparks
import ObjStore
import GameStateAux
import InitDataField
import B3DLib
import Actions
import Reference
import math








##########################################################################################################################################################
########### Weapons

class RightHandSword(ItemTypes.PersistantItemType):
	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		
		self.WeaponFX= None
		AddDorcasWeaponFX(me.Name, self)
		self.Name= me.Name

	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["RightHandSword"]=(self.Name, self.WeaponFX)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["RightHandSword"]
			self.WeaponFX=parms[0]
			self.Name= parms[1]
		else:
			AddDorcasWeaponFX(me.Name, self)
			self.Name=""




class ShieldSword(ItemTypes.PersistantItemType):
	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		
		self.WeaponFX= None
		AddDorcasWeaponFX(me.Name, self)
		self.Name= me.Name
		Sparks.MakeShield(self.Name)
	
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["ShieldSword"]=(self.Name, self.WeaponFX)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["ShieldSword"]
			self.WeaponFX=parms[0]
			self.Name= parms[1]
		else:
			AddDorcasWeaponFX(me.Name, self)
			self.Name=""

	
		
## FX


class DorcasWeaponFX:

	def __init__(self, WeaponName, auraparams, auragradient, prtldata, lightdata):
		self.ObjId= ObjStore.GetNewId()
		ObjStore.ObjectsStore[self.ObjId]= self
		weapon=Bladex.GetEntity(WeaponName)
		self.WeaponName=WeaponName
		self.Aura=None
		self.Particles=None
		self.Light=None
		if auraparams:
			s, a, ci, f, b, am=auraparams
			m, r1, g1, b1, a1, imd, r2, g2, b2, a2, emd=auragradient
			self.Aura=Bladex.CreateEntity(WeaponName+"Aura", "Entity Aura", 0, 0, 0)
			self.Aura.SetAuraParams(s, a, ci, f, b, am)
			self.Aura.SetAuraGradient(m, r1, g1, b1, a1, imd, r2, g2, b2, a2, emd)
			weapon.Link(self.Aura)
			self.Aura.SetAuraActive(1)
		if prtldata:
			pt, pps, v, nv, rv, g, fr, ff, t2l=prtldata
			self.Particles=Bladex.CreateEntity(WeaponName+"Particles", "Entity Particle System Dobj", 0, 0, 0)
			self.Particles.ObjectName=WeaponName
			self.Particles.ParticleType=pt
			self.Particles.PPS=pps
			self.Particles.Velocity=v
			self.Particles.NormalVelocity=nv
			self.Particles.RandomVelocity=rv
			self.Particles.YGravity=g
			self.Particles.Friction=fr
			self.Particles.FollowFactor=ff
			self.Particles.Time2Live=t2l
		if lightdata:
			i, color, fl=lightdata
			self.Light=Bladex.CreateEntity(WeaponName+"Light", "Entity Spot", 0, 0, 0)
			self.Light.Intensity=i
			self.Light.Color=color
			self.Light.Flick=fl
			self.Light.CastShadows=0
			self.Light.Visible=0
			weapon.Link(self.Light)



	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		return (1,
				self.ObjId,
				self.WeaponName,
				GameStateAux.SaveEntityAux(self.Aura),
				GameStateAux.SaveEntityAux(self.Particles),
				GameStateAux.SaveEntityAux(self.Light)
			)


	def __setstate__(self,parm):
		
		if parm[0]==1:
			self.ObjId= parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.WeaponName=parm[2]
			self.Aura=GameStateAux.LoadEntityAux(parm[3])
			self.Particles=GameStateAux.LoadEntityAux(parm[4])
			self.Light=GameStateAux.LoadEntityAux(parm[5])
		else:
			
			self.WeaponName=""
			self.Aura=""
			self.Particles=""
			self.Light=""
			self.ObjId= ObjStore.GetNewId()
			ObjStore.ObjectsStore[self.ObjId]=self



def AddDorcasWeaponFX(WeaponName, data):
	weapon=Bladex.GetEntity(WeaponName)
	if not weapon:
		print "El arma especificada no existe!"
		return
	if not data:
		InitDataField.Initialise(weapon)
		data= weapon.Data

	
	elif weapon.Kind in ("ProLHWep4","ProRHWep4"):
		auraparams=(40, 1, 1, 0, 0, 1)
		auragradient=(2, 0.8, 0.6, 0.0, 0.6, 0.0, 0.8, 0.1, 0.0, 0.0, 0.6)
		prtldata=("Llamita", 400, (0.0, 0.0, 0.0), 1.0, 0.0, -1000.0, 0.02, 0.0, 10)
		lightdata=(0.5, (255, 120, 0), 1)
		weapon.SelfIlum=0.3
		
	elif weapon.Kind in ("ProLHWep3","ProRHWep3"):
		auraparams=(10, 1, 1, 0, 0, 1)
		auragradient=(2, 0.9, 1.0, 1.0, 0.2, 0.1, 0.4, 0.8, 1.0, 0.2, 1.0)
		prtldata=("Vaho", 20, (0.0, 0.0, 0.0), 0.0, 1.0, 150.0, 0.02, 0.0, 60)
		lightdata=()
		weapon.SelfIlum=0.1
		weapon.Alpha=0.99
		weapon.RasterMode="AdditiveAlpha"
	
	else:
		print "No hay efecto definido para este tipo de arma!"
		return
	data.WeaponFX=DorcasWeaponFX(WeaponName, auraparams, auragradient, prtldata, lightdata)




###########################################################################################################################################################

class BoomerangWeapon(ItemTypes.PersistantItemType):
	Name=""
	Speed= 15000.0
	Spin= -0.8
	Axis= (1.0, 0.0, 0.0)
	OwnerName= "Player1"
	C= None
	TimeWeaponStarted= None
	R= None
	Rn= None
	w= None
	RSQdist=None
	WeaponActive= 0
	grasped= 0
	tFinished= None
	Weapon= None
	ThrownBy=None
	Target= None
	Time2Grasp=0.4 
	spinsound=None
	
	
	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon= 1
		self.Name= me.Name
		self.Speed= 15000.0
		self.Spin= -0.8
		self.Axis= (1.0, 0.0, 0.0)
		self.OwnerName= "Player1"
		self.C= None
		self.TimeWeaponStarted= None
		self.R= None
		self.Rn= None
		self.w= None
		self.RSQdist=None
		self.WeaponActive= 0
		self.grasped= 0
		self.tFinished= None
		self.Weapon= None
		self.ThrownBy=None
		self.Target= None
		self.Time2Grasp=0.4
		# Create a looped sound
		SoundName= "..\\..\\Sounds\\vueltas-en-el-aire.wav"
		self.spinsound= Bladex.CreateEntity (me.Name+"LoopSound", "Entity Sound", 0, 0, 0)
		self.spinsound.SetSound (SoundName)
		self.spinsound.MinDistance=5000
		self.spinsound.MaxDistance=30000
		me.Link(self.spinsound)
		
		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		ThrownByName=""
		WeaponName=""
		SpinSoundName=""
		if self.Weapon: WeaponName=self.Weapon.Name
		if self.ThrownBy: ThrownByName=self.ThrownBy.Name
		if self.spinsound: SpinSoundName=self.spinsound.Name
		
		state[1]["BoomerangWeapon"]=(self.Name,
								self.Speed,
								self.Spin,
								self.Axis,
								self.OwnerName,
								self.C,
								self.TimeWeaponStarted,
								self.R,
								self.Rn,
								self.w,
								self.RSQdist,
								self.WeaponActive,
								self.grasped,
								self.tFinished,
								WeaponName,
								ThrownByName,
								self.Target,
								self.Time2Grasp,
								SpinSoundName)
								
		
		return state
	
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["BoomerangWeapon"]
			ThrownByName=""
			WeaponName=""
			SpinSoundName=""
			
			(self.Name,
			self.Speed,
			self.Spin,
			self.Axis,
			self.OwnerName,
			self.C,
			self.TimeWeaponStarted,
			self.R,
			self.Rn,
			self.w,
			self.RSQdist,
			self.WeaponActive,
			self.grasped,
			self.tFinished,
			WeaponName,
			ThrownByName,
			self.Target,
			self.Time2Grasp,
			SpinSoundName)= parms
			
			if WeaponName: self.Weapon=Bladex.GetEntity(WeaponName)
			if ThrownByName: self.ThrownBy=Bladex.GetEntity(ThrownByName)
			if SpinSoundName: self.spinsound=Bladex.GetEntity(SpinSoundName)
			
		else:
			self.Name="Unnamed"


	
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return

		if owner.ActiveEnemy:
			enemy = Bladex.GetEntity(owner.ActiveEnemy)
			if enemy and enemy.Person:
				TargetPos= enemy.GraspPos ("ViewPoint")
		else:
			TargetPos= owner.Rel2AbsPoint(0,-10000.0,0.0)
	
		if weapon.TestHit:
			return

		Actions.RemoveFromInventory (owner, weapon, EventName)
		
		SourcePos= weapon.Position
		
		offsetx,offsety,offsetz= B3DLib.Scale(B3DLib.Normalize((TargetPos[0]-SourcePos[0], TargetPos[1]-SourcePos[1], TargetPos[2]-SourcePos[2])), 1000.0)
		TargetPos= TargetPos[0]+offsetx, TargetPos[1]+offsety, TargetPos[2]+offsetz

		self.C= (SourcePos[0]+TargetPos[0])*0.5, (SourcePos[1]+TargetPos[1])*0.5, (SourcePos[2]+TargetPos[2])*0.5
		self.TimeWeaponStarted= Bladex.GetTime()
		self.R= SourcePos[0]-self.C[0], SourcePos[1]-self.C[1], SourcePos[2]-self.C[2]
		self.RSQdist= abs(self.R[0]**2.0+self.R[1]**2.0+self.R[2]**2.0)
		moduloR= math.sqrt(self.RSQdist)
		scale= (moduloR/8.0) / math.sqrt(self.R[2]*self.R[2]+self.R[0]*self.R[0])
		self.Rn= -self.R[2]*scale, 0.0, self.R[0]*scale
		self.w = self.Speed / moduloR
		Bladex.SetAfterFrameFunc("DalWeaponMoveWeapon", self.MoveWeapon)
		self.WeaponActive= 0
		self.grasped= 0
		self.tFinished= Actions.TWOPI/self.w
		self.Weapon= weapon
		self.ThrownBy= owner  # this pointer may not be valid
		self.Time2Grasp= Bladex.GetAnimationDuration("Kgt_tke_r_02")*0.2
		self.spinsound.PlaySound(-1)
		weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
		InitDataField.Initialise(weapon)
		
	def MoveWeapon (self, time):
		self.Weapon.RemoveFromWorld()
		t= time-self.TimeWeaponStarted
		wt= self.w*t
		cos_wt= math.cos(wt)
		sin_wt= math.sin(wt)
		P= self.R[0]*cos_wt + self.Rn[0]*sin_wt, self.R[1]*cos_wt + self.Rn[1]*sin_wt, self.R[2]*cos_wt + self.Rn[2]*sin_wt
		self.Weapon.Position= P[0]+self.C[0], P[1]+self.C[1], P[2]+self.C[2]
		
		if wt>=Actions.TWOPI:
			owner=Bladex.GetEntity(self.OwnerName)
			if owner:
				inv= owner.GetInventory()
				inv.AddWeapon(self.Weapon.Name)
				if not owner.InvRight:
					inv.LinkRightHand(self.Weapon.Name)
			Bladex.RemoveAfterFrameFunc("DalWeaponMoveWeapon")
		elif wt >= Actions.PI*1.5:
			if self.WeaponActive:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
		elif wt >= Actions.PI and self.WeaponActive:
			owner=Bladex.GetEntity(self.OwnerName)
			if owner and owner.SQDistance2(self.Weapon) < self.RSQdist/2.0:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
		elif wt >= Actions.PI*0.5:
			if not self.WeaponActive:
				self.Weapon.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
				self.WeaponActive= 1
		
		if (not self.grasped) and t+self.Time2Grasp >= self.tFinished:
			self.grasped=1
			self.spinsound.StopSound()
			owner=Bladex.GetEntity(self.OwnerName)
			if owner and owner.Life>0:
				owner.Wuea=Reference.WUEA_ENDED
				owner.InterruptCombat()
				owner.LaunchAnmType("tke_r_02")
				#owner.LaunchAnmType("catch") The catch animation is too slow for Player chars
				# the PickupEvent bound to anim should update the katar damge if char levels up while weapon in flight
				
				
			else:
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				self.Weapon.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
				self.Weapon.Impulse(0,10,0)
				Bladex.RemoveAfterFrameFunc("DalWeaponMoveWeapon")
		# Angular velocity
		self.Weapon.RotateRel(0.0, 0.0, 0.0 ,self.Axis[0],self.Axis[1],self.Axis[2],self.Spin,1)



###########################################################################################################################################################


class WeaponSuriken(ItemTypes.PersistantItemType):

	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		
		self.OwnerName= "Player1"
		self.Name= me.Name
		self.SpecialExtraDamage= []
		
		
	def DropReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return		
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return	
		if weapon.TestHit:
			return
		Actions.RemoveFromInventory (owner, weapon, EventName)
		ix, iy, iz = owner.Rel2AbsVector(-1000.0, -1500.0, 0.0)
		weapon.Impulse(ix, iy, iz)
		weapon.ExcludeHitFor(owner)
		weapon.OnStopFunc=None
		owner.DelAnmEventFunc(EventName)
		Reference.EntitiesObjectData[weapon.Name]= [Reference.OBJ_ITEM]
		weapon.Data=ItemSuriken(weapon)
		
		
	
	def SurikenStopFunc(self, EntityName):
		weapon= Bladex.GetEntity(EntityName)
	
		if weapon:
			weapon.MessageEvent(Actions.MESSAGE_STOP_WEAPON,0,0)
			weapon.MessageEvent(Actions.MESSAGE_STOP_TRAIL,0,0)
			
			Reference.EntitiesObjectData[weapon.Name]= [Reference.OBJ_ITEM]
			weapon.Data=ItemSuriken(weapon)
			try:
				if weapon.Data.PrevHitFunc:
					weapon.HitFunc= weapon.Data.PrevHitFunc
					weapon.Data.PrevHitFunc= None
					weapon.HitFunc (EntityName)
			except AttributeError:
				pass
			if Reference.EntitiesObjectData.has_key (self.Name):
				print self.SpecialExtraDamage
				for damage in self.SpecialExtraDamage:
					print damage
					if damage in Reference.EntitiesObjectData[self.Name]:
						Reference.EntitiesObjectData[self.Name].remove (damage)
						print "Suriken damage restored"
			print"Suriken Stopped"
	
		
		
		
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= weapon.Parent
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return
		
		if weapon.TestHit:
			return
		
		weapon.ExcludeHitFor(owner)
		weapon.OnStopFunc=self.SurikenStopFunc
		
		lvl=owner.Level+1
		if lvl<=20:
			damfact=lvl*5
		else:
			damfact=100
		self.SpecialExtraDamage=[["Venom",+damfact],]
		if not Reference.EntitiesObjectData.has_key(self.Name):
			if weapon:
				Reference.EntitiesObjectData[self.Name]= BCopy.deepcopy(Reference.DefaultObjectData[weapon.Kind])
				print "Suriken data established"
		for damage in self.SpecialExtraDamage:
			Reference.EntitiesObjectData[self.Name].append (damage)
			print damage
				
		Actions.RemoveFromInventory (owner, weapon, EventName)

		if owner.Name=="Player1":
			F= owner.Data.ThrowForce*34000.0

			if owner.InCombat:
				target= Bladex.GetEntity(owner.ActiveEnemy)
				target_pos= target.Position
				source_pos= weapon.Position
				x= target_pos[0]-source_pos[0]
				y= target_pos[1]-source_pos[1]
				z= target_pos[2]-source_pos[2]

				angle, time= Actions.AutoCalcThrow (math.sqrt(x*x+z*z), y, F/weapon.Mass,+9800.0)
			elif EventName == "ThrowLightFacingEvent":
				angle= -PI*0.0625 
			elif EventName == "ThrowHeavyFacingEvent":
				angle= -PI*0.125 
			else:
				angle= -PI*0.0625 

			impulse = owner.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)

			if owner.InCombat:
				angle= B3DLib.Pos2PosXZAngle(source_pos[0], source_pos[1], source_pos[2],target_pos[0], target_pos[1], target_pos[2])
				diff_angle= min (max (B3DLib.DiffAngle(angle, owner.Angle), -Actions.FACINGANGLE), Actions.FACINGANGLE)
				x,y,z= impulse
				cos_ang= math.cos(diff_angle); sin_ang= math.sin(diff_angle)
				impulse = (x*cos_ang-z*sin_ang, y, x*sin_ang+z*cos_ang)

			weapon.Impulse(impulse[0], impulse[1], impulse[2])
			weapon.ExclusionMask= weapon.ExclusionMask | Actions.B_SOLID_MASK_PERSON

			axis= weapon.GetDummyAxis("1H_R", 0.0, 1.0, 0.0)
			mass= 2.0
			
			scale = TWOPI*10/mass
			weapon.AngularVelocity=axis[0]*scale,axis[1]*scale,axis[2]*scale
			weapon.MessageEvent(Actions.MESSAGE_START_WEAPON,0,0)
			weapon.MessageEvent(Actions.MESSAGE_START_TRAIL,0,0)
			InitDataField.Initialise(weapon)
			weapon.Data.PrevHitFunc= None
		
			
			weapon.Data.PrevInflictHitFunc= weapon.InflictHitFunc
			weapon.InflictHitFunc= Actions.ThrownWeaponInflictHitFunc
			weapon.Data.ThrownBy= owner
			owner.DelAnmEventFunc(EventName)
		
		
		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["WeaponSuriken"]=(self.Name,self.OwnerName,self.SpecialExtraDamage)
		return state
		
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["WeaponSuriken"]
			self.Name= parms[0]
			self.OwnerName= parms[1]
			self.SpecialExtraDamage=parms[2]
		else:
			self.Name= ""
			self.OwnerName= ""
			self.SpecialExtraDamage=[]
		
		
		
		
class ItemSuriken (ItemTypes.PersistantItemType):

	def __init__(self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon= 1
		self.Name= me.Name
		self.OwnerName=""
		Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_ITEM]
		Reference.EntitiesSelectionData[self.Name]=(8,4000,MenuText.GetMenuText('Suriken'))
		Reference.StackObjects['ProSuriken1']= 6
		weapon= Bladex.GetEntity(self.Name)
		InitDataField.Initialise(weapon)
		me.UseFunc = self.UseSuriken
	
	def UseSuriken(self, SurikenName, TipoUso):
		skn=Bladex.GetEntity(SurikenName)
		if TipoUso == Actions.USE_FROM_INV:
		   	ownerName= skn.Data.UsedBy
		   	Actions.FreeBothHands(ownerName)
		   	owner=Bladex.GetEntity(ownerName)
		   	if owner and owner.Life >0:
		   		owner.Data.throw_weapon = None
      	              	inv=owner.GetInventory()
      	              	inv.RemoveObject(SurikenName)
   	              	Change.ChangeObject(ownerName, SurikenName, self.FinishChange)
   	        elif TipoUso == Actions.USE_FROM_TAKE:
		   	Actions.StdUse (ownerName)


	def FinishChange(self, EntityName,ObjectName):
		skn=Bladex.GetEntity(ObjectName)
		newowner=Bladex.GetEntity(skn.Parent)
		if newowner.Name=="Player1":
	       		Reference.EntitiesObjectData[ObjectName]= [Reference.OBJ_STANDARD,   10, 0, 1.0, Reference.THR_SPINNING, []]
	       	else:
	       		Reference.EntitiesObjectData[ObjectName]= [Reference.OBJ_WEAPON,   10, 0, 1.0, Reference.THR_SPINNING, []]
		skn.Data=WeaponSuriken(skn)   
		
		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["ItemSuriken"]=   (				self.Name,
									self.OwnerName
								)
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["ItemSuriken"]
			self.Name=parms[0]
			self.OwnerName=  parms[1]		
		else:
			self.Name=""
			self.OwnerName= "Player1"
		
		
		
def MakeSuriken(name,pos,ori):
	su=Bladex.CreateEntity(name,"ProSuriken1",pos[0],pos[1],pos[2], "Weapon")
	su.Scale=1.0
	su.Orientation=(ori[0],ori[1],ori[2],ori[3])
	su.Impulse(0,0,0)
	su.Data=ItemSuriken(su)
	

