import Bladex
import Sparks
import CharStats
import pdb
import Reference
import Actions
import math
import AuxFuncs
import InitDataField
import Objects
import whrandom
import BCopy
import B3DLib
import netgame
import Damage
import Breakings
import Auras
import GenFX
import ObjStore
import GameStateAux
import BUIx
import ItemTypes
import MenuText
import Change
import AuxFuncs
import pocimac
import darfuncs
import AllyCombat
import Ally_Def
import Interpolator
import MasklinTypes
import MasklinMagic
import OnInitTake
import AniSound
import Combat
import Language
import Change
import copy
import WizardAllyTypes




TRUE = 1==1
FALSE = not TRUE

PI = math.pi
TWOPI = PI*2


CHOOSE_FIRST  = -1
CHOOSE_SECOND =  1
CHOOSE_EITHER =  0





### Class Definitions for Wizard Kit ###########################

def IsInWizardInv(EntityName):
	wepsihave=[]
	char=Bladex.GetEntity("Player1")
	if char.Kind!="Wizard_A":
		return 0
	inv=char.GetInventory()
	for id in range(inv.nWeapons):
		wp = inv.GetWeapon (id)
 		if wp:
    			mywp = Bladex.GetEntity(wp)
    			if mywp.Kind in ("ProStaff1","WizardSword"):
    				wepsihave.append(mywp.Name)
    				if EntityName in (wepsihave):
					return 1
	return 0	
	



class MagicWeapon(ItemTypes.ActivateableSpecialWeapon):

	WepDef=[0,-3, -5, -10, -15, -20, -25, -30, -35, -40, -45, -50, -55, -60, -65, -70, -75, -80, -85]
	
	
	def __init__ (self, me):
		ItemTypes.ActivateableSpecialWeapon.__init__(self, me)
		
        	self.WepDef=[0,-3, -5, -10, -15, -20, -25, -30, -35, -40, -45, -50, -55, -60, -65, -70, -75, -80, -85]
        	
		self.Activate()

	def Activate (self):
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 2.0 , self.UpdateDamage, (self.Name,), self.Name+" UpdateDamage")
		
	
	def UpdateDamage(self,EntityName):
		me=Bladex.GetEntity(EntityName)
		if IsInWizardInv(EntityName):
			char=Bladex.GetEntity("Player1")
			lvl=char.Level
			wepdef=0
			wepdam=1
			extradamage=0.0
			if lvl <=18:
				wepdef=self.WepDef[lvl]
				wepdam=lvl+1
			else:
				wepdef=-100
				wepdam=20
			if char.Data.MagicPower:
				extradamage= int(MasklinTypes.GetMagicLevelFactor())
				#print "Setting magic weapon extradamage to: ",extradamage
				Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_WEAPON,  wepdam,  wepdef, 1.0,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,], ["Electric", +extradamage]]
				
			else:
				Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_WEAPON,  wepdam,  wepdef, 1.0,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
			if self.Anointed:
				Reference.EntitiesObjectData[self.Name].append(["Weak",+1.0])
			
		else:
			#print EntityName,": I am not in Wizard Inventory "
			pass
				
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 8.0, self.UpdateDamage, (self.Name,), self.Name+" UpdateDamage")
		
	





class WizardStaff(MagicWeapon):

	liteparams=[(0.0, 0.55, (40, 40, 40))]
	Anointed=0
	
	def __init__(self, me):
		MagicWeapon.__init__(self, me)
		self.liteparams=[(0.0, 0.55, (40, 40, 40))]
		self.Anointed=0
		self.Activate()
				
	def ResetLite(self, EntityName):
		me = Bladex.GetEntity(EntityName)
		me.Lights=self.liteparams
		lo=AuxFuncs.GetSpot(me)
		lo.CastShadows=0
		
			
	def __getstate__(self):
		state= ItemTypes.ActivateableSpecialWeapon.__getstate__(self)
		state[1]["WizardStaff"]= (self.liteparams,self.Anointed)
		return state

	def __setstate__(self,parm):
		ItemTypes.ActivateableSpecialWeapon.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["WizardStaff"]
			self.liteparams=parms[0]
			self.Anointed=parms[1]
		else:
			self.liteparams=[(0.0, 0.55, (40, 40, 40))]
			self.Anointed=0
		

		
class WizardSword(MagicWeapon):

	def __init__(self, me):
		MagicWeapon.__init__(self, me)
		self.Anointed=0
		self.Scan()
	
	def Scan (self):
		Bladex.AddScheduledFunc(Bladex.GetTime()+ 7.0 , self.Scan2, (self.Name,), self.Name+" Scan2")
		
	
	def Scan2 (self, EntityName):
		me = Bladex.GetEntity(EntityName)
		
		if me:
			me.SelfIlum=0.3
			if MasklinTypes.IsHoldingSwordButNotFighting():
				pos=me.Position
				possibleenemies=Bladex.GetEntitiesAt(pos[0],pos[1],pos[2], 20000)
				
				for id in possibleenemies:
					en=Bladex.GetEntity(id)
					if en:
						if en.Person:
							if en.Life>0 and en.Alpha>0.90 and MasklinTypes.CheckIfAlly (en.Name) and en.Name != "Player1":
								#print "WizSword detects ",en.Name
								aura = Auras.MakeAura(me.Name, 2.0 ,(25,1.0,1.0,1,0,0), (),(),(2,  1.0,0.2,0.0, 1.0, 0.6  , 1.0,0.0,0.0, 0.0, 1.0))
								break
			Bladex.AddScheduledFunc(Bladex.GetTime()+ 8.0, self.Scan2, (self.Name,), self.Name+" Scan2")


	def __getstate__(self):
		state= ItemTypes.ActivateableSpecialWeapon.__getstate__(self)
		state[1]["WizardSword"]= (self.Anointed,)
		return state

	def __setstate__(self,parm):
		ItemTypes.ActivateableSpecialWeapon.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["WizardSword"]
			self.Anointed=parms[0]
		else:
			self.Anointed=0




class WizardShield:
	def __init__(self, me):
		me.Weapon=1
		self.Name= me.Name
		self.Rebound= 0.4
		Sparks.MakeShield(me.Name)
	
	def AbsorbFunc (self, AttackerName, WeaponName, DamagePoints):
		if not AttackerName:
			print "No AttackerName on Masklin Shield"
			return
	
		attacker= Bladex.GetEntity(AttackerName)
		if attacker and attacker.Person:
			effective_damage= max(DamagePoints*self.Rebound, 0.0)
			
			LastDamage= min (effective_damage, attacker.Life)
			if LastDamage>0 and not attacker.Data.Invincibility:
				attacker.Life= attacker.Life-LastDamage
			DamageZone=Reference.BODY_FRONT
			attacker.Data.RespondToHit(AttackerName, self.Name, LastDamage, "", DamageZone, 0)
		



class CarcajWizarddrug (ItemTypes.Quiver):
	pass

class CarcajWizarddrug_E (CarcajWizarddrug):
	pass

class CarcajWizarddrug1 (CarcajWizarddrug):
	pass

class CarcajWizarddrug2 (CarcajWizarddrug):
	pass


class WizardBow(ItemTypes.Arco):
	pass




class WolfClaw(ItemTypes.PersistantItemType):
	
	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		self.Name= me.Name
	
	def DropReleaseEventHandler (self,EntityName,EventName):
		me=Bladex.GetEntity(self.Name)
		if me.Alpha>0.9:
			me.Alpha=0
		
	
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		me=Bladex.GetEntity(self.Name)
		if me.Alpha>0.9:
			me.Alpha=0
		
		
		

class WolfHerb(ItemTypes.PersistantItemType):
	
	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		self.Name= me.Name
		me.UseFunc= self.RemoveClaw
	
		
	def RemoveClaw(self, ObjectName, use_from):
		user=Bladex.GetEntity("Player1")
		inv=user.GetInventory()
		me=Bladex.GetEntity(ObjectName)
		
		if user.MeshName == "Werewolf":
			rwp=Bladex.GetEntity(user.InvRight)
			if rwp and rwp.Kind=="ProWolfClaw":
				Actions.RemoveFromInventory (user, rwp, "")
	  			rwp.Position=0,50000,0
	  			#print rwp.Name, " Removed"
	  	Actions.TryToTake(user.Name,ObjectName)
	  	
	  	try:		
			me.UseFunc=None
			print "WH use func cancelled"
		except:
			print "WH use func NOT cancelled"
			pass
		
	
############################################################################################################################################################
########## Magic Recharge Potions

POTION_STATE_USED = 0
POTION_STATE_UNUSED = 1

POTION_TYPE_EAT = 0
POTION_TYPE_DRINK_RIGHT = 1
POTION_TYPE_GULP = 2
POTION_TYPE_DRINK_LEFT = 3




MAGIC_FOOD   = 0
MAGIC_POTION = 1

MagicTypeValues = {
	           "ProMagicPot1"    : ( 1000, MAGIC_POTION),
	           "ProMagicPot2"    : ( 2000, MAGIC_POTION),
	           "ProFern1"        : ( 500,  MAGIC_FOOD)
		  }



class MagicPotion:
	def __init__(self,pot):
		self.Hand = 0
		self.Estado = POTION_STATE_UNUSED
		self.MagicIncrease = 100
		self.Sonido=0
		self.Type = POTION_TYPE_DRINK_RIGHT
		self.OHand = ""		
		self.FadeDelta = (0.2 /60.0)
		self.Takeable=1
		self.DrinkFunc = 0
		self.DrinkFuncArguments = ()
		


	def IncrementMagic(self):
		UsedBy = Bladex.GetEntity(self.entity) # The Player
		UsedBy.Data.AddMagic(self.MagicValue)
		#pocimac.RestoreWoundsToLifeLevel(UsedBy.Name) # do I want this? - no
		self.Estado = POTION_STATE_USED



	def FadeOut(self,entity,timer):		
		poc = Bladex.GetEntity(entity)
		poc.Alpha = poc.Alpha - poc.Data.FadeDelta
		if len(poc.Lights):
			poc.Lights = [(poc.Alpha/2, poc.Lights[0][1], poc.Lights[0][2])]
		if poc.Alpha <= 0:
			poc.SubscribeToList("Pin")
			

			
def CanIUseTheMagicPotion(me):
	if me.Kind=="Wizard_A":
		if me.Data.MagicLevel>9990:
			import GameText
			import MenuText
			GameText.WriteTextAux(MenuText.GetMenuText("I can absorb no more magic"),2.0,255,255,255,[],None,1)
			return 0
		else:
			print "I CAN use the potion"
			return 1
	else:
		import GameText
		import MenuText
		GameText.WriteTextAux(MenuText.GetMenuText("I cannot use this magic item"),2.0,255,255,255,[],None,1)
		return 0
			
			
def MagicPotionNotDropped(entidad):
	char = Bladex.GetEntity(entidad)	
	object = Bladex.GetEntity(char.Data.obj_used)
	if object.Data.Estado == POTION_STATE_USED:
		SoltarPocima(entidad,0)
	else:
		object.ExcludeHitFor(char)
		inv = char.GetInventory()

		if object.Data.Type == POTION_TYPE_DRINK_LEFT:
			# In Combat and using left hand's second slot
			object.Data.Estado = POTION_STATE_UNUSED
			inv.LinkLeftHand2("None")
			inv.RemoveObject(object.Name)
			impulse = char.Rel2AbsVector(1000.0 * object.Mass, -1000.0 * object.Mass, 0.0)
			object.Impulse(impulse[0],impulse[1],impulse[2])
		else:
			object.Data.Estado = POTION_STATE_USED
			object.Data.Takeable= 0
			inv.LinkRightHand("None")		
			
			if object.Data.Hand == 1:
				char.AnmEndedFunc = RestoreHand

			inv.RemoveObject(char.Data.obj_used)
			impulse = char.Rel2AbsVector(-1000.0 * object.Mass, -1000.0 * object.Mass, 0.0)	
			object.Impulse(impulse[0],impulse[1],impulse[2])	




def RestoreHand(entidad):	
	char = Bladex.GetEntity(entidad)
	char.AddAnmEventFunc("ChangeREvent",Actions.ToggleWEvent)
	char.LaunchAnmType("Chg_r")


def TakeMagicPotionUsed():
	pass
	
	

def DropMagicPotion(Entidad,Evento = 0):
	char = Bladex.GetEntity(Entidad)
	char.AnmEndedFunc = ""
	if Evento:
		char.DelAnmEventFunc(Evento)
	object = Bladex.GetEntity(char.Data.obj_used)
	object.ExcludeHitFor(char)
	object.TimerFunc = object.Data.FadeOut
	object.SubscribeToList("Timer60")
	object.Data.Takeable=0
	inv = char.GetInventory()

	if object.Data.Type == POTION_TYPE_DRINK_LEFT:
		# In Combat and using left hand's second slot
		inv.LinkLeftHand2("None")
		inv.RemoveObject(char.Data.obj_used)
		impulse = char.Rel2AbsVector(1000.0 * object.Mass, -1000.0 * object.Mass, 0.0)
		object.Impulse(impulse[0],impulse[1],impulse[2])
	else:
		inv.LinkRightHand("None")		
		
		if object.Data.Hand == 1:			
			char.AnmEndedFunc = RestoreHand
		else:
			char.AnmEndedFunc= Actions.TakeStraightRecover
		inv.RemoveObject(char.Data.obj_used)
		impulse = char.Rel2AbsVector(-1000.0 * object.Mass, -1000.0 * object.Mass, 0.0)	
		object.Impulse(impulse[0],impulse[1],impulse[2])
	darfuncs.SetHint(object,"")
	OnInitTake.AddOnInitTakeEvent(object.Name,TakeMagicPotionUsed)


def PickMagicPotion(Entidad,Evento):
	char=Bladex.GetEntity(Entidad)
	char.DelAnmEventFunc(Evento)
	magpot = char.Data.obj_used		
	object = Bladex.GetEntity(char.Data.obj_used)

	inv = char.GetInventory()
	if object.Data.Type==3:
		inv.LinkLeftHand2(magpot)
	else:
		inv.LinkRightHand(magpot)
		
		
def TryToUseMagicPotion(me, object):
	if not MagicTypeValues.has_key(object.Kind):
		return 1
	if Reference.DefaultObjectData[object.Kind][0] == Reference.OBJ_ITEM:
		return 1
	return CanIUseTheMagicPotion(me)


Actions.TryToTakeCallBacks.append(TryToUseMagicPotion)


def BeberMagicPocima(Entidad,Evento):
	char = Bladex.GetEntity(Entidad)
	char.DelAnmEventFunc(Evento)
	Poti = Bladex.GetEntity(char.Data.obj_used)
	Pot = Poti.Data	
	Pot.Estado = POTION_STATE_USED
	Pot.Takeable=0
	char.Data.AddMagic(Pot.MagicIncrease)
	Pot.Sonido.Play(char.Position[0],char.Position[1],char.Position[2],0)

	if (Pot.DrinkFunc <> 0):
		Bladex.AddScheduledFunc(Bladex.GetTime(),Pot.DrinkFunc,Pot.DrinkFuncArguments)




def UseMagicPotion(PotName,TipoUso):
        print "Use Magic Potion"
	magpot = Bladex.GetEntity(PotName)
	char = Bladex.GetEntity(magpot.Data.UsedBy)
	if not CanIUseTheMagicPotion(char):
			return
	
	if (TipoUso == Actions.USE_FROM_INV and magpot.Data.Estado == POTION_STATE_UNUSED):
		magpot.Data.Hand = 0
		char.Data.obj_used = PotName
		char.AnmEndedFunc = MagicPotionNotDropped
		# Use from inventory		
		magpot.Data.Type = 1
		if not char.InvRight:
			UseMagicPotion2(PotName)
		else:
			if char.InCombat:
				if not char.InvLeft2:
					magpot.Data.Type = 3					
					magpot.LaunchAnmType("attack_drink")
					magpot.AddAnmEventFunc("PickBottle",PickMagicPotion)
					magpot.AddAnmEventFunc("drinkingEvent",BeberMagicPocima)		
					magpot.AddAnmEventFunc("ThrowBottle",DropMagicPotion)

			elif Actions.IsRightHandStandardObject(char.Name):
				if Actions.TryDropRight(char.Name):	
					Actions.DropReleaseEventHandler(char.Name, "DropRightEvent")
				if not char.InvRight:					
					UseMagicPotion2(PotName)
			else:
				char.AddAnmEventFunc("ChangeREvent",Actions.ToggleWEvent)
				char.LaunchAnmType("Chg_r")
				char.Data.Hand = 1
				magpot.Data.OHand = char.InvRight
				char.AnmEndedFunc=UseMagicPotion3
	elif (TipoUso == Actions.USE_FROM_TAKE and magpot.Data.Estado == POTION_STATE_UNUSED):
		# Automatic use from take 		
		magpot.Data.Hand = 0
		char.Data.obj_used = PotName	
		magpot.Data.Type = POTION_TYPE_GULP
		char.AnmEndedFunc=UseMagicPotion3
		print "use potion from take"
	
		
def UseMagicPotion2(PotName):	
	Reference.debugprint("UseMagicPotion2")		
	magpot = Bladex.GetEntity(PotName)
	char = Bladex.GetEntity(magpot.Data.UsedBy)
	char.AnmEndedFunc= Actions.TakeStraightRecover
	if (magpot.Data.Type == POTION_TYPE_DRINK_RIGHT):
		char.LaunchAnmType("drink")	
		char.AddAnmEventFunc("PickBottle",PickMagicPotion)
	elif magpot.Data.Type == POTION_TYPE_GULP:
		char.LaunchAnmType("gulp00")	
	else:
		print 'Unknown Potion Type' + `magpot.Data.Type`

	char.AddAnmEventFunc("drinkingEvent",BeberMagicPocima)
	print 'should throw bottle with event ThrowBottle in animation '+char.AnimName
	char.AddAnmEventFunc("ThrowBottle",DropMagicPotion)
		
	
def UseMagicPotion3(Entity):	
	char = Bladex.GetEntity(Entity)	
	UseMagicPotion2(char.Data.obj_used)	
		
			
			
def CreateMagicPotion(PotName):
	magpot = Bladex.GetEntity(PotName)
	magpot.Static = 0
	magpot.Data = MagicPotion(magpot)
	magpot.UseFunc = UseMagicPotion	
	if MagicTypeValues.has_key(magpot.Kind):
		magpot.Data.MagicIncrease = MagicTypeValues[magpot.Kind][0]
	if magpot.Kind=="ProMagicPot1":
		magpot.Lights =[(0.4, 0.05, (60, 20, 20))]
		magpot.SelfIlum       = 0.5
	if magpot.Kind=="ProMagicPot2":
		magpot.Lights =[(0.5, 0.05, (30, 20, 40))]
		magpot.SelfIlum       = 0.6
			
	spot = AuxFuncs.GetSpot(magpot)
	if spot:
		spot.Visible      = 0
		spot.CastShadows  = 0
		
	magpot.Data.Sonido = Bladex.CreateSound('..\\..\\Sounds\\Drink.wav', 'MagicDrinking')
	magpot.Data.Sonido.Volume=1
	magpot.Data.Sonido.MinDistance=10000
	magpot.Data.Sonido.MaxDistance=20000
	
	return magpot.Data


def CreateMagicFood(PotName):
	magpot = Bladex.GetEntity(PotName)
	magpot.Static = 0
	magpot.Data = MagicPotion(magpot)
	magpot.UseFunc = UseMagicPotion	
	if MagicTypeValues.has_key(magpot.Kind):
		magpot.Data.MagicIncrease = MagicTypeValues[magpot.Kind][0]
	
		
	magpot.Data.Sonido = Bladex.CreateSound('..\\..\\Sounds\\bugbite-bone2.wav', 'MagicEating')
	magpot.Data.Sonido.Volume=1
	magpot.Data.Sonido.MinDistance=10000
	magpot.Data.Sonido.MaxDistance=20000
	
	return magpot.Data


###########################################################################################################################################################

class AmuletoInvisibility (ItemTypes.ItemOfProtection):
	def __init__ (self, me):
		ItemTypes.ItemOfProtection.__init__(self, me)
		self.UsedBy= "Player1"
		self.UseTime= 100.0
		self.nUses= 7


	def UseStart (self, ObjectName, use_from):
		owner=Bladex.GetEntity(self.UsedBy)
		if not owner.Data.Invisible:
			ItemTypes.ItemOfProtection.UseStart (self, ObjectName, use_from)
			owner.Data.MakeMeInvisible()
			print "Amulet Use Start"
			print self.nUses
		else:
			Actions.ReportMsg("You are Already Invisible")

	def UseEnd (self,ObjectName, UserName):
		ItemTypes.ItemOfProtection.UseEnd (self, ObjectName, UserName)	
		owner=Bladex.GetEntity(self.UsedBy)
		if owner.Data.Invisible:
			owner.Data.RestoreVisibilty()
		print "Amulet Use End"
		
		
def TwinkleFX1(ObjName, ilum=-1):
	wps=Bladex.CreateEntity(ObjName+" TwinkleStar", "Entity Particle System Dobj", 0.0, 0.0, 0.0)
	wps.ObjectName=ObjName
	wps.ParticleType="LucesCools"
	wps.Time2Live=16
	wps.RandomVelocity=0
	wps.Velocity=0,0,0
	wps.NormalVelocity=2
	wps.YGravity=0
	wps.PPS=5
	Bladex.GetEntity(ObjName).SelfIlum = ilum
	
	
	
#########################################################################################################################################################
######## Healing Spells


class HealingSpell(ItemTypes.PersistantItemType):

	OwnerName="Player1"
	PatientName=""
	ParentPotName=""
	HealSound=None
	Destroyed=0

	def __init__ (self, me, parentpot):
		ItemTypes.PersistantItemType.__init__(self, me)
		#self.Lightname=""
		self.Name=me.Name
		self.OwnerName="Player1"
		self.PatientName=""
		self.Destroyed=0
		
		self.ParentPotName=parentpot.Name
		lite=Bladex.CreateEntity(self.Name+"Light", "Entity Spot",0,0,0)
		lite.Color=255,255,255
   		lite.Intensity=1
   		lite.Precission=0.1
   		lite.CastShadows=0
   		lite.Visible=1
   		lite.Flick=0   
  		lite.SizeFactor = 1.5 
   		lite.AngVel=0.1
   		lite.GlowTexture="StarParticle"
   		me.Link(lite) 
   		
   		self.HealSound=Bladex.CreateEntity (me.Name+"HealSound", "Entity Sound", 0, 0, 0)
		self.HealSound.SetSound("..\\..\\Sounds\\spirits.wav")
		self.HealSound.MinDistance=5000
		self.HealSound.MaxDistance=20000
	
   		Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_STANDARD,  0,  0, 1.0,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
   
   		
   		
   		
	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["HealingSpell"]=(self.Name,
					  self.OwnerName,
					  self.PatientName,
					  self.ParentPotName,
					  self.HealSound.Name,
					  self.Destroyed
					  )
		return state
		
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["HealingSpell"]
			self.Name= parms[0]
			self.OwnerName=parms[1]
			self.PatientName=parms[2]
			self.ParentPotName=parms[3]
			self.HealSound= Bladex.GetEntity(parms[4])
			self.Destroyed=parms[5]
		else:
			self.Name=me.Name
			self.OwnerName="Player1"
   			self.PatientName=""
   			self.ParentPotName=""
   			self.HealSound= Bladex.GetEntity(self.Name+"HealSound")
   			self.Destroyed=0
   
   	
   		
   		
   	def DropReleaseEventHandler (self,EntityName,EventName):
		hspell= Bladex.GetEntity(self.Name)
		if not hspell:
			return
		if not self.OwnerName:
			return		
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return	
		if hspell.TestHit:
			return
		Actions.RemoveFromInventory (owner, hspell, EventName)
		ix, iy, iz = owner.Rel2AbsVector(-1000.0, -1500.0, 0.0)
		hspell.Impulse(ix, iy, iz)
		hspell.ExcludeHitFor(owner)
		hspell.OnStopFunc=None
		hspell.DelAnmEventFunc(EventName)
		hpot= Bladex.GetEntity(self.ParentPotName)
		if hpot:
			if hpot.Data.nUses>0:
				Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,hpot.Data.AddUse,())
   				print "return to pot"
		Bladex.AddScheduledFunc(Bladex.GetTime()+2.3,self.DestroyMe,(EntityName,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+20.0,self.DestroyMe,(EntityName,))
		
		
	def DestroyMe(self,EntityName):
		if self.Destroyed:
			return
		print "Destroy spell"
		hspell= Bladex.GetEntity(self.Name)
		x,y,z=hspell.Position
		
   		hspell.Position=0,50000,0
   		hspell.RemoveFromWorld()
   		self.Destroyed=1
   		hpot= Bladex.GetEntity(self.ParentPotName)
		if hpot:
			if hpot.Data.nUses>0:
				hpot.Data.ResetUse()
   				print "parent pot reset use"
		chorigen=Bladex.CreateEntity(self.Name+"Sparx","Entity Particle System D1", x, y, z)
		chorigen.ParticleType="WhiteSpark"
		chorigen.FollowFactor=1.0
		chorigen.YGravity=0
		chorigen.RandomVelocity=30
		chorigen.Velocity=0.0,0.0, 0.0
		chorigen.Time2Live=6
		chorigen.PPS=800
		chorigen.DeathTime=Bladex.GetTime()+2.0
		
   		print "spell destroyed"
   		
   		
   		
   	def ThrowReleaseEventHandler (self,EntityName,EventName):
		print "Start Throw Healing spell"
		hspell= Bladex.GetEntity(self.Name)
		if not hspell:
			return
		if not self.OwnerName:
			return		
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return	
		if hspell.TestHit:
			return
		Actions.RemoveFromInventory (owner, hspell, EventName)
		ix, iy, iz = owner.Rel2AbsVector(-5000.0, 0.0, 0.0)
		hspell.Impulse(ix, iy, iz)
		hspell.ExcludeHitFor(owner)
		hspell.OnStopFunc=None
		hspell.DelAnmEventFunc(EventName)
		Bladex.AddScheduledFunc(Bladex.GetTime()+2.3,self.DestroyMe,(EntityName,))
		Bladex.AddScheduledFunc(Bladex.GetTime()+20.0,self.DestroyMe,(EntityName,))
		
   		
	def SlowThrowReleaseEventHandler (self,EntityName):
		print "Start Throw Healing spell"
		hspell= Bladex.GetEntity(self.Name)
		sx,sy,sz=hspell.Position
		if not hspell:
			return
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner or owner.InvRight != self.Name:
			return
		
		Actions.RemoveFromInventory (owner, hspell,"")
		
		target_pos= owner.Rel2AbsPoint(0,-10000,0)
		tlist=[]
		initpos=hspell.Position
		for ename in Bladex.GetEntitiesAt(initpos[0],initpos[1],initpos[2], 30000):
			target = Bladex.GetEntity(ename)
			if target and target.Person :
				if target.Life>0 and target.Life<CharStats.GetCharMaxLife(target.Kind, target.Level) and target.Alpha>0.9 and not MasklinTypes.CheckIfAlly(target.Name) and target.Name !="Player1" and owner.CanISee(target):
					tlist.append(target.Name)
					print "Spell target found-> ",target.Name
					break
		if len(tlist)==0:			
			print "No Target -> Abort"
			hpot= Bladex.GetEntity(self.ParentPotName)
			if hpot:
				if hpot.Data.nUses>0:
					Bladex.AddScheduledFunc(Bladex.GetTime()+2.0,hpot.Data.AddUse,())
   					print "return to pot"
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.3,self.DestroyMe,(EntityName,))
			Bladex.AddScheduledFunc(Bladex.GetTime()+20.0,self.DestroyMe,(EntityName,))
			return
			
		tlist.sort(self.ChooseLeastLife)
		patient=Bladex.GetEntity(tlist[0])
		self.PatientName=patient.Name
		Bladex.AddScheduledFunc(Bladex.GetTime()+0.1, self.SpellToTarget,())
		
		
		
	def SpellToTarget(self):
		if self.PatientName:
			patient=Bladex.GetEntity(self.PatientName)
			#Actions.TurnToFaceEntity("Player1",self.PatientName)
			hspell=Bladex.GetEntity(self.Name)
			targetpos= (patient.Position[0],patient.Position[1]-1000,patient.Position[2])
			initpos=hspell.Position
			hspelldin=Objects.CreateDinamicObject(hspell.Name)
			Objects.DisplaceObjectFromTo(hspelldin, initpos, targetpos, 5000.0, 0.0, "", "", "", "", (), self.SpellImpact,())
			print "Healing spell active"
		
		

	def RestoreTimer(self,Patient,time):
		if self.PatientName:
			patient=Bladex.GetEntity(self.PatientName)
			maxlife=CharStats.GetCharMaxLife(patient.Kind, patient.Level) 
			pjlvl=Bladex.GetEntity("Player1").Level+1
			lifeinc=pjlvl*3
			# in case patient dies while being healed.....
			if patient.Life>0:
				if patient.Life<(maxlife-lifeinc):
					patient.Life=patient.Life+lifeinc
				else:
					patient.Life=maxlife
					patient.RemoveFromList("Timer15")
					patient.TimerFunc=""
					Bladex.AddScheduledFunc(Bladex.GetTime()+0.3,self.DestroyMe,(self.Name,))
					ray=Bladex.GetEntity(self.Name+"Ray")
			 		if ray:
			 			ray.SubscribeToList("Pin")
			else:
			 	patient.RemoveFromList("Timer15")
				patient.TimerFunc=""
				Bladex.AddScheduledFunc(Bladex.GetTime()+0.3,self.DestroyMe,(self.Name,))
				ray=Bladex.GetEntity(self.Name+"Ray")
			 	if ray:
			 		ray.SubscribeToList("Pin")
			 	print self.PatientName, " I got killed while recieving treatment"
			 
			 
	
			
	def SpellImpact(self):
		if self.PatientName:
			patient=Bladex.GetEntity(self.PatientName)
			if patient.Life<0:
				Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,self.DestroyMe,(self.Name,))
				print "To late!!!"
				return
			hspell=Bladex.GetEntity(self.Name)
			sx,sy,sz=hspell.Position
			px,py,pz=patient.Position
			ray= Bladex.CreateEntity(self.Name+"Ray", "Entity ElectricBolt", sx,sy,sz)
			ray.MaxAmplitude=500.0
			ray.Position= sx,sy,sz	
			ray.Target= px,py,pz
			ray.CoreGlowColor=100,100,100
			ray.InnerGlowColor=100,100,150
			ray.OuterGlowColor=0,0,0
			ray.Active= 1
			ray.Damage=0
			if patient.Data.Poisoned:
				patient.Data.UnVenom ()
			time=Bladex.GetTime()
			aura= Auras.MakeAura (patient.Name, 2.8,(55,1.0,1.0,1,0,0), (),(),(2,  0.7,0.7,0.7, 0.5, 0.0  , 0.4,0.4,0.4, 0.1, 0.1))
			aura.Data.AddEvent(time+2.2,      (55,0.8,1.0,1,0,0), (),(),(2,  0.6,0.6,0.6, 0.5, 0.0  , 0.3,0.3,0.4, 0.1, 1.0))
			aura.Data.AddEvent(time+2.8,      (255,0.0,1.0,1,0,0), (),(),(2,  0.4,0.5,0.6, 0.5, 0.0  , 0.3,0.3,0.6, 0.1, 1.0))
        		patient.SubscribeToList("Timer15")
        		patient.TimerFunc=self.RestoreTimer
			self.HealSound.Position=sx, sy, sz
			self.HealSound.PlaySound(0)
			
			
			
	def ChooseLeastLife (self, entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)

		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST
		if p1.Life <= 0 and p2.Life <= 0:
			return CHOOSE_EITHER                          
		elif p1.Life <= 0:
			return CHOOSE_SECOND
		elif p2.Life <= 0:
			return CHOOSE_FIRST
		l1 = p1.Life
		l2 = p2.Life
		val = l2 - l1
		if val < 0:
			return CHOOSE_SECOND
		elif val > 0:
			return CHOOSE_FIRST
		else:
			return CHOOSE_EITHER   




class HealingPotion(ItemTypes.PersistantItemType):
	def __init__ (self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.UseFunc= self.UseStart
		self.UsedBy= "Player1"
		self.nUses= 10
		self.Age_number=0
		self.Name= me.Name
		
		me.SelfIlum=0.2
		me.Lights=[(0.1, 0.55, (200,200,240))]
		lo=AuxFuncs.GetSpot(me)
		lo.CastShadows=0
		


	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["HealingPotion"]=(self.UsedBy,
					   self.nUses,
					   self.Age_number,
					   self.Name)
		return state
		
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["HealingPotion"]
			self.UsedBy=parms[0]
			self.nUses= parms[1]
			self.Age_number=parms[2]
			self.Name= parms[3]
		else:
			self.UsedBy="Player1"
			self.nUses=10
			self.Age_number=0
			self.Name=""
			
			
			

	def UseStart(self, ObjectName, TipoUso):
		print "Healing Spell USE START"
		# Sometimes the use fails if there are pickupable objects near,so this is failsafe check
		Bladex.AddScheduledFunc(Bladex.GetTime()+25.0, self.ResetUse,())
		hpot=Bladex.GetEntity(ObjectName)
		if TipoUso == Actions.USE_FROM_INV:
			if hpot: 
				hpot.UseFunc= 0
		   	owner= Bladex.GetEntity(self.UsedBy)
		   	Actions.FreeBothHands(owner.Name)
		   	if owner and owner.Life >0:
		   		owner.Data.throw_weapon = None
		   	hspell=Bladex.CreateEntity(self.Name+"_HealingSpell_"+`self.Age_number`,"ProHealSpell1",0,20000,0)
			hspell.Weapon=1
			hspell.Alpha=0
			hspell.RasterMode="AdditiveAlpha"
			hspell.RasterMode="Read"
			hspell.CastShadows=0
			hspell.Data=HealingSpell(hspell,hpot)
		   	self.Age_number=self.Age_number+1
		   	Change.ChangeObject(self.UsedBy, hspell.Name, self.FinishPotion)
		   	
   	        elif TipoUso == Actions.USE_FROM_TAKE:
		   	Actions.StdUse (owner.Name)

	
	def AddUse(self):
		if self.nUses>0:
			self.nUses=self.nUses+1
			print "adding use - total ",self.nUses
			
			
	def ResetUse(self):
		if self.nUses<=0:
			return
		print "ResetUse"
		hpot= Bladex.GetEntity(self.Name)
		if not hpot.UseFunc:
			hpot.UseFunc=self.UseStart
			print "healing pot use reset after use....."
		else:
			print "healing pot use already reset......"


	def FinishPotion (self, EntityName,ObjectName):
		owner= Bladex.GetEntity(self.UsedBy)
		hpot= Bladex.GetEntity(self.Name)
		print "Finish Potion"
		self.nUses= self.nUses-1
		print "Uses left is ",self.nUses
		if self.nUses==0:
			if owner:
				inv= owner.GetInventory()
				if inv:
					inv.RemoveObject(self.Name)
					if hpot: 
						hpot.SubscribeToList("Pin")
						print "Heling potion totaly used up"
						return
		
			


#########################################################################################################################################################
############ Special FX Stuff

Bladex.ReadBitMap("../../Data/espiritu.bmp","GlowSpirit")

Bladex.ReadBitMap("../../Data/SpiritFirePtrl.bmp","SpiritFireParticle")

Bladex.ReadAlphaBitMap("../../Data/Estrellita.bmp","Estrellita")

Bladex.ReadBitMap("../../Data/BlueFirePrtl.bmp","BlueFireParticle")



Bladex.AddParticleGType("WIZParticle","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 #va de 0 a 1
		aux=traux**0.5
	else:
		traux=i/25.0 #va de 1 a 0
		aux=traux**2.0
	r=255
	g=255
	b=255
	a=255.0*traux
	size=200.0*aux
	Bladex.SetParticleGVal("WIZParticle",i,r,g,b,a,size)



Bladex.AddParticleGType("WIZPowupConc","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,50)

for i in range(50):
	if i>5:
		traux=1.0
		saux=((50.0-i)/45.0)**2.0 
	else:
		saux=traux=i/5.0 
	r=30
	g=100
	b=230
	a=200.0*traux
	size=200.0*saux
	Bladex.SetParticleGVal("WIZPowupConc",i,r,g,b,a,size)



Bladex.AddParticleGType("WizEnergyConc1","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,60)

for i in range(60):
	if i>10:
		traux=(60.0-i)/50.0 
	else:
		traux=i/10.0 
	r=100
	g=110
	b=10
	a=255.0*traux
	size=20.0+250.0*(1-i/60.0)**2.0
	Bladex.SetParticleGVal("WizEnergyConc1",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("WizDeepBlueEnergyConc1","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,60)

for i in range(60):
	if i>10:
		traux=(60.0-i)/50.0 
	else:
		traux=i/10.0 
	r=10
	g=10
	b=100
	a=255.0*traux
	size=20.0+250.0*(1-i/60.0)**2.0
	Bladex.SetParticleGVal("WizDeepBlueEnergyConc1",i,r,g,b,a,size)



Bladex.AddParticleGType("WizEnergyDissip1","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 
	else:
		traux=i/25.0 
	r=100
	g=110
	b=25
	a=255.0*traux
	size=250.0*(1-(1-i/30.0)**0.5)
	Bladex.SetParticleGVal("WizEnergyDissip1",i,r,g,b,a,size)



#### For Balls

Bladex.AddParticleGType("WizSpellEnergyConc","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>5:
		traux=(30.0-i)/25.0 #va de 0 a 1
	else:
		traux=i/5.0 #va de 1 a 0
	r=150
	g=200
	b=100
	a=255.0*traux
	size=10.0+150.0*(1-i/30.0)**2.0
	Bladex.SetParticleGVal("WizSpellEnergyConc",i,r,g,b,a,size)

	
Bladex.AddParticleGType("WizMagicMissile","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 #va de 0 a 1
	else:
		traux=i/25.0 #va de 1 a 0
	r=90
	g=130
	b=40
	a=255.0*traux
	size=340.0*(1-(1-i/30.0)**0.5)
	Bladex.SetParticleGVal("WizMagicMissile",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("DeepPurpleMagicMissile","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 #va de 0 a 1
		aux=traux**0.5
	else:
		traux=i/25.0 #va de 1 a 0
		aux=traux**2.0
	r=200
	g=30
	b=230
	a=255.0*traux
	size=400.0*aux
	Bladex.SetParticleGVal("DeepPurpleMagicMissile",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("DeepPurpleEnergyConc","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,20)

for i in range(20):
	if i>3:
		traux=1.0
		saux=((20.0-i)/17.0)**2.0 #va de 0 a 1
	else:
		saux=traux=i/3.0 #va de 1 a 0
	r=200
	g=50
	b=230
	a=255.0*traux
	size=100.0*saux
	Bladex.SetParticleGVal("DeepPurpleEnergyConc",i,r,g,b,a,size)
	
	


Bladex.AddParticleGType("FlameEnergyConc","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>5:
		traux=(30.0-i)/25.0 #va de 0 a 1
	else:
		traux=i/5.0 #va de 1 a 0
	r=245
	g=190
	b=25
	a=255.0*traux
	size=10.0+150.0*(1-i/30.0)**2.0
	Bladex.SetParticleGVal("FlameEnergyConc",i,r,g,b,a,size)
	
	


Bladex.AddParticleGType("DemonCloud","SmokePart3",Reference.B_PARTICLE_GTYPE_MUL,16)


for i in range(16):
	aux=(16.0-i)/16
	r=255
	g=255
	b=255
	a=0
	if aux < 0.5:
		size = aux*512
	else:
		size = (1-aux)*512
	Bladex.SetParticleGVal("DemonCloud",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("DisappDust","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,64)

for i in range(68):
	r=200.0
	g=200.0
	b=200.0
	a    = 255*i/64.0
	size = 128*(64-i)/64.0+16
	
	Bladex.SetParticleGVal("DisappDust",i,r,g,b,a,size)
	
	


Bladex.AddParticleGType("MoonEnergyConc","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>5:
		traux=1.0
		saux=((30.0-i)/25.0)**2.0 #va de 0 a 1
	else:
		saux=traux=i/5.0 #va de 1 a 0
	b=255
	g=100.0*(1.0-i/30.0)
	r=20+80*(i/30.0)
	a=200.0*traux
	size=300.0*saux
	Bladex.SetParticleGVal("MoonEnergyConc",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("MoonMagicMissile","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 #va de 0 a 1
		aux=traux**0.5
	else:
		traux=i/25.0 #va de 1 a 0
		aux=traux**2.0
	b=255
	g=100.0*(i/30.0)
	r=20+80*(1.0-i/30.0)
	a=200.0*traux
	size=400.0*aux
	Bladex.SetParticleGVal("MoonMagicMissile",i,r,g,b,a,size)
	


generator = whrandom.whrandom()

Bladex.AddParticleGType("Brillitos","Estrellita",Reference.B_PARTICLE_GTYPE_BLEND,64)

for i in range(64):
	r=255.0
	g=255.0
	b=255.0
	a   = generator.randint(0,255)
	size= generator.randint(0,100)

	Bladex.SetParticleGVal("Brillitos",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("EnergyKeyNegra","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,60)

for i in range(60):
	if i>10:
		traux=(60.0-i)/50.0 #va de 0 a 1
	else:
		traux=i/10.0 #va de 1 a 0
	r=255
	g=50
	b=40
	a=255.0*traux
	size=225.0*(1-i/60.0)**2.0
	Bladex.SetParticleGVal("EnergyKeyNegra",i,r,g,b,a,size)


Bladex.AddParticleGType("LlamitaBlue","BlueFireParticle",Reference.B_PARTICLE_GTYPE_ADD,21)

for i in range(21):
	if i>=14:
		aux=1.0/3.0+2*(21.0-i)/21.0 #va de 1/3 a 1
		caux=(21.0-i)/21.0 #va de 0 a 1/3
		saux=3.0*(21.0-i)/21.0 #va de 0 a 1
	elif i>7 and i<14:
		aux=1.0
		caux=1.0/3.0
		saux=1.0
	else:
		aux=1.0-((7.0-i)/7.0) #va de 1 a 0
		caux=1.0/3.0
		saux=1.0-2*((7.0-i)/7.0) #va de 1 a -1
	b=155.0*3.0*caux
	g=155.0*3.0*caux
	r=min(255*(1.0-2.0*caux), 255.0)
	a=200.0*aux
	size=4.0+6.0*saux
	Bladex.SetParticleGVal("LlamitaBlue",i,r,g,b,a,size)


	
Bladex.AddParticleGType("BlueFire","FireParticle",Reference.B_PARTICLE_GTYPE_ADD,31)

for i in range(32):
	if(i>16):
		aux=0.0
	else:
		aux=(16.0-i)/16.0
	r=40
	g=20
	b=150+105*aux
	a=255.0*(1.0-aux)
	size=150.0-(aux**2.0)*120.0
	Bladex.SetParticleGVal("BlueFire",i,r,g,b,a,size)



Bladex.AddParticleGType("SkullMagicMissile","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 #va de 0 a 1
	else:
		traux=i/25.0 #va de 1 a 0
	r=255
	g=10
	b=10
	a=255.0*traux
	size=340.0*(1-(1-i/30.0)**0.5)
	Bladex.SetParticleGVal("SkullMagicMissile",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("EnergiaBlue","GenericParticle",Reference.B_PARTICLE_GTYPE_ADD,80)

for i in range(80):
	if i>60:
		traux=1-((i-60.0)/20.0) 
	elif i<20:
		traux=i/20.0 
	else:
		traux=1.0
	r=20
	g=20
	b=255
	a=255.0*traux
	size=20.0
	Bladex.SetParticleGVal("EnergiaBlue",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("BlueFuegoInvocacion","SpiritFireParticle",Reference.B_PARTICLE_GTYPE_ADD,120)

for i in range(120):
	if i<40:
		traux=i/40.0 
	else:
		traux=1.0
	r=50
	g=50
	b=255
	a=255.0*traux
	size=400.0
	Bladex.SetParticleGVal("BlueFuegoInvocacion",i,r,g,b,a,size)

	

Bladex.AddParticleGType("PurpleLargeFire","BlueFireParticle",Reference.B_PARTICLE_GTYPE_ADD,31)

for i in range(32):
	if(i>16):
		aux=0.0
	else:
		aux=(16.0-i)/16.0
	r=255
	g=min(100.0*(1.0-aux*aux)+35,255.0)#300
	b=min(255.0*(1.0-aux)+20,255.0) 
	a=min(200.0*(1.0-aux),255.0)
	size=130.0+math.sqrt(1.0-aux)*110.0
	Bladex.SetParticleGVal("PurpleLargeFire",i,r,g,b,a,size)
	


Bladex.AddParticleGType("PurpleFlame","BlueFireParticle",Reference.B_PARTICLE_GTYPE_ADD,21)

for i in range(21):
	if i>=14:
		aux=1.0/3.0+2*(21.0-i)/21.0 #va de 1/3 a 1
		caux=(21.0-i)/21.0 #va de 0 a 1/3
		saux=3.0*(21.0-i)/21.0 #va de 0 a 1
	elif i>7 and i<14:
		aux=1.0
		caux=1.0/3.0
		saux=1.0
	else:
		aux=1.0-((7.0-i)/7.0) #va de 1 a 0
		caux=1.0/3.0
		saux=1.0-2*((7.0-i)/7.0) #va de 1 a -1
	r=155.0*3.0*caux
	g=15.0*3.0*caux#150
	b=min(255*(1.0-2.0*caux), 255.0)
	a=100.0*aux
	size=300.0+200.0*saux
	Bladex.SetParticleGVal("PurpleFlame",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("BrillosGold","StarParticle",Reference.B_PARTICLE_GTYPE_ADD,8)

for i in range(8):
	if i>5:
		aux=(8.0-i)/3.0
	else:
		aux=i/5.0
	r=235.0
	g=245.0
	b=55.0
	a=255.0
	size=100.0*aux
	Bladex.SetParticleGVal("BrillosGold",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("GoldSpark","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,6)

for i in range(6):
	r=100
	g=130
	b=20
	a=255.0
	size=20.0+10.0*(i/6.0)**2.0
	Bladex.SetParticleGVal("GoldSpark",i,r,g,b,a,size)
	
	
	
Bladex.AddParticleGType("WhiteSpark","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,6)

for i in range(6):
	r=100
	g=100
	b=100
	a=255.0
	size=20.0+10.0*(i/6.0)**2.0
	Bladex.SetParticleGVal("WhiteSpark",i,r,g,b,a,size)


Bladex.AddParticleGType("RedEnergyDis","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,30)

for i in range(30):
	if i>25:
		traux=(30.0-i)/5.0 #va de 0 a 1
	else:
		traux=i/25.0 #va de 1 a 0
	b=20
	g=10
	r=255
	a=255.0*traux
	size=80.0*(1-(1-i/30.0)**0.5)
	Bladex.SetParticleGVal("RedEnergyDis",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("RedSpark","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,6)

for i in range(6):
	r=100
	g=10
	b=20
	a=255.0
	size=20.0+10.0*(i/6.0)**2.0
	Bladex.SetParticleGVal("RedSpark",i,r,g,b,a,size)
	

Bladex.AddParticleGType("WhiteMagicMist","SmokeParticle",Reference.B_PARTICLE_GTYPE_ADD,64)

for i in range(64):
	if i>50:
		traux=(i-50.0)/14.0 
	else:
		traux=(50.0-i)/50.0 
	aux=(64.0-i)/64.0 
	r=150 
	g=150 
	b=150 
	a=75.0*(1.0-traux)
	size=400.0+aux*400.0
	Bladex.SetParticleGVal("WhiteMagicMist",i,r,g,b,a,size)


Bladex.AddParticleGType("WhiteStorm","SmokeParticle",Reference.B_PARTICLE_GTYPE_BLEND,64)

for i in range(68):
	r=255.0
	g=255.0
	b=255.0
	a    = 255*i/64.0
	size = 512*(64-i)/64.0
	if i>64: a =0;size = 0

	Bladex.SetParticleGVal("WhiteStorm",i,r,g,b,a,size)
	
	
Bladex.AddParticleGType("GreeenEnergyDissip","GenericParticle2",Reference.B_PARTICLE_GTYPE_ADD,60)

for i in range(60):
	if i>50:
		traux=(60.0-i)/10.0 
	else:
		traux=i/50.0 
	r=100
	g=255
	b=130
	a=255.0*traux
	size=20.0+250.0*(1-(1-i/60.0)**0.5)
	Bladex.SetParticleGVal("GreeenEnergyDissip",i,r,g,b,a,size)
	
	
	
demondisappsound = Bladex.CreateSound('..\\..\\Sounds\\AparicionEnric2.wav', 'DemonDisappearSound')
demondisappsound.Volume=1.0
demondisappsound.MinDistance=5000
demondisappsound.MaxDistance=20000



def TurnFromTheDarkSideFX(EnemyName):
	per=Bladex.GetEntity(EnemyName)
	per.Freeze()
	per.Data.Invincibilty=1
	EnemyMagicallyDisappearing(EnemyName)
	impl=Bladex.CreateEntity(EnemyName+"Implosion", "Entity Particle System D1", per.Position[0], per.Position[1], per.Position[2])
	impl.ParticleType="EnergiaBlue"
	impl.YGravity=0.0
	impl.Friction=0.0
	impl.PPS=300
	impl.Velocity=0.0, 0.0, 0.0
	impl.RandomVelocity=-30.0
	impl.Time2Live=70
	impl.DeathTime=Bladex.GetTime()+1.2
	Bladex.AddScheduledFunc(Bladex.GetTime()+2.0, TurnFromTheDarkSideFX2, (EnemyName,))



def TurnFromTheDarkSideFX2(EnemyName):
	per=Bladex.GetEntity(EnemyName)
	
	TYPE=per.Kind
	x,y,z=per.Position
	lvl=per.Level
	life=per.Life
	ang=per.Angle
	aper=Bladex.CreateEntity(EnemyName+"Ally",TYPE,0,30000,0,"Person")
	aper.Level=lvl
	aperinv=aper.GetInventory()
	lwp=Bladex.GetEntity(per.InvLeft)
	rwp=Bladex.GetEntity(per.InvRight)
	perinv=per.GetInventory()
	perkit=[]
	# find out what enemy was holding....
	for id in range(perinv.nWeapons):
		sd = perinv.GetWeapon (id)
	  	if sd:
	        	ent = Bladex.GetEntity(sd)
			perkit.append(ent.Name)
	for id in range(perinv.nShields):
		sh = perinv.GetShield (id)
	  	if sh:
	    		ent = Bladex.GetEntity(sh)
	    		perkit.append(ent.Name)
	for id in range(perinv.nQuivers):
		qv = perinv.GetQuiver (id)
	  	if qv:
	    		ent = Bladex.GetEntity(qv)
	    		perkit.append(ent.Name)
	for id in range(perinv.nObjects):
	  	for ob in Actions.GetListOfObjectsAt(perinv,id):
	    		if ob:
	          		ent = Bladex.GetEntity(ob)
	      			perkit.append(ent.Name)
	# if enemy has a key, then give it straight to Player
	for id in range(perinv.nKeys):
		ky = perinv.GetKey (id)
	  	if ky:
	    		ent = Bladex.GetEntity(ky)
	    		Actions.RemoveFromInventory (per, ent, "")
	    		Actions.TakeObject("Player1",ent.Name)
	    				
	if len(perkit)!= 0:
		for i in perkit:
			thing=Bladex.GetEntity(i)
			object_flag=Reference.GiveObjectFlag(thing.Name)
			if object_flag==Reference.OBJ_WEAPON:
				RWPTYPE=thing.Kind
				arwp=Bladex.CreateEntity(aper.Name+"Weapon",RWPTYPE,0,30000,0,"Weapon")
				ItemTypes.ItemDefaultFuncs(arwp)
				Actions.TakeObject(aper.Name,arwp.Name)
			elif object_flag==Reference.OBJ_SHIELD:
				LWPTYPE=thing.Kind
				alwp=Bladex.CreateEntity(aper.Name+"Shield",LWPTYPE,0,30000,0,"Weapon")
				ItemTypes.ItemDefaultFuncs(alwp)
				Actions.TakeObject(aper.Name,alwp.Name)
			elif object_flag==Reference.OBJ_BOW:
				BWTYPE=thing.Kind
				abw=Bladex.CreateEntity(aper.Name+"Bow",BWTYPE,0,30000,0,"Weapon")
				ItemTypes.ItemDefaultFuncs(abw)
				aperinv.AddBow(abw.Name)
			elif object_flag==Reference.OBJ_QUIVER:
				QVTYPE=thing.Kind
				aqv=Bladex.CreateEntity(aper.Name+"Quiver",QVTYPE,0,30000,0,"Weapon")
				try:
					import QuiverTypes
					QuiverTypes.QuiverTypeFuncs(aqv)
				except NameError:
					ItemTypes.ItemDefaultFuncs(aqv)
				aperinv.AddQuiver(aqv.Name)
				aqv.Data.ArrowsLeft=10
			elif object_flag==Reference.OBJ_ITEM:
				ITYPE=thing.Kind
				import pocimac  # most likely to be a potion
				if ITYPE[:6]=="Pocima":
					apot=Bladex.CreateEntity(aper.Name+"Potion",ITYPE,0,30000,0,"Physic")
					pocimac.CreatePotion(apot.Name)
					aperinv.AddObject(apot.Name,0)
				elif ITYPE =="Saquito":
					afood=Bladex.CreateEntity(aper.Name+"Food",ITYPE,0,30000,0,"Physic")
					import pocimac
					pocimac.CreatePotion(afood.Name)
					aperinv.AddObject(afood.Name,0)
		
	WizardAllyTypes.AllyDefaultFuncs (aper)
	aper.Data.Dusted=1
	if per.MeshName=="Golem_ice":
		aper.SetMesh("Golem_ice")
		aper.Data.Resistances= copy.copy(CharStats.GetCharResistances("Golem_ice"))
		aper.Data.StoneType="Piedra_Glm_ic"
		aper.Data.StoneAlpha=0.6
		aper.Data.StoneSelfIlum=0.8
		aper.Alpha=0.6
		aper.SelfIlum=0.8
		ag=Bladex.CreateEntity(aper.Name+"AuraGolem", "Entity Aura", 0, 0, 0)
		ag.SetAuraParams(50, 1, 1, 0, 0, 1)
		ag.SetAuraGradient(2, 0.9, 1.0, 1.0, 0.2, 0.1, 0.4, 0.8, 1.0, 0.0, 0.8)
		aper.Link(ag)
		ag.SetAuraActive(1)

	# this func increases weapon damge on levelup
	aper.Data.LevelupFunc=WizardAllyTypes.ConvertedAllyLevelUpFunc
	aper.Data.LevelupArgs=(aper.Name,)
	print EnemyName+" Turned from the Dark Side"
	aper.Freeze()
	aper.Alpha=0.2
	per.Position=0,30000,0
	per.UnFreeze()
	per.Life=-20
	aper.Position=x,y,z
	aper.Angle=ang
	aper.UnFreeze()
	# delay killing the original enemy as potions will be 
	# deleted because of collision before registered 
	Bladex.AddScheduledFunc(Bladex.GetTime()+5.0,KillOff,(per.Name,))
	char=Bladex.GetEntity("Player1")
	char.Data.AllyList.append(aper.Name)
	AllyMagicallyAppearing(aper.Name)
	aper.ResetChase()
	demondisappsound.Play(x,y,z, 0)


def KillOff(entity):
	per=Bladex.GetEntity(entity)
	per.Life=0



def AllyMagicallyAppearing(entityname):
	TimeEffect=2.0
	time=Bladex.GetTime()
	per=Bladex.GetEntity(entityname)
	
	per.RasterMode="Read"
	Bladex.AddScheduledFunc(time+TimeEffect, GenFX.ChangeRasterMode, (entityname, "Full"))
	AuxFuncs.FadeObject(entityname, 0.2, 1.0, 2.0)
	if per.InvLeft<>"":
		obj=Bladex.GetEntity(per.InvLeft)
		obj.RasterMode="Read"
		Bladex.AddScheduledFunc(time+TimeEffect, GenFX.ChangeRasterMode, (per.InvLeft, "Full"))
		AuxFuncs.FadeObject(per.InvLeft, 0.2, 1.0, TimeEffect)
	if per.InvRight<>"":
		obj=Bladex.GetEntity(per.InvRight)
		obj.RasterMode="Read"
		Bladex.AddScheduledFunc(time+TimeEffect, GenFX.ChangeRasterMode, (per.InvRight, "Full"))
		AuxFuncs.FadeObject(per.InvRight, 0.2, 1.0, TimeEffect)
	if per.InvLeftBack<>"":
		obj=Bladex.GetEntity(per.InvLeftBack)
		obj.RasterMode="Read"
		Bladex.AddScheduledFunc(time+TimeEffect, GenFXChangeRasterMode, (per.InvLeftBack, "Full"))
		AuxFuncs.FadeObject(per.InvLeftBack, 0.2, 1.0, TimeEffect)
	if per.InvRightBack<>"":
		obj=Bladex.GetEntity(per.InvRightBack)
		obj.RasterMode="Read"
		Bladex.AddScheduledFunc(time+TimeEffect, GenFX.ChangeRasterMode, (per.InvRightBack, "Full"))
		AuxFuncs.FadeObject(per.InvRightBack, 0.2, 1.0, TimeEffect)
	AuraParams0=(240, 0.01, 1.0, 0, 1, 1)
	AuraParams1=(50 , 1.0 , 1.0, 0, 1, 1)
	AuraParams2=(50 , 0.01, 1.0, 0, 1, 1)
	AuraGradient0=(2,  0.2, 0.4, 0.8, 1.0, 0.2  ,  0.0, 0.2, 0.8, 0.0, 0.7)
	AuraGradient1=(2,  0.8, 0.9, 1.0, 1.0, 0.2  ,  0.0, 0.2, 0.9, 0.1, 1.0)
	aura=Auras.MakeAura(entityname, TimeEffect, AuraParams0, (), (), AuraGradient0)
	aura.Data.AddEvent (time+TimeEffect/2.0, AuraParams1, (), (), AuraGradient1)
	aura.Data.AddEvent (time+TimeEffect, AuraParams2, (), (), AuraGradient0)
	ps=Bladex.CreateEntity(entityname+"PSPersonMagicallyAppearing", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	ps.PersonName=entityname
	ps.ParticleType="FastEnergyConc"###
	ps.PPS=200
	ps.YGravity=0.0
	ps.Friction=0.0
	ps.Velocity=0.0, 0.0, 0.0
	ps.RandomVelocity=0.5
	ps.NormalVelocity=-2.0
	ps.Time2Live=30
	ps.DeathTime=time+TimeEffect/2.0


def EnemyMagicallyDisappearing(entityname):
	TimeEffect=2.0
	time=Bladex.GetTime()
	per=Bladex.GetEntity(entityname)
	per.Alpha=1.0
	per.RasterMode="Read"
	AuxFuncs.FadeObject(entityname, 1.0, 0.2, TimeEffect)
	if per.InvLeft<>"":
		obj=Bladex.GetEntity(per.InvLeft)
		obj.RasterMode="Read"
		AuxFuncs.FadeObject(per.InvLeft, obj.Alpha, 0.2, TimeEffect)
	if per.InvRight<>"":
		obj=Bladex.GetEntity(per.InvRight)
		obj.RasterMode="Read"
		AuxFuncs.FadeObject(per.InvRight, obj.Alpha, 0.2, TimeEffect)
	if per.InvLeftBack<>"":
		obj=Bladex.GetEntity(per.InvLeftBack)
		obj.RasterMode="Read"
		AuxFuncs.FadeObject(per.InvLeftBack, obj.Alpha, 0.2, TimeEffect)
	if per.InvRightBack<>"":
		obj=Bladex.GetEntity(per.InvRightBack)
		obj.RasterMode="Read"
		AuxFuncs.FadeObject(per.InvRightBack, obj.Alpha, 0.2, TimeEffect)
	AuraParams0=(240, 0.01, 1.0, 0, 1, 1)
	AuraParams1=(50 , 1.0 , 1.0, 0, 1, 1)
	AuraParams2=(50 , 0.01, 1.0, 0, 1, 1)
	AuraGradient0=(2,  0.2, 0.4, 0.8, 1.0, 0.2  ,  0.0, 0.2, 0.8, 0.0, 0.7)
	AuraGradient1=(2,  0.8, 0.9, 1.0, 1.0, 0.2  ,  0.0, 0.2, 0.9, 0.1, 1.0)
	aura=Auras.MakeAura(entityname, TimeEffect, AuraParams2, (), (), AuraGradient0)
	aura.Data.AddEvent (time+TimeEffect/2.0, AuraParams1, (), (), AuraGradient1)
	aura.Data.AddEvent (time+TimeEffect, AuraParams0, (), (), AuraGradient0)
	ps=Bladex.CreateEntity("PSPersonMagicallyAppearing", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	ps.PersonName=entityname
	ps.ParticleType="EnergyDissip"#####
	ps.PPS=200
	ps.YGravity=0.0
	ps.Friction=0.0
	ps.Velocity=0.0, 0.0, 0.0
	ps.RandomVelocity=0.5
	ps.NormalVelocity=2.0
	ps.Time2Live=60
	ps.DeathTime=time+TimeEffect/3.0



def DeathAppears(PersonName):
	time=Bladex.GetTime()
	aura=Auras.MakeAura(PersonName,0.4,   ( 50, 1.0 , 0.0, 0, 0, 0), (), (), (2,  0.9, 0.9, 0.0, 0.9, 0.0  ,  0.9, 0.9, 0.0, 0.9, 0.8))
	aura.Data.AddEvent(time+0.2,          (150, 0.5 , 0.0, 0, 0, 0), (), (), (2,  0.9, 0.9, 0.0, 0.9, 0.0  ,  0.9, 0.9, 0.0, 0.9, 0.8))
	aura.Data.AddEvent(time+0.4,          (200, 0.01, 0.0, 0, 0, 0), (), (), (2,  0.9, 0.9, 0.0, 0.9, 0.0  ,  0.9, 0.9, 0.0, 0.9, 0.8))

	wps=Bladex.CreateEntity(PersonName+"WPS", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	wps.PersonName=PersonName
	wps.ParticleType="DemonCloud"
	wps.Time2Live=16
	wps.RandomVelocity=2.0
	wps.Velocity=0,0,0
	wps.NormalVelocity=20
	wps.YGravity=0
	wps.DeathTime=Bladex.GetTime()+0.25
	wps.PPS=1024
	per = Bladex.GetEntity(PersonName)
	per.UnFreeze()
	per.Alpha = 1.0
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.0, per.ResetChase,())
	demondisappsound.Play(per.Position[0], per.Position[1], per.Position[2], 0)
	
	
def DeathDisappears(PersonName):
	print "Removing demon"
	wps=Bladex.CreateEntity(PersonName+"WPS", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	wps.PersonName=PersonName
	wps.ParticleType="DemonCloud"
	wps.Time2Live=16
	wps.RandomVelocity=2.0
	wps.Velocity=0,0,0
	wps.NormalVelocity=2
	wps.YGravity=0
	wps.DeathTime=Bladex.GetTime()+0.25
	wps.PPS=1024
	per = Bladex.GetEntity(PersonName)	
	#per.Data.InteruptActions(per.Name)
	darfuncs.HideBadGuy(per.Name)
	per.Position=0,40000,0  ############################################################# added 18-4-07
	demondisappsound.Play(per.Position[0], per.Position[1], per.Position[2], 0)
	
	
	
def DissolveLimb(ObjName):
	limb= Bladex.GetEntity(ObjName)
	if limb:
		wps=Bladex.CreateEntity(ObjName+"WPS", "Entity Particle System Dobj", 0.0, 0.0, 0.0)
		wps.ObjectName=ObjName
		wps.ParticleType="DisappDust"
		wps.Time2Live=64
		wps.RandomVelocity=0
		wps.Velocity=100,300,0
		wps.NormalVelocity=2.0
		wps.YGravity=-300
		wps.DeathTime=Bladex.GetTime()+1.5
		wps.PPS=300
		limb = Bladex.GetEntity(ObjName)
		limb.Alpha=0.6
		limb.RasterMode="Read"
		limb.CastShadows=0
		AuxFuncs.FadeObject(ObjName, 0.6, 0.0, 4.0)
		Bladex.AddScheduledFunc(Bladex.GetTime()+4.1, limb.RemoveFromWorld,())
	
	
	


#entity_source_name, prtl_type, pps, rnd_vel, normal_vel, friction, time2live, death_time, ygravity=0

def Att5_StaffFX(EntityName="Player1"):
	pers=Bladex.GetEntity(EntityName)
	global WizFX_prtlsys
	WizFX_prtlsys=GenFX.AddParticles(pers.InvRight, "WizEnergyConc1", 400, 4, 0, 0.01, 10, 3.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.7,GenFX.ModifyParticles,(WizFX_prtlsys, 1000, 5, 0, 0.1, 10, 2.0,))
	Bladex.AddScheduledFunc(Bladex.GetTime()+1.8,GenFX.AddParticles,(pers.InvRight, "WizEnergyDissip1", 3000, 60, 0, 0.05, 20, 0.1,))
	
		
def Att7_StaffFX(EntityName="Player1"):
	pers=Bladex.GetEntity(EntityName)
	global WizFX_prtlsys
	WizFX_prtlsys=GenFX.AddParticles(pers.InvRight, "WizDeepBlueEnergyConc1", 400, 4, 0, 0.01, 10, 3.0)
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.7,GenFX.ModifyParticles,(WizFX_prtlsys, 1000, 5, 0, 0.1, 10, 2.0,))
	
	

############################################################################################################################################################
#### not used*
"""
class LightningRope:
	def __init__(self, me, damage, ownerName="Player1"):
		self.Name=me.Name
		self.OwnerName=ownerName
		self.Moving=0
		self.RightEnd=""
		self.LeftEnd=""
		self.RightEndLite=""
		self.LeftEndLite=""
		self.movesound=""
		self.ObjId=ObjStore.GetNewId()
		
		owner=Bladex.GetEntity(self.OwnerName)
		x,y,z=me.Position
		tx,ty,tz=me.Target
		Reference.EntitiesObjectData[self.Name]=[Reference.OBJ_WEAPON, damage, 0,1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Whip"]]

		target_posL=owner.Rel2AbsPoint(-5000,-30000,0)
		target_posR=owner.Rel2AbsPoint(5000,-30000,0)
		
		
		self.movesound=Bladex.CreateEntity(me.Name+"MoveSound", "Entity Sound", 0, 0, 0)
		self.movesound.SetSound("..\\..\\Sounds\\campo-escudo-barrera1.wav")
		self.movesound.MinDistance=2000
		self.movesound.MaxDistance=30000
		#me.Link(self.movesound)
		#self.movesound.PlaySound(-1)
		
					
		
		Lmissile=Bladex.CreateEntity(self.Name+"LeftEnd", "Entity Magic Missile", x,y,z)
		self.LeftEnd=Lmissile.Name
		
		Lendlite=Bladex.CreateEntity(self.Name+"LeftEndLite", "Entity Spot", x,y,z)
		Lendlite.Color=40,20,200 
		Lendlite.Intensity=0.05
		Lendlite.Precission=0.00
		Lendlite.CastShadows=0
		Lendlite.GlowTexture="GlowSpirit"
		Lendlite.AngVel=3.14159
		Lendlite.SizeFactor=1.0
		self.LeftEndLite=Lendlite.Name
		Lmissile.Link(Lendlite)
		
		langle= -B3DLib.GetYAngle(target_posL[0]-x,target_posL[1]-y,target_posL[2]-z)
		lvx,lvy,lvz=owner.Rel2AbsVector(-1000.0, -math.cos(langle)*3000, -math.sin(langle)*3000)
		Lmissile.Velocity=lvx,lvy,lvz
		Lmissile.OnHitFunc= self.OnHitFunc
		

		Rmissile=Bladex.CreateEntity(self.Name+"RightEnd", "Entity Magic Missile", tx,ty,tz)
		self.RightEnd=Rmissile.Name
		
		Rendlite=Bladex.CreateEntity(self.Name+"RightEndLite", "Entity Spot", tx,ty,tz)
		Rendlite.Color=40,20,200 
		Rendlite.Intensity=0.00
		Rendlite.Precission=0.06
		Rendlite.CastShadows=0
		Rendlite.GlowTexture="GlowSpirit"
		Rendlite.AngVel=3.14159
		Rendlite.SizeFactor=1.0
		Rmissile.Link(Rendlite)
		self.RightEndLite=Rendlite.Name
		
		rangle= -B3DLib.GetYAngle(target_posR[0]-x,target_posR[1]-y,target_posR[2]-z)
		rvx,rvy,rvz=owner.Rel2AbsVector(1000.0, -math.cos(rangle)*3000, -math.sin(rangle)*3000)
		Rmissile.Velocity=rvx,rvy,rvz
		Rmissile.OnHitFunc= self.OnHitFunc
		
		
		self.Moving=1
		
		me.TimerFunc=self.MoveRope
		me.SubscribeToList("Timer8")
		Bladex.AddScheduledFunc(Bladex.GetTime()+4.0, self.RopeEnd, ())
		print "Rope Created"
		
		
	def persistent_id(self):
		return self.ObjId
	
		
	
	def RopeEnd(self):
		if self.Moving:
			self.Moving=0
			#if self.movesound:
			#	self.movesound.StopSound()
			me=Bladex.GetEntity(self.Name)
			me.TimerFunc=""
			
					
			
			me.Active=0
			Rendlite=Bladex.GetEntity(self.RightEndLite)
			Lendlite=Bladex.GetEntity(self.LeftEndLite)
			
			Lmissile=Bladex.GetEntity(self.LeftEnd)
			if Lmissile:
				Lmissile.OnHitFunc=None
				if Lendlite:
					Lmissile.Unlink(Lendlite)
					Lmissile.SubscribeToList("Pin")
					AuxFuncs.SpotIntensityVariation(self.LeftEndLite, 0.2, 0.0, 0.5, 1)
					self.LeftEndLite=None
			Rmissile=Bladex.GetEntity(self.RightEnd)
			if Rmissile:
				Rmissile.OnHitFunc=None
				if Rendlite:
					Rmissile.Unlink(Rendlite)
					Rmissile.SubscribeToList("Pin")
					AuxFuncs.SpotIntensityVariation(self.RightEndLite, 0.2, 0.0, 0.7, 1)
					self.RightEndLite=None
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.3,me.SubscribeToList,("Pin",))
			print "Rope Destroyed"
			
			
			
			
	def MoveRope(self, EntityName,time):
		if self.Moving:
			print "Moooooving"
			me=Bladex.GetEntity(EntityName)
			if me:
				if self.LeftEnd:
					try:
						x,y,z=Bladex.GetEntity(self.LeftEnd).Position
						me.Position=x,y,z
					except AttributeError:
						x,y,z=me.Position
					me.Position=x,y,z
				if self.RightEnd:
					try:
						tx,ty,tz=Bladex.GetEntity(self.RightEnd).Position
					except AttributeError:
						tx,ty,tz=me.Target
					me.Target=  tx,ty,tz
					
	
	
	
	def OnHitFunc (self, EntityName, hit_entity):
		print EntityName+" hitting "+hit_entity
		me=Bladex.GetEntity(self.Name)
		if hit_entity:
			hit_ent=Bladex.GetEntity(hit_entity)
			
			if hit_ent.Person:
				return
			print EntityName+" hitting non-person "+hit_entity
			me.TimerFunc=""
			self.RopeEnd()
			print EntityName+" Hit object -> breaking..."
			
		else:
			me.TimerFunc=""
			self.RopeEnd()
			print EntityName+" Hitting World -> breaking..."
	
	
	
	
	
	#### Save stuff needed here......???
	
	
	
	
def MakeLightningRope(name, damage,posL,posR):
	rope=Bladex.CreateEntity(name,"Entity ElectricBolt", posL[0],posL[1]-500,posL[2])
	rope.MaxAmplitude=250.0
	rope.FixedTarget=0
	rope.Position= posL[0],posL[1]-500,posL[2]
	rope.Target= posR[0],posR[1]-500,posR[2]
	rope.Active= 1
	rope.Damage=1
	
	rope.Data=LightningRope(rope,damage)
	return rope

"""
	
############################################################################################################################################################
#### Wobbly Spells

class WobblySpell1(ItemTypes.PersistantItemType):
	DamageEntityName=""
	Name=""
	OwnerName="Player1"
	Hit=0
	Fired=0
	MissileShootSound=None
	MissileWhileSound=None
	MissileImpactSound=None
	ThrownBy=None
	FirePS=None
	Destroyed=0
	
	def __init__(self, me, ownerName):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.CastShadows= 0
		me.Visible= 0
		me.Flick=1
		me.Color=140, 255, 160
		me.Intensity=0.0
		me.Damage=1
		me.DamageRadius=500.0

		ball=Bladex.CreateEntity(me.Name+"_Shell", "EsferaOrbital", 0,0,0)
		ball.Orientation=0.707107,0.707107,0.000000,0.000000
		ball.RasterMode="Read"
		ball.RasterMode="AdditiveAlpha"
		ball.Alpha=0.0
		ball.SelfIlum=0.5
		ball.CastShadows=0

		AuxFuncs.FadeObject(ball.Name, 0.0, 0.99, 2.0)

		self.DamageEntityName=ball.Name
		self.Name=me.Name
		self.OwnerName=ownerName
		self.Hit=0
		self.Fired=0

		Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, self.IntensityVarWithoutTimer, (0.1, 2.0))

		# Create and link a particle system here
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.CreateFireball, ())

		me.OnHitFunc=self.PrevOnHitFunc
		me.InflictHitFunc= self.WobblyHitFunc
		me.TimerFunc=self.MoveAndRotateBall
		me.SubscribeToList("Timer30")

		# Create an energy concentration effect here for 1.0 second		
		concball=Bladex.CreateEntity(me.Name+"_Conc","Entity Particle System Dobj", 0, 0, 0)
		concball.ObjectName=ball.Name
		concball.ParticleType="DeepPurpleEnergyConc"
		concball.PPS=2000
		concball.YGravity=0.0
		concball.Friction=0.0
		concball.RandomVelocity=-5.0
		concball.NormalVelocity=-15.0
		concball.Time2Live=20
		concball.FollowFactor=0.1
		concball.DeathTime=Bladex.GetTime()+1.0

		concsound=Bladex.CreateEntity(me.Name+"ConcSound", "Entity Sound", 0, 0, 0)
		concsound.SetSound("..\\..\\Sounds\\energy-ball-conc.wav")
		concsound.MinDistance=5000
		concsound.MaxDistance=30000
		me.Link(concsound)
		concsound.PlaySound(0)

		self.SetMissileSound("shoot", "..\\..\\Sounds\\Fireball-Fire.wav")
		self.SetMissileSound("while", "..\\..\\Sounds\\energy-ball.wav")
		self.SetMissileSound("impact", "..\\..\\Sounds\\energy-ball-impact.wav")

		Bladex.AddScheduledFunc(Bladex.GetTime()+20.0, self.BallDissipation, (), "PostFunc"+me.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, self.ReleaseThrownWeaponHandler, (me.Name, ""))

		#Reference.EntitiesObjectData[me.Name]= BCopy.deepcopy(Reference.DefaultObjectData[ball.Kind])
		if Reference.EntitiesObjectData.has_key(me.Name):
			del Reference.EntitiesObjectData[me.Name]
		
		
		
		damagefact=MasklinTypes.GetMagicLevelFactor()*21 #######################
		print "Wobbly damge_",damagefact
		Reference.EntitiesObjectData[me.Name]=[Reference.OBJ_WEAPON,  damagefact,  0, 1.0,  Reference.THR_STRAIGHT, []]

	def __getstate__(self):

		state= ItemTypes.PersistantItemType.__getstate__(self)
		MissileShootSoundName= ""
		MissileWhileSoundName= ""
		MissileImpactSoundName= ""
		ThrownByName=""
		FirePSName=""
		if self.MissileShootSound: MissileShootSoundName= self.MissileShootSound.Name
		if self.MissileWhileSound: MissileWhileSoundName= self.MissileWhileSound.Name
		if self.MissileImpactSound: MissileImpactSoundName= self.MissileImpactSound.Name
		if self.ThrownBy: ThrownByName=self.ThrownBy.Name
		if self.FirePS: FirePSName= self.FirePS.Name
		
		state[1]["WobblySpell1"]=(self.DamageEntityName,
									self.Name,
									self.OwnerName,
									self.Hit,
									self.Fired,
									MissileShootSoundName,
									MissileWhileSoundName,
									MissileImpactSoundName,
									ThrownByName,
									FirePSName,
									self.Destroyed
									)

		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["WobblySpell1"]
			MissileShootSoundName=""
			MissileWhileSoundName=""
			MissileImpactSoundName=""
			ThrownByName=""
			FirePSName=""
			
			(self.DamageEntityName,
			self.Name,
			self.OwnerName,
			self.Hit,
			self.Fired,
			self.Destroyed,
			MissileShootSoundName,
			MissileWhileSoundName,
			MissileImpactSoundName,
			ThrownByName,
			FirePSName)= parms
			
			if MissileShootSoundName: 
				self.MissileShootSound= Bladex.GetEntity(MissileShootSoundName)
			if MissileWhileSoundName: 
				self.MissileWhileSound= Bladex.GetEntity(MissileWhileSoundName)
			if MissileImpactSoundName: 
				self.MissileImpactSound= Bladex.GetEntity(MissileImpactSoundName)
			if ThrownByName:
				self.ThrownBy=Bladex.GetEntity(ThrownByName)
			if FirePSName:
				self.FirePS=Bladex.GetEntity(FirePSName)
		if self.Name:
			me=Bladex.GetEntity(self.Name)
			if me:
				me.OnHitFunc=self.PrevOnHitFunc
				me.InflictHitFunc= self.WobblyHitFunc
				me.TimerFunc=self.MoveAndRotateBall
				me.SubscribeToList("Timer30")


	def SetMissileSound(self, kind, wavfile):
		missile=Bladex.GetEntity(self.Name)
		if missile:
			if kind=="shoot":
				missilesound=Bladex.CreateEntity(self.Name+"ShootSound", "Entity Sound", 0, 0, 0)
				self.MissileShootSound=missilesound
			elif kind=="while":
				missilesound=Bladex.CreateEntity(self.Name+"WhileSound", "Entity Sound", 0, 0, 0)
				self.MissileWhileSound=missilesound
			elif kind=="impact":
				missilesound=Bladex.CreateEntity(self.Name+"ImpactSound", "Entity Sound", 0, 0, 0)
				self.MissileImpactSound=missilesound
			missilesound.SetSound(wavfile)
			missilesound.Volume=1.0
			missilesound.MinDistance=5000
			missilesound.MaxDistance=30000
			missile.Link(missilesound)


	def BallDissipation(self):
		missile=Bladex.GetEntity(self.Name)
		ball=Bladex.GetEntity(self.DamageEntityName)
		if missile:
			intred=0.2 
			escred=0.1 
			rndvelred=-2.0 
			PPSred=150.0 
			Alphared=0.099 
			sndred=0.1 
			missile.Intensity=max(0.0, missile.Intensity-intred)
			ball.Scale=max(0.0, ball.Scale-escred)
			ball.Alpha=max(0.0, ball.Alpha-Alphared)
			self.FirePS.RandomVelocity=self.FirePS.RandomVelocity-rndvelred
			self.FirePS.PPS=max(10.0, self.FirePS.PPS-PPSred)
			self.MissileWhileSound.Volume=max(0.0, self.MissileWhileSound.Volume-sndred)
			if missile.Intensity>0.0:
				Bladex.AddScheduledFunc(Bladex.GetTime()+0.1, self.BallDissipation, (), "PostFunc"+self.Name)
			else:
				self.FirePS.DeathTime=Bladex.GetTime()+1.0/60.0
				missile.Unlink(self.FirePS)
				missile.SubscribeToList("Pin")
				ball.SubscribeToList("Pin")
				self.MissileShootSound=None
				self.MissileWhileSound=None
				self.MissileImpactSound=None
				self.ThrownBy=None
				self.FirePS=None
		elif ball:
			ball.SubscribeToList("Pin")
			self.MissileShootSound=None
			self.MissileWhileSound=None
			self.MissileImpactSound=None
			self.ThrownBy=None
			self.FirePS=None


	def DissipateConc(self):
		shootball=Bladex.CreateEntity(self.Name+"_Shoot","Entity Particle System Dobj", 0, 0, 0)
		shootball.ObjectName=self.DamageEntityName
		shootball.ParticleType="DeepPurpleMagicMissile" 
		shootball.PPS=1000
		shootball.YGravity=0.0
		shootball.Friction=0.0
		shootball.RandomVelocity=5.0
		shootball.NormalVelocity=20.0
		shootball.Time2Live=30
		shootball.DeathTime=Bladex.GetTime()+0.5


	def IntensityVarWithoutTimer(self, intvar, end_int):
		missile=Bladex.GetEntity(self.Name)
		if missile:
			missile.Intensity=missile.Intensity+intvar
			if missile.Intensity>=end_int:
				missile.Intensity=end_int
			else:
				Bladex.AddScheduledFunc(Bladex.GetTime()+0.1, self.IntensityVarWithoutTimer, (intvar, end_int))


	def MoveAndRotateBall(self, ent_name, time):
		missile=Bladex.GetEntity(ent_name)
		if missile:
			ball=Bladex.GetEntity(self.DamageEntityName)
			ball.Position=missile.Position
			ball.RotateRel(0.0, 0.0, 0.0, 0, 0, 1, -0.5)


	def CreateFireball(self):
		rayo1=Bladex.CreateEntity(self.Name+"_Ray1", "Entity ElectricBolt", 0.0, 600.0, 600.0)
		rayo1.Target=0.0, -600.0, -600.0
		rayo2=Bladex.CreateEntity(self.Name+"_Ray2", "Entity ElectricBolt", 0.0, 600.0, -600.0)
		rayo2.Target=0.0, -600.0, 600.0
		rayo1.FixedTarget=rayo2.FixedTarget=0
		rayo1.MaxAmplitude=rayo2.MaxAmplitude=600
		rayo1.MinSectorLength=rayo2.MinSectorLength=10000
		rayo1.Damage=rayo2.Damage=0
		rayo1.Active=rayo2.Active=1
		rayo1.CoreGlowColor=rayo2.CoreGlowColor=100.0, 50.0, 50.0
		rayo1.InnerGlowColor=rayo2.InnerGlowColor=50.0, 10.0, 10.0
		rayo1.OuterGlowColor=rayo2.OuterGlowColor=0.0, 0.0, 0.0
		ball=Bladex.GetEntity(self.DamageEntityName)
		ball.Link(rayo1)
		ball.Link(rayo2)
		fireball=Bladex.CreateEntity(self.Name+"_Fire","Entity Particle System D1",0,0,0)
		fireball.ParticleType="DeepPurpleMagicMissile"
		fireball.PPS=400
		fireball.YGravity=0.0
		fireball.Friction=0.04
		fireball.RandomVelocity=-16.0
		fireball.FollowFactor=0.4
		fireball.Time2Live=30
		missile=Bladex.GetEntity(self.Name)
		missile.Link(fireball)
		self.FirePS=fireball



	def DestroyFunc(self, EntityName):
		missile=Bladex.GetEntity(EntityName)
		if not self.Destroyed:
			self.OnHitFunc(EntityName,"")



	def SetTarget(self, EntityName, OwnerName):
		missile=Bladex.GetEntity(EntityName)
		if missile:
			owner=Bladex.GetEntity(OwnerName)
			x,y,z=owner.Position
			if owner:
				if owner.ActiveEnemy:
					missile.ETarget=owner.ActiveEnemy
					
				else:
					tlist=[]
					for ename in Bladex.GetEntitiesAt(x,y,z, 50000):
						target = Bladex.GetEntity(ename)
						if target and target.Person:
							if target.Life>0 and target.Alpha>0.9 and MasklinTypes.CheckIfAlly(target.Name) and target.Name !="Player1" and owner.CanISee(target):
								tlist.append(target.Name)
								
								print "Wobbly target found-> ",target.Name
								break
					if len(tlist)==0:			
						print "No Target for wobbly -> Destroy ball in 3secs"
						
						Bladex.AddScheduledFunc(Bladex.GetTime()+3.0,self.DestroyFunc ,(EntityName,))
						missile.ETarget=""
						return
                   			foundtarget= Bladex.GetEntity(tlist[0])	
					missile.ETarget=foundtarget.Name
					
				
					

	def ReleaseThrownWeaponHandler (self,EntityName,EventName):
		if self.Fired:
			return
		self.Fired=1
		me= Bladex.GetEntity(EntityName)
		if not me:
			return
		if not self.OwnerName:
			return
		owner= Bladex.GetEntity(self.OwnerName)
		if not owner:
			return
		Bladex.AddScheduledFunc(Bladex.GetTime()+1.0, self.SetTarget, (EntityName, self.OwnerName))
		me.Velocity=owner.Rel2AbsVector(0.0, -3500.0, 0.0)
		self.MissileShootSound.PlaySound(0)
		self.MissileWhileSound.PlaySound(-1)
		self.ThrownBy= owner  # this pointer may not be valid
		self.DissipateConc()
		Bladex.AddScheduledFunc(Bladex.GetTime()+20.0,self.CheckDestroyBall,(EntityName,))


	def WobblyHitFunc(self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		# Called on the impact of the ball on an Entity
		# NOTE: if the Damage parameter has been set to 0, this function will not be called.
		print EntityName+" inflicting hit to "+VictimName
		
		if VictimName != "BWorld" and VictimName != self.OwnerName and VictimName != self.DamageEntityName and Bladex.GetEntity(VictimName).Kind[:11] != "MagicShield":
			ball=Bladex.GetEntity(self.DamageEntityName)
			if ball:
				if not self.Hit:
					self.Hit= 1
					victim= Bladex.GetEntity(VictimName)
					#print " Fire hitting "+VictimName
					if victim.Person:
						Bladex.RemoveScheduledFunc("PostFunc"+self.Name)
						ball.Alpha=0.99
						victim.DamageFunc(VictimName, "Player1", self.DamageEntityName, "", 1, -1, ImpX, ImpY, ImpZ, 0)###
						# Override hurt anim
						if victim.Life>0:
							if victim.InCombat:
								victim.Wuea=Reference.WUEA_ENDED
								victim.InterruptCombat()
								victim.LaunchAnmType("hurt_f_big")
							else:
								victim.Wuea=Reference.WUEA_ENDED
								victim.InterruptCombat()
								victim.LaunchAnmType("hurt_f_big")
							if victim.Kind=="ChaosKnight":
								if victim.Life>=100:
									victim.Life = int(victim.Life/2)
								else:
									victim.Life=5
						self.OnHitFunc(self.Name,VictimName)
					elif victim.Weapon:
						if Reference.IsParryingType(victim.Kind):
							Bladex.RemoveScheduledFunc("PostFunc"+self.Name)
							ball.Alpha=0.99
							Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, self.BallDissipation, (), "PostFunc"+self.Name)
					else:
						Bladex.RemoveScheduledFunc("PostFunc"+self.Name)
						ball.Alpha=0.99
						Bladex.AddScheduledFunc(Bladex.GetTime()+0.5, self.BallDissipation, (), "PostFunc"+self.Name)
					
					

	def BallExpansion(self, ent_name, time):
		alpha_var=-0.066 #(0.0-0.99)/(0.5*30.0)
		scale_var=0.133 #(3.0-1.0)/(0.5*30.0)
		y_var=60.0 #900.0/(0.5*30.0)
		ball=Bladex.GetEntity(ent_name)
		x, y, z=ball.Position
		ball.Position=x, y+y_var, z
		ball.RotateRel(0.0, 0.0, 0.0, 0, 0, 1, -0.5)
		ball.Alpha=max(0.0, ball.Alpha+alpha_var)
		ball.Scale=ball.Scale+scale_var
		if ball.Scale>=3.0:
			ball.RemoveFromList("Timer30")
			ball.SubscribeToList("Pin")
			self.MissileShootSound=None
			self.MissileWhileSound=None
			self.MissileImpactSound=None
			self.ThrownBy=None
			self.FirePS=None


	def PrevOnHitFunc (self, EntityName, hit_entity):
		# Called on the impact of the ball with the world, or an Entity (if Damage parameter==1)
		if not hit_entity:
			self.OnHitFunc(EntityName, hit_entity)


	def OnHitFunc (self, EntityName, hit_entity):
		if self.Destroyed:
			return
		
		ball_name=self.DamageEntityName
		ball=Bladex.GetEntity(ball_name)
		x, y, z =0,0,0
		if ball:
			x, y, z=ball.Position
			ball.SelfIlum=1.0
		else:
			try:
				# balls sometimes get stuck
				x, y, z=Bladex.GetEntity(EntityName).Position
			except:
				pass
			
		
		impactlight=Bladex.CreateEntity(ball_name+"ImpactLight", "Entity Spot", x, y-800.0, z)
		impactlight.Color=140, 255, 160
		impactlight.Intensity=4.0
		impactlight.Precission=0.1
		impactlight.CastShadows=0
		impactlight.Flick=0
		impactlight.Visible=0
		AuxFuncs.SpotIntensityVariation(impactlight.Name, 4.0, 0.0, 1.4, 1)
		if self.MissileWhileSound: self.MissileWhileSound.StopSound()
		if self.MissileImpactSound: self.MissileImpactSound.PlaySound(0)
		victim= Bladex.GetEntity(hit_entity)
		if victim and victim.Person:
			impactps=Bladex.CreateEntity(ball_name+"ImpactPS", "Entity Particle System Dperson", 0, 0, 0)
			impactps.PersonName=hit_entity
			impactps.ParticleType="DeepPurpleMagicMissile"
			impactps.PPS=600
			impactps.YGravity=2000.0
			impactps.Friction=0.0
			impactps.RandomVelocity=5.0
			impactps.NormalVelocity=25.0
			impactps.Velocity=0.0, -1000.0, 0.0
			impactps.Time2Live=30
			impactps.DeathTime=Bladex.GetTime()+0.4
		ball.TimerFunc=self.BallExpansion
		if ball:
			ball.SubscribeToList("Timer30")
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.5,self.DestroyBall,(EntityName,),"DestroyBall"+EntityName)
		missile=Bladex.GetEntity(self.Name)
		missile.RemoveFromList("Timer30")
		missile.SubscribeToList("Pin")
		self.MissileShootSound=None
		self.MissileWhileSound=None
		self.MissileImpactSound=None
		self.ThrownBy=None
		self.FirePS=None
		if Reference.EntitiesObjectData.has_key(EntityName):
			del Reference.EntitiesObjectData[EntityName]
		self.Destroyed=1
		
	def CheckDestroyBall(self, EntityName):
		if not self.Destroyed:
			self.DestroyBall(EntityName)
	

	def DestroyBall(self,EntityName):
		ball_name=self.DamageEntityName
		ball=Bladex.GetEntity(ball_name)
		if ball: 
			ball.SubscribeToList("Pin")
			self.MissileShootSound=None
			self.MissileWhileSound=None
			self.MissileImpactSound=None
			self.ThrownBy=None
			self.FirePS=None
			print "Wobbly Gone"
			
			
			
def MakeWobblySpell1 (name, x,y,z, ownerName=""):
	missile= Bladex.CreateEntity(name, "Entity Magic Missile", x, y, z)
	missile.Data= WobblySpell1 (missile, ownerName)
	return missile
		
##########################################################################################################################################################
###### new lightning rope...

class Slicer(ItemTypes.PersistantItemType):
	Name=""
	OwnerName=""
	BoltName=""
	Speed= 6000   #12000.0
	MaxScale=5.6
	Range= 2500.0
	sp=None
	tp=None
	v=None
	TimeWeaponStarted=0.0
	WeaponActive=0
	loopsound=None
	Weapon=None
	ThrownBy=None
	ActiveTime=4.0
	
	
	def __init__(self, me, ownerName, damage):
		ItemTypes.PersistantItemType.__init__(self, me)
		me.Weapon=1
		me.Alpha= 0.0
		self.Name= me.Name
		self.OwnerName= ownerName
		self.Bolt1Name=""
		self.Speed= 6000.0
		self.Range= 2500.0
		self.MaxScale=6.0
		self.Damage= damage
		self.ActiveTime=4.0
		
		
		owner=Bladex.GetEntity(self.OwnerName)
		
		
		if owner:
			x,y,z= me.Position
			tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
			angley= -B3DLib.GetYAngle(tx-x,ty-y,tz-z)
			anglexz= B3DLib.Pos2PosXZAngle(x,y,z,tx,ty,tz)
			me.Orientation=0.707107,0.707107,0.000000,0.000000
			me.RotateRel(0,0,0, 0,-1,0, 3.14159/2.0)
			me.RotateRel(0,0,0, -1,0,0, (3.0*3.14159/2.0)-anglexz)
			me.RotateRel(0,0,0, 0,-1,0, -angley)
		
			self.Range= 30000.0
			damagefactor= int(self.Damage)/4

			me.InflictHitFunc= self.SlicerInflictHitFunc
			time= Bladex.GetTime()
		
			Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_WEAPON, damagefactor, 0, 1.0, Reference.THR_SPINNING,[],["Whip"]]
			
			x,y,z=me.GraspPos("Left")
			bolt1=Bladex.CreateEntity(self.Name+"Bolt1","Entity ElectricBolt", 0, 0, 0)
			me.Link (bolt1)
			bolt1.Position= x,y,z
			bolt1.MaxAmplitude=250.0
			bolt1.FixedTarget=0
			bolt1.Active= 1
			bolt1.Damage=0
			self.Bolt1Name=bolt1.Name
			self.FixRope()
			
		
			# Create a looped sound
			Sound1Name= "..\\..\\Sounds\\M-desliz-arana.wav"
			self.loopsound= Bladex.CreateEntity (me.Name+"LoopSound", "Entity Sound", 0, 0, 0)
			self.loopsound.SetSound (Sound1Name)
			self.loopsound.MinDistance=500
			self.loopsound.MaxDistance=20000
			me.Link(self.loopsound)
			
			
			Sound2Name= "..\\..\\Sounds\\slice-splat1.wav"
			self.perhitsound=Bladex.CreateEntity(me.Name+"perhitsound", "Entity Sound", 0,0,0)
			self.perhitsound.SetSound(Sound2Name)
			self.perhitsound.MinDistance=5000
			self.perhitsound.MaxDistance=30000
			
			
			
			
	def FixRope (self):
		me= Bladex.GetEntity (self.Name)
		bolt1= Bladex.GetEntity (self.Bolt1Name)
		bolt1.ETarget= ""
		sx,sy,sz= me.GraspPos ("Left")
		x,y,z= me.GraspPos ("Right")
		bolt1.Target= x,y,z
		bolt1.Active= 1
		
			
		
	def SlicerInflictHitFunc(self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		victim= Bladex.GetEntity(VictimName)
		if victim and victim.Person:
			print EntityName+" Hitting"+VictimName
			x,y,z=victim.Position
			self.perhitsound.Position=x,y,z
			self.perhitsound.PlaySound(0)
			
			
	def DestroyMe(self,EntityName):	
		me= Bladex.GetEntity(EntityName)
		bolt1=Bladex.GetEntity(self.Bolt1Name)
		if bolt1:
			bolt1.SubscribeToList("Pin")
		if me:
			Bladex.AddScheduledFunc(Bladex.GetTime()+0.2, me.SubscribeToList, ("Pin",), me.Name+" PinMe")
	


	def ThrowReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner:
			return
		
		owner.Unlink(weapon)
		weapon.ExcludeHitFor(owner)

		sp= weapon.Position
		tp= owner.Rel2AbsPoint(0,-30000.0,0.0)
		v= B3DLib.Normalize((tp[0]-sp[0], tp[1]-sp[1], tp[2]-sp[2]))
		self.sp= sp
		self.tp= tp
		self.v= v
		Bladex.SetAfterFrameFunc(self.Name+"SlicerMoveWeapon", self.MoveWeapon)
		self.TimeWeaponStarted= Bladex.GetTime()
		self.WeaponActive= 0
		self.Weapon= weapon
		self.ThrownBy= owner  # this pointer may not be valid
		
		
		SoundName= "..\\..\\Sounds\\disparo-cuchilla.wav"
		firesound=Bladex.CreateEntity(weapon.Name+"firesound", "Entity Sound", 0, 0, 0)
		firesound.SetSound(SoundName)
		firesound.MinDistance=5000
		firesound.MaxDistance=30000
		weapon.Link(firesound)
		firesound.PlaySound(0)
		self.loopsound.PlaySound(-1)


	def MoveWeapon (self, time):
		me= self.Weapon
		me.RemoveFromWorld()
		t= time-self.TimeWeaponStarted
		ax, ay, az= B3DLib.Scale(self.v,t*self.Speed)
		me.Position= self.sp[0]+ax, self.sp[1]+ay, self.sp[2]+az
		
		if me.Scale< self.MaxScale:
			me.Scale=me.Scale+0.04
		else:
			print "Full Size"

		if self.WeaponActive:
			if me.TestHit:
				print "Hit world"
				me.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				me.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
				self.loopsound.StopSound()
				Bladex.RemoveAfterFrameFunc(self.Name+"SlicerMoveWeapon")
				self.DestroyMe(self.Name)	
				
				SoundName= "..\\..\\Sounds\\impacto-cuchilla.wav"
				hitsound=Bladex.CreateEntity(me.Name+"hitsound", "Entity Sound", 0, 0, 0)
				hitsound.SetSound(SoundName)
				hitsound.MinDistance=5000
				hitsound.MaxDistance=30000
				me.Link(hitsound)
				hitsound.PlaySound(0)
		elif t>0.01:
			me.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
			me.MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
			self.WeaponActive= 1
		me.PutToWorld()


def MakeSlicer (name, x,y,z, ownerName="",damage=500):
	edge= Bladex.CreateEntity(name,"ProEdge1", x,y,z)
	edge.Scale=1.0
	edge.Weapon=1
	edge.Data= Slicer(edge, ownerName, damage)
	return edge
	

##########################################################################################################################################################

class Halfmoon(ItemTypes.PersistantItemType):
	Name=""
	OwnerName=""
	TrailName=""
	Speed= 12000.0
	Axis=(1.0,0.0,0.0)
	Spin= 0.15
	Range= 2500.0
	Time2Live=2.5
	MaxAlpha= 1.0
	StartingDamage=0.0
	AbsorbedDamage= 0.0
	AuxFuncsData= None
	sp=None
	tp=None
	v=None
	TimeWeaponStarted=0.0
	WeaponActive=0
	loopsound=None
	Weapon=None
	ThrownBy=None
	
	def __init__(self, me, ownerName, damage):
		ItemTypes.PersistantItemType.__init__(self, me)
		# Create a particle system around the object as it appears
		me.Weapon=1
		me.Alpha= 0.0
		self.Name= me.Name
		self.OwnerName= ownerName
		self.TrailName=self.Name+"_Trail"
		self.Speed= 12000.0
		self.Axis=B3DLib.Normalize((0.05,1.0,0.0))
		self.Spin= 0.15
		self.Range= 2500.0
		self.Damage= damage
		owner=Bladex.GetEntity(self.OwnerName)
		
		# Really want to align our orientation with that of the weapon before linking them
		if owner:
			owner.LinkAnchors("R_Hand",me,"1H_R")
			weapon= Bladex.GetEntity(owner.InvRight)
			if weapon:
				if weapon.Kind=="ProStaff1":
					self.Range= 30000.0
			damagefactor= int(self.Damage*3.0)
			print "Halfmoon Damage is ",damagefactor 
		
		me.InflictHitFunc= self.HalfmoonInflictHitFunc
		time= Bladex.GetTime()
		
		if self.Speed: self.Time2Live= self.Range/self.Speed
		else: self.Time2Live= self.Range/12000.0
		self.MaxAlpha= 0.3
		
		Reference.EntitiesObjectData[self.Name]= [Reference.OBJ_WEAPON, damagefactor, 0, 1.0, Reference.THR_SPINNING,[],["Ice", + damagefactor]]
		
		self.StartingDamage= Reference.EntitiesObjectData[me.Name][1]
		self.AbsorbedDamage= 0.0
		me.Alpha= self.MaxAlpha
		me.RasterMode="AdditiveAlpha"
		me.RasterMode="Read"
		me.SelfIlum=0.9
		
		# Create a looped sound
		SoundName= "..\\..\\Sounds\\rueda-metal.wav"
		self.loopsound= Bladex.CreateEntity (me.Name+"LoopSound", "Entity Sound", 0, 0, 0)
		self.loopsound.SetSound (SoundName)
		self.loopsound.MinDistance=500
		self.loopsound.MaxDistance=20000
		me.Link(self.loopsound)




	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)

		loopsoundName= ""
		WeaponName=""
		ThrownByName=""

		if self.loopsound: loopsoundName= self.loopsound.Name
		if self.Weapon: WeaponName=self.Weapon.Name
		if self.ThrownBy: ThrownByName=self.ThrownBy.Name
		
		state[1]["Halfmoon"]=(self.Name,
								self.OwnerName,
								self.TrailName,
								self.Speed,
								self.Axis,
								self.Spin,
								self.Range,
								self.Damge,
								self.Time2Live,
								self.MaxAlpha,
								self.StartingDamage,
								self.AbsorbedDamage,
								self.AuxFuncsData,
								self.sp,
								self.tp,
								self.v,
								self.TimeWeaponStarted,
								self.WeaponActive,
								loopsoundName,
								WeaponName,
								ThrownByName
								)
		return state

	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["Halfmoon"]

			loopsoundName= ""
			ThrownByName=""
			WeaponName=""
			
			(self.Name,
			self.OwnerName,
			self.TrailName,
			self.Speed,
			self.Axis,
			self.Spin,
			self.Range,
			self.Damage,
			self.Time2Live,
			self.MaxAlpha,
			self.StartingDamage,
			self.AbsorbedDamage,
			self.AuxFuncsData,
			self.sp,
			self.tp,
			self.v,
			self.TimeWeaponStarted,
			self.WeaponActive,
			loopsoundName,
			WeaponName,
			ThrownByName)= parms
			
			if loopsoundName: self.loopsound= Bladex.GetEntity(loopsoundName)
			if WeaponName: self.Weapon=Bladex.GetEntity(WeaponName)
			if ThrownByName: self.ThrownBy=Bladex.GetEntity(ThrownByName)
			
			me= Bladex.GetEntity(self.Name)
			if me: me.InflictHitFunc= self.HalfmoonInflictHitFunc
		else:
			self.Name="Unnamed"


	def FadeOut(self,EntityName):	
		# to be called upon impact with the world??
		me= Bladex.GetEntity(EntityName)
		if me:
			fadeTime= 0.6
			AuxFuncs.FadeObject(me.Name, me.Alpha, 0.0, fadeTime)
			Bladex.AddScheduledFunc(Bladex.GetTime()+fadeTime+0.2, me.SubscribeToList, ("Pin",), me.Name+" PinMe")


	def HalfmoonInflictHitFunc(self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		print "HalfmoonTrail hitting "+VictimName
		victim= Bladex.GetEntity(VictimName)
		if victim and victim.Person:
			charFDef= max(CharStats.GetCharDefenseData(victim.CharType,victim.Level),0.0)
			self.AbsorbedDamage= self.AbsorbedDamage + charFDef
			victim.DamageFunc(VictimName, "Player1", EntityName, "Light", 1, -1, ImpX, ImpY, ImpZ, 0)
	
	
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if not owner:
			return
		
		owner.Unlink(weapon)
		weapon.ExcludeHitFor(owner)

		sp= weapon.Position
		tp= owner.Rel2AbsPoint(-3500,-30000.0,0.0)
		v= B3DLib.Normalize((tp[0]-sp[0], tp[1]-sp[1], tp[2]-sp[2]))
		self.sp= sp
		self.tp= tp
		self.v= v
		Bladex.SetAfterFrameFunc(self.Name+"HalfmoonTrailMoveWeapon", self.MoveWeapon)
		self.TimeWeaponStarted= Bladex.GetTime()
		self.WeaponActive= 0
		self.Weapon= weapon
		self.ThrownBy= owner  # this pointer may not be valid

		traildisk=Bladex.CreateEntity(self.TrailName,"Entity Particle System Dobj", 0, 0, 0)
		traildisk.ObjectName=self.Name
		traildisk.ParticleType="MoonMagicMissile"
		traildisk.PPS=800
		traildisk.YGravity=0.0
		traildisk.Friction=0.01
		traildisk.RandomVelocity=16.0
		traildisk.NormalVelocity=0.0
		traildisk.Velocity=v[0]*3000.0, v[1]*3000.0, v[2]*3000.0
		traildisk.Time2Live=20
		traildisk.FollowFactor=0.0

		# Create a firing sound
		SoundName= "..\\..\\Sounds\\disparo-cuchilla.wav"
		firesound=Bladex.CreateEntity(weapon.Name+"firesound", "Entity Sound", 0, 0, 0)
		firesound.SetSound(SoundName)
		firesound.MinDistance=5000
		firesound.MaxDistance=30000
		weapon.Link(firesound)
		firesound.PlaySound(0)
		self.loopsound.PlaySound(-1)


	def MoveWeapon (self, time):
		me= self.Weapon
		me.RemoveFromWorld()
		t= time-self.TimeWeaponStarted
		ax, ay, az= B3DLib.Scale(self.v,t*self.Speed)
		me.Position= self.sp[0]+ax, self.sp[1]+ay, self.sp[2]+az

		# Reduce DamagePoints and Alpha	
		current_damage= max(0.0, self.StartingDamage*(1.0-(t/self.Time2Live))-self.AbsorbedDamage)
		intensity= current_damage/self.StartingDamage
		Reference.EntitiesObjectData[me.Name][1]= current_damage
		me.Alpha= self.MaxAlpha*intensity

		if self.WeaponActive:
			if me.TestHit:
				print "Hit world"
				me.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				me.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
				self.loopsound.StopSound()
				Bladex.RemoveAfterFrameFunc(self.Name+"HalfmoonTrailMoveWeapon")
				self.FadeOut(self.Name)	
				ps=Bladex.GetEntity(self.TrailName)
				if ps:
					ps.PPS=8000
					ps.YGravity=6900.0
					ps.RandomVelocity=90.0
					ps.RandomVelocity_V=45.0
					ps.DeathTime=Bladex.GetTime()+0.05
				# Play a hut world sound
				# Create a firing sound
				SoundName= "..\\..\\Sounds\\impacto-cuchilla.wav"
				hitsound=Bladex.CreateEntity(me.Name+"hitsound", "Entity Sound", 0, 0, 0)
				hitsound.SetSound(SoundName)
				hitsound.MinDistance=5000
				hitsound.MaxDistance=30000
				me.Link(hitsound)
				hitsound.PlaySound(0)
			if intensity<=0.0:
				me.MessageEvent(Reference.MESSAGE_STOP_WEAPON,0,0)
				me.MessageEvent(Reference.MESSAGE_STOP_TRAIL,0,0)
				self.WeaponActive= 0
				self.loopsound.StopSound()
				Bladex.RemoveAfterFrameFunc(self.Name+"HalfmoonTrailMoveWeapon")
				self.FadeOut(self.Name)	
				ps=Bladex.GetEntity(self.TrailName)
				if ps:
					ps.PPS=400
					ps.DeathTime=Bladex.GetTime()+0.05
		elif t>0.01:
			me.MessageEvent(Reference.MESSAGE_START_WEAPON,0,0)
			me.MessageEvent(Reference.MESSAGE_START_TRAIL,0,0)
			self.WeaponActive= 1
		# Angular velocity
		#me.RotateRel(0.0, 0.0, 0.0,self.Axis[0],self.Axis[1],self.Axis[2],self.Spin,1)
		me.PutToWorld()
		
		
		
		
def MakeHalfmoon (name, x,y,z, ownerName="",damage=500):
	missile= Bladex.CreateEntity(name, "HalfmoonTrail", x, y, z)
	missile.Weapon=1
	missile.Data= Halfmoon(missile, ownerName, damage)
	return missile
	
	
	
########################################################################################################################################################


class FlyingMagicSkull(ItemTypes.PersistantItemType):

	Destroyed=0
	
	def __init__(self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		
		me.Weapon= 1
		self.Age= 0
		self.OwnerName="Player1"
		self.Name= me.Name
		self.Destroyed=0
		
		
		self.missilesound1=Bladex.CreateSound("..\\..\\Sounds\\M-IMPACTO-FUEGO.wav", "MissileSound1")
		self.missilesound1.Volume=0.6
		self.missilesound1.MinDistance=10000
		self.missilesound1.MaxDistance=20000
		
		self.missilesound2=Bladex.CreateSound("..\\..\\Sounds\\bugbite-bone2.wav", "MissileSound2")
		self.missilesound2.Volume=0.6
		self.missilesound2.MinDistance=10000
		self.missilesound2.MaxDistance=20000
		
		self.missilesound3=Bladex.CreateSound("..\\..\\Sounds\\Demon-spirit1.wav", "MissileSound3")
		self.missilesound3.Volume=1.0
		self.missilesound3.MinDistance=10000
		self.missilesound3.MaxDistance=20000
		
		self.missilesound4=Bladex.CreateSound("..\\..\\Sounds\\Demon-spirit3.wav", "MissileSound4")
		self.missilesound4.Volume=1.0
		self.missilesound4.MinDistance=10000
		self.missilesound4.MaxDistance=20000
		
		
		self.missilesound5=Bladex.CreateSound("..\\..\\Sounds\\Demon-spirit2.wav", "MissileSound5")
		self.missilesound5.Volume=1.0
		self.missilesound5.MinDistance=10000
		self.missilesound5.MaxDistance=20000
		
		self.missilesound6=Bladex.CreateSound("..\\..\\Sounds\\Demon-spirit5.wav", "MissileSound6")
		self.missilesound6.Volume=1.0
		self.missilesound6.MinDistance=10000
		self.missilesound6.MaxDistance=20000
		
		
		

	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		state[1]["FlyingMagicSkull"]=   (self.Age, self.OwnerName, self.Name, self.Destroyed,)
													
		return state
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["FlyingMagicSkull"]
			self.Age=parms[0]
			self.OwnerName=  parms[1]
			self.Name= parms[2]
			self.Destroyed=parms[3]
		else:
			self.Age=0
			self.OwnerName= ""
			self.Name= ""
			self.Destroyed=0
		self.missilesound1=Bladex.CreateSound("..\\..\\Sounds\\M-IMPACTO-FUEGO.wav", "MissileSound1")
		self.missilesound1.Volume=0.6
		self.missilesound1.MinDistance=10000
		self.missilesound1.MaxDistance=20000
		
		self.missilesound2=Bladex.CreateSound("..\\..\\Sounds\\bugbite-bone2.wav", "MissileSound2")
		self.missilesound2.Volume=0.6
		self.missilesound2.MinDistance=10000
		self.missilesound2.MaxDistance=20000
		
		self.missilesound3=Bladex.CreateSound("..\\..\\Sounds\\Demon-spirit1.wav", "MissileSound3")
		self.missilesound3.Volume=1.0
		self.missilesound3.MinDistance=10000
		self.missilesound3.MaxDistance=20000
		
		self.missilesound4=Bladex.CreateSound("..\\..\\Sounds\\Demon-spirit3.wav", "MissileSound4")
		self.missilesound4.Volume=1.0
		self.missilesound4.MinDistance=10000
		self.missilesound4.MaxDistance=20000
		
		
		self.missilesound5=Bladex.CreateSound("..\\..\\Sounds\\Demon-spirit2.wav", "MissileSound5")
		self.missilesound5.Volume=1.0
		self.missilesound5.MinDistance=10000
		self.missilesound5.MaxDistance=20000
		
		self.missilesound6=Bladex.CreateSound("..\\..\\Sounds\\Demon-spirit5.wav", "MissileSound6")
		self.missilesound6.Volume=1.0
		self.missilesound6.MinDistance=10000
		self.missilesound6.MaxDistance=20000
		

	
	
	def MissileImpact(self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		victim=Bladex.GetEntity(VictimName)
		if victim and victim.Person:
			victim.DamageFunc(VictimName, "Player1",EntityName, "Steal", 1, -1, ImpX, ImpY, ImpZ, 0)###
		missile=Bladex.GetEntity(EntityName)
		missile.Data.missilesound.StopSound()
		x, y, z=missile.Position
		self.missilesound2.Play(x, y, z, 0)
		impactps=Bladex.CreateEntity("ImpactPS", "Entity Particle System D1", x, y, z)
		impactps.ParticleType="SkullMagicMissile"
		impactps.PPS=2000
		impactps.YGravity=1400.0
		impactps.Friction=0.06
		impactps.Velocity=-ImpX/5.0, -ImpY/5.0, -ImpZ/5.0
		impactps.RandomVelocity=40.0
		impactps.Time2Live=20
		impactps.DeathTime=Bladex.GetTime()+0.25
		luzimp=Bladex.CreateEntity("LuzImpacto", "Entity Spot", x-ImpX/10.0, y-ImpY/10.0, z-ImpZ/10.0)
		luzimp.Color=200, 200, 255
		luzimp.Intensity=1.0
		luzimp.Precission=0.001
		luzimp.CastShadows=0
		luzimp.Flick=0
		luzimp.Visible=0
		missileesphere=missile.Data.Sphere
		if missileesphere:
			missile.Unlink(missileesphere)
		AuxFuncs.SpotIntensityVariation(luzimp.Name, 1.0, 0.0, 1.0, 1)
		missile.Data.OldInflictHitFunc(EntityName, VictimName, ImpX, ImpY, ImpZ)		
		Bladex.AddScheduledFunc(Bladex.GetTime(), self.DeleteMissile, (missile.Name,),"DeleteMissile")


	def DeleteMissile(self, missileName):
		if self.Destroyed:
			print "Flying Skull already destroyed"
			return
		missile=Bladex.GetEntity(missileName)
		if missile:
			if Reference.EntitiesObjectData.has_key(missile.Name):
				del Reference.EntitiesObjectData[missile.Name]
			missile.Damage=0
			missile.SubscribeToList("Pin")
		weapon=Bladex.GetEntity(self.Name)
		if weapon:
			weapon.SubscribeToList("Pin")
		self.Destroyed=1
		
		
	
	def MissileOnHit (self, MissileName, hit_entity):
		missile=Bladex.GetEntity(MissileName)
		if hit_entity:
			print MissileName+" hitting "+hit_entity
			pass
		else:
			missile.Data.missilesound.StopSound()
			x, y, z=missile.Position
			self.missilesound2.Play(x, y, z, 0)
			impactps=Bladex.CreateEntity("ImpactPS", "Entity Particle System D1", x, y, z)
			impactps.ParticleType="SkullMagicMissile"
			impactps.PPS=2000
			impactps.YGravity=1400.0
			impactps.Friction=0.06
			impactps.RandomVelocity=40.0
			impactps.Time2Live=20
			impactps.DeathTime=Bladex.GetTime()+0.25
			luzimp=Bladex.CreateEntity("LuzImpacto", "Entity Spot", x, y, z)
			luzimp.Color=200, 200, 255
			luzimp.Intensity=1.0
			luzimp.Precission=0.001
			luzimp.CastShadows=0
			luzimp.Flick=0
			luzimp.Visible=0
			missileesphere=missile.Data.Sphere			
			if missileesphere:
				missile.Unlink(missileesphere)
			AuxFuncs.SpotIntensityVariation(luzimp.Name, 1.0, 0.0, 1.0, 1)			
			Bladex.AddScheduledFunc(Bladex.GetTime(), self.DeleteMissile, (missile.Name,),"DeleteMissile")
	
	
	
	def ChooseCanISeeNearest (self, entity1name, entity2name):
		p1 = Bladex.GetEntity(entity1name)
		p2 = Bladex.GetEntity(entity2name)
		if not p1 and not p2:
			return CHOOSE_EITHER
		elif not p1:
			return CHOOSE_SECOND
		elif not p2:
			return CHOOSE_FIRST

		if p1.Life <= 0 and p2.Life <= 0:
			return CHOOSE_EITHER
		elif p1.Life <= 0:
			return CHOOSE_SECOND
		elif p2.Life <= 0:
			return CHOOSE_FIRST

		me=Bladex.GetEntity(self.Name)

		if not me.CanISee(p1) and not me.CanISee(p2) <= 0:
			return CHOOSE_EITHER
		elif not me.CanISee(p1):
			return CHOOSE_SECOND
		elif not me.CanISee(p2):
			return CHOOSE_FIRST


		val = me.SQDistance2(p1) - me.SQDistance2(p2)

		if val < 0:
			return CHOOSE_FIRST
		elif val > 0:
			return CHOOSE_SECOND
		else:
			return CHOOSE_EITHER

	
	def InitLaunch(self):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		self.OwnerName= "Player1"
		owner=Bladex.GetEntity(self.OwnerName)
		if weapon.TestHit:
			return
		weapon.ExcludeHitFor(owner)
		weapon.RotateRel(0,0,0, 1,0,0, 3.14159/2.0)
		init_pos=weapon.Position
		end_pos=owner.Rel2AbsPoint(0.0,-4000.0,3000)
		weapondin=Objects.CreateDinamicObject(weapon.Name)
		Objects.DisplaceObjectFromTo(weapondin, init_pos, end_pos, 5000.0, 0.0, "", "", "", "", (), self.SeekEnemy,(weapon.Name,))
		num= whrandom.random()
		if num<0.2:
			self.missilesound4.Play(init_pos[0],init_pos[1],init_pos[2],0)
		elif num<0.4:
			self.missilesound4.Play(init_pos[0],init_pos[1],init_pos[2],0)
		elif num<0.6:
			self.missilesound4.Play(init_pos[0],init_pos[1],init_pos[2],0)
		elif num<0.8:
			self.missilesound4.Play(init_pos[0],init_pos[1],init_pos[2],0)
		
		
		
	def SeekEnemy(self, WeaponName):
		print "Seek Enemy"
		weapon= Bladex.GetEntity(WeaponName)
		x,y,z= weapon.Position
		owner=Bladex.GetEntity(self.OwnerName)
		target_pos= owner.Rel2AbsPoint(0,-20000.0,4000.0)
		
		if owner.ActiveEnemy:
			target= Bladex.GetEntity(owner.ActiveEnemy)
			target_pos= target.Position
		else:
			tlist=[]
			for ename in Bladex.GetEntitiesAt(x,y,z, 50000):
				target = Bladex.GetEntity(ename)
				if target and target.Person and owner.CanISee(target):
					if target.Life>0 and target.Alpha>0.9 and MasklinTypes.CheckIfAlly(target.Name) and target.Name !="Player1":
						tlist.append(target.Name)
						print "Skull target found-> ",target.Name
						break
			if len(tlist)==0:			
				print "No Target -> Abort"
				weapon.SubscribeToList("Pin")
				ps=Bladex.CreateEntity(WeaponName+"DissFX","Entity Particle System D1", x, y, z)
				ps.ParticleType="RedSpark"
				ps.FollowFactor=1.0
				ps.YGravity=0
				ps.RandomVelocity=30
				ps.Velocity=0.0,0.0, 0.0
				ps.Time2Live=8
				ps.PPS=800
				ps.DeathTime=Bladex.GetTime()+0.3
				return
			tlist.sort(self.ChooseCanISeeNearest)
                   	target_pos= Bladex.GetEntity(tlist[0]).Position	
			
		print"Start seeking....."
		angle= -B3DLib.GetYAngle(target_pos[0]-x,target_pos[1]-y,target_pos[2]-z)
		vx,vy,vz=owner.Rel2AbsVector(0.0, -math.cos(angle)*6000, -math.sin(angle)*6000)
		
		self.Age= self.Age+1
		self.missilesound1.Play(x, y, z, 0)
				
		missileps1=Bladex.CreateEntity("MissilePS1", "Entity Particle System D1", 0.0, 0.0, 0.0)
		missileps1.ParticleType="SkullMagicMissile"
		missileps1.PPS=100  #200
		missileps1.YGravity=0.0
		missileps1.Friction=0.08
		missileps1.Velocity=0.0, 0.0, 0.0
		missileps1.RandomVelocity=15.0
		missileps1.Time2Live=30
		
		if target:
			missile=ItemTypes.MakeHunterSeekerMissile("MM1", x,y,z,vx,vy,vz, target.Name)
		else:
			# not really needed as skull will not seek if no enemy
			missile=ItemTypes.MakeHunterSeekerMissile("MM1", x,y,z,vx,vy,vz,"")		
		
		missile.Intensity=1.0
		missile.Color= 0.0,0.0,0.0
		missile.CastShadows=0
		missile.Visible=0
		missile.Flick=0
		missilesound=Bladex.CreateEntity("MissileSound", "Entity Sound", 0, 0, 0)
		missilesound.SetSound("..\\..\\Sounds\\Espiritus1.wav")
		missilesound.MinDistance=10000
		missilesound.MaxDistance=20000
		missile.Link(missilesound)
		missile.Link(missileps1)
		missile.Link(weapon)
		missileps1.FollowFactor=1.0 
		missilesound.PlaySound(-1)
		InitDataField.Initialise(missile)
		missile.Data.OldInflictHitFunc=missile.InflictHitFunc
		missile.InflictHitFunc=self.MissileImpact
		missile.OnHitFunc=self.MissileOnHit
		missile.Data.missilesound=missilesound
		missile.Data.Sphere=weapon
		
		## add damage stuff here
		lvl=Bladex.GetEntity("Player1").Level+1
		damfact=lvl*lvl   #lvl*3
		Reference.EntitiesObjectData[missile.Name]=  [Reference.OBJ_WEAPON,  damfact,  0, 1.0,  Reference.THR_STRAIGHT, [],["Steal"]]
		Bladex.AddScheduledFunc(Bladex.GetTime()+25, self.DeleteMissile, (missile.Name,),"DeleteMissile")
		
#########################################################################################################################################################

class EnchantedWeapon(ItemTypes.PersistantItemType):

	spinsound=None
	Spin= -0.8    
	Axis= (1.0, 0.0, 0.0)
	Speed= 7000.0
	missileName= ""
	OwnerName="Player1"
	LastHitTime=-1
	IChuckedIt=0
	Age= 0
	SpellLiteName=""
	IAmMagic=1
	
	def __init__(self, me):
		ItemTypes.PersistantItemType.__init__(self, me)
		
		me.Weapon= 1
		self.Age= 0
		self.Speed= 7000.0
		self.missileName= ""
		self.LastHitTime=-1
		self.IChuckedIt=0
		self.OwnerName="Player1"
		self.Name= me.Name
		self.Axis= (1.0, 0.0, 0.0)
		self.Spin= -0.8                
		self.SpellLiteName=""
		self.IAmMagic=1
				
		SoundName= "..\\..\\Sounds\\vueltas-en-el-aire.wav"
		self.spinsound= Bladex.CreateEntity (me.Name+"SpinSound", "Entity Sound", 0, 0, 0)
		self.spinsound.SetSound (SoundName)
		self.spinsound.MinDistance=500
		self.spinsound.MaxDistance=20000
		me.Link(self.spinsound)
		
		

	def __getstate__(self):
		state= ItemTypes.PersistantItemType.__getstate__(self)
		spinsoundName= ""
		if self.spinsound: 
			spinsoundName= self.spinsound.Name
		
		state[1]["EnchantedWeapon"]=   (self.Age,
						self.Speed,
						self.missileName,
						self.LastHitTime,
						self.OwnerName,
						self.Name,
						self.spinsound.Name,
						self.Axis,
						self.Spin,
						self.SpellLiteName)
		return state
		
		
	def __setstate__(self,parm):
		ItemTypes.PersistantItemType.__setstate__(self,parm)
		if parm[0]==1:
			parms=parm[1]["EnchantedWeapon"]
			self.Age=parms[0]
			self.Speed=parms[1]
			self.missileName= parms[2]
			self.LastHitTime= parms[3]
			self.OwnerName=  parms[4]
			self.Name= parms[5]
			self.spinsound=Bladex.GetSound(parms[6])
			self.Axis=parms[7]
			self.Spin=parms[8]
			self.SpellLiteName=parms[9]
		else:
			self.Age=0
			self.Speed= 10000.0
			self.missileName= ""
			self.LastHitTime=-1
			self.OwnerName= ""
			self.Name= ""
			self.spinsound=""
			self.Axis= (1.0, 0.0, 0.0)
			self.Spin= -0.8
			self.SpellLiteName=""
		
		if self.missileName:
			missile= Bladex.GetEntity(self.missileName)
			if missile:
				missile.InflictHitFunc= self.MyInflictHitFunc
				missile.OnHitFunc= self.WeaponOnHitFunc
				#if weapon:
				#	weapon.InflictHitFunc= self.MyInflictHitFunc
			else:
				print "Missile "+self.missileName+" unavailable for linking...."

	
	
	def ThrowReleaseEventHandler (self,EntityName,EventName):
		weapon= Bladex.GetEntity(self.Name)
		if not weapon:
			return
		if not self.OwnerName:
			return
		owner=Bladex.GetEntity(self.OwnerName)
		if owner.Kind != "Wizard_A":
			return
		if not owner or owner.InvRight != self.Name:
			return
		if weapon.TestHit:
			return
		weapon.ExcludeHitFor(owner)
		self.IChuckedIt=1
		Actions.RemoveFromInventory (owner, weapon, EventName)
		self.Age= self.Age+1
		x,y,z= weapon.Position
		missile= Bladex.CreateEntity(self.Name+"_Missile_"+`self.Age`, "Entity Magic Missile", x,y,z)
		InitDataField.Initialise(missile)
		missile.CastShadows=0
		missile.Color=0, 0, 0
		self.missileName= missile.Name
		self.weaponName= weapon.Name
		list=[]
		pj_dir=owner.Rel2AbsVector(0.0,-1.0,0.0)
		abovehead_pos=owner.Rel2AbsPoint(0.0,0.0,2000)
		tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
		
		if owner.ActiveEnemy:
			enemy= Bladex.GetEntity(owner.ActiveEnemy)
			if enemy and enemy.Person:
				tx1,ty1,tz1= enemy.GraspPos ("ViewPoint")
				tx2,ty2,tz2= enemy.Position
				tx= (tx1+tx2)/2.0; ty= (ty1+ty2)/2.0; tz= (tz1+tz2)/2.0; 
			else:
				tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
		else:
			list=Bladex.GetEnemiesVisibleFrom(abovehead_pos,30000,pj_dir,0.0)
			for id in list:
				enemy = Bladex.GetEntity(id)
				if enemy and enemy.Person:
					if enemy.Life>0 and MasklinTypes.CheckIfAlly(enemy.Name):
						tx1,ty1,tz1= enemy.GraspPos ("ViewPoint")
					
						tx2,ty2,tz2= enemy.Position
						tx= (tx1+tx2)/2.0; ty= (ty1+ty2)/2.0; tz= (tz1+tz2)/2.0; 
						break
						print"target set for enemy on high wall"
					else:
						tx,ty,tz= owner.Rel2AbsPoint(0,-30000.0,0.0)
					
		angley= -B3DLib.GetYAngle(tx-x,ty-y,tz-z)
		vx,vy,vz= owner.Rel2AbsVector(0.0, -math.cos(angley)*self.Speed, -math.sin(angley)*self.Speed)
		
		anglexz= B3DLib.Pos2PosXZAngle(x,y,z,tx,ty,tz)
		diff_angle= min (max (B3DLib.DiffAngle(anglexz, owner.Angle), -Actions.FACINGANGLE), Actions.FACINGANGLE)
		cos_ang= math.cos(diff_angle); sin_ang= math.sin(diff_angle)
		vx,vy,vz=  (vx*cos_ang-vz*sin_ang, vy, vx*sin_ang+vz*cos_ang)
		
		lite=Bladex.CreateEntity(self.Name+"Lite","Entity Spot",x,y,z)
		lite.Color=140, 180, 255
		lite.Intensity=0.0
		lite.CastShadows=0
		lite.Visible=1
		self.LiteName=lite.Name
		weapon.Link(lite)
		AuxFuncs.SpotIntensityVariation(lite.Name, 0.0, 0.02, 1.0, 0, 1.0, 2.0)
		
		#weapon.Orientation=0.707107,0.707107,0.0,0.0
		#weapon.RotateRel(0,0,0, 0,-1,0, 3.14159/2.0)
		#weapon.RotateRel(0,0,0, -1,0,0, (3.0*3.14159/2.0)-anglexz)
		#weapon.RotateRel(0,0,0, 0,-1,0, -angley)
		#weapon.RotateRel(0,0,0, 1,0,0, -3.14159/2.0)
		
		#weapon.RotateRel(0,0,0, 0,0,1, 3.14159/20.0)
		
		weapon.Position=0, 0, 0
		missile.Link(weapon)
		
		missile.Velocity= vx,vy,vz
		
		missile.Data.ThrownBy = owner  		# this pointer may not be valid
		
		Bladex.SetAfterFrameFunc("WeaponSpinWeapon", self.SpinWeapon)
		
		Reference.EntitiesObjectData[missile.Name]=  [Reference.OBJ_WEAPON,  2, 0, 1.0,  Reference.THR_SPINNING, [Reference.W_FLAG_1H,]]
		if Reference.EntitiesObjectData.has_key(weapon.Name):
			wphp=Reference.DefaultObjectData[weapon.Name][1]
		else:
			wphp=Reference.DefaultObjectData[weapon.Kind][1]
		nudamage=wphp*6
		Reference.EntitiesObjectData[missile.Name][1]=nudamage
	
		missile.OnHitFunc= self.WeaponOnHitFunc
		weapon.InflictHitFunc=0                       #self.MyInflictHitFunc
		missile.InflictHitFunc= self.MyInflictHitFunc
		
		self.spinsound.PlaySound(-1)
		print "Weapon thrown"
	
		
		
	def SpinWeapon(self,time):
		weapon= Bladex.GetEntity(self.weaponName)
		if weapon:
			weapon.RotateRel(0.0, 0.0, 0.0 ,self.Axis[0],self.Axis[1],self.Axis[2],self.Spin,1)
		
		
		
		
	def MyInflictHitFunc(self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		if self.missileName:
			self.WeaponOnHitFunc (self.missileName, VictimName)
			victim=Bladex.GetEntity(VictimName)
			if victim and victim.Person:
				victim.DamageFunc(VictimName, "Player1", EntityName, "Slash", 1, -1, ImpX, ImpY, ImpZ, 0)
				print EntityName+" whacked "+VictimName
			
	
	def DeleteMissileData(self):
		if self.missileName and Reference.EntitiesObjectData.has_key(self.missileName):
			del Reference.EntitiesObjectData[self.missileName]
			self.missileName= ""
			
			
			
			
	def WeaponOnHitFunc (self, EntityName, hit_entity):
		if hit_entity:
			thing=Bladex.GetEntity(hit_entity)
			if thing.Person:
				print "hitting"+hit_entity
			else:
				print  "hitting"+hit_entity
		else:
			print "hitting world"
			
		Bladex.RemoveAfterFrameFunc("WeaponSpinWeapon")
		time=Bladex.GetTime()
		if time==self.LastHitTime:
			return
		missile= Bladex.GetEntity(EntityName)
		weapon= Bladex.GetEntity(self.Name)
		if weapon:
			
			weapon.Alpha= 1.0
			weapon.Impulse(0,0,0)
			if self.LiteName:
				lite=Bladex.GetEntity(self.LiteName)
				weapon.Unlink(lite)
				AuxFuncs.SpotIntensityVariation(self.LiteName, 0.02, 0.0, 1.0, 1, 2.0, 0.0)
			
		if weapon and missile:
			Bladex.AddScheduledFunc(time, self.DeleteMissileData, (), "DeleteMissileData")
			missile.Unlink(weapon)
			missile.Stop()
			missile.SubscribeToList("Pin")
		self.spinsound.StopSound()
		self.IChuckedIt=0
		print"FINISHED"
			
		
#########################################################################################################################################################
#### Base Class for conjoured demos only


class Ally_Demon (Ally_Def.NPCAlly):

	Lifetime=10
	
	def __init__(self, me):
		# base class init		
		Ally_Def.NPCAlly.__init__(self, me)
		
		if (me.Level+1)>=3:
			self.Lifetime=(me.Level+1)*8
		else:
			self.Lifetime=25.0
			
		me.Alpha=0.7
		self.SetLifeTime()
		
	def SetLifeTime(self):
		Bladex.AddScheduledFunc(Bladex.GetTime()+ self.Lifetime ,self.DestroyDemon,())	
			
	def DestroyDemon(self):
		dem=Bladex.GetEntity(self.Name)
		if dem.Life>0:
			DeathDisappears(dem.Name)
			
			
	def OnKilledEnemy(self,KilledEntityName):
		Ally_Def.NPCAlly.OnKilledEnemy(self,KilledEntityName)
		me=Bladex.GetEntity(self.Name)
		# Wiz gets XP from kills by demons he has created
		owner=Bladex.GetEntity("Player1")
		if owner.Life>0:
			owner.Data.GetAllyMagicReward(KilledEntityName)
			
			
	def __getstate__(self):
		NPCAlly_state=Ally_Def.NPCAlly.__getstate__(self)
		if(NPCAlly_state[0]!=1):
			return NPCAlly_state
		NPCAlly_state[1]["Ally_Demon"]=(self.Lifetime,)
		return NPCAlly_state
	
	def __setstate__(self,parm):
		Ally_Def.NPCAlly.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Ally_Demon"]
			self.Lifetime=parms[0]



class EntitiesFader(Interpolator.LinearInt):
	"Clase para hacer desaparecer una entidad"

	def __init__(self, Entities2Fade):
		Interpolator.LinearInt.__init__ (self,1.0,0.0)
		self.ObjId=ObjStore.GetNewId() 
		ObjStore.ObjectsStore[self.ObjId]=self

		name= "Entity Fader for; "
		for entity_name in Entities2Fade:
			name= name+entity_name+", "
		self.Interpolator= Interpolator.Interp(name)
		self.Entities2Fade= Entities2Fade

	
	def persistent_id(self):
		return self.ObjId

	def __getstate__(self):
		# Tiene que devolver c䮯 poder guardar el estado de la clase
		return (1,
			self.ObjId,
			self.Interpolator,
			self.Entities2Fade
			)

	def __setstate__(self,parm):
		# Toma como par⮥tro lo que devuelve __getstate__() y debe recrear la clase
		if parm[0]==1:
			self.ObjId=parm[1]
			ObjStore.ObjectsStore[self.ObjId]=self
			self.Interpolator=parm[2]
			self.Entities2Fade=parm[3]
			self.init_value=1.0
			self.end_value=0.0
			self.period=self.end_value-self.init_value
		else:
			print "Warning -> Version mismatch in EntitiesFader.__setstate__()"
			self.Interpolator= None
			self.Entities2Fade= None
			self.init_value=1.0
			self.end_value=0.0
			self.period=self.end_value-self.init_value
			
			self.ObjId=ObjStore.GetNewId() # Para identificarlo al grabar/guardar
			ObjStore.ObjectsStore[self.ObjId]=self

	def ExecuteFadeOut(self,value):
		#pdb.set_trace()
		ret= Interpolator.LinearInt.Execute(self,value)
		for entity_name in self.Entities2Fade:
			entity= Bladex.GetEntity(entity_name)
			if entity:
				entity.Alpha= ret
	
	def ExecuteFadeIn(self,value):
		ret= Interpolator.LinearInt.Execute(self,value)
		for entity_name in self.Entities2Fade:
			entity= Bladex.GetEntity(entity_name)
			if entity:
				entity.Alpha= 1.0-ret
	
	def FadeOut(self, period):
		self.Interpolator.Actions=[]
		self.Execute= self.ExecuteFadeOut
		time= Bladex.GetTime()
		self.Interpolator.AddAction (time,time+period,self)
	
	def FadeIn(self, period):
		#pdb.set_trace()
		self.Interpolator.Actions=[]
		self.Execute= self.ExecuteFadeIn
		time= Bladex.GetTime()
		self.Interpolator.AddAction (time,time+period,self)
	
	def Stop(self):
		self.Interpolator.Actions=[]
		
	def EndExecute(self):
		if self.Execute== self.ExecuteFadeIn:
			for entity_name in self.Entities2Fade:
				entity= Bladex.GetEntity(entity_name)
				if entity:
					entity.Alpha= 1.0
		elif  self.Execute== self.ExecuteFadeOut:
			for entity_name in self.Entities2Fade:
				entity= Bladex.GetEntity(entity_name)
				if entity:
					entity.Alpha= 0.0




class Little_Demon (Ally_Demon):

	Fader=None
	FadeOutTime= 0.23333
	FadeInTime= 0.23333
	TransitTime= 0.0
	AGE_Number=0
	ImplosionPeriod = 2.5
	DeathBallPeriod = 3.5

	def __init__(self, me):
		# base class init		
		Ally_Demon.__init__(self, me)
		me.ImDeadFunc=self.ImDeadFunc
		me.MutilateFunc=self.NewMutilateFunc
		
		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
			
		# Create a linear interpolator for fading
		FadeList=[me.Name]
		self.Fader= EntitiesFader (FadeList)

		self.DamageFactorNone  = 0.1
		self.DamageFactorLight = 0.2

		me.AddAnmEventFunc("Spit", self.StartSpit)
		me.AddAnmEventFunc("Disappear", self.Disappear)
		me.AddAnmEventFunc("EndZig", self.EndZig)
		me.AddAnmEventFunc("EndZag", self.EndZag)
	
	

	def __getstate__(self):
		NPCAlly_state=Ally_Def.NPCAlly.__getstate__(self)
		if(NPCAlly_state[0]!=1):
			print "ERROR: Little_Demon.__getstate__(): Base class version differs."
			return NPCAlly_state
		NPCAlly_state[1]["Little_Demon"]=(self.AGE_Number,)
		return NPCAlly_state
	
	def __setstate__(self,parm):
		Ally_Def.NPCAlly.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Little_Demon"]
			self.AGE_Number=parms[0]
		
		me=Bladex.GetEntity(self.Name)
		# Create a linear interpolator for fading
		FadeList=[me.Name]		
		self.Fader= EntitiesFader (FadeList)
		self.FadeOutTime= 0.23333
		self.FadeInTime= 0.23333
		self.TransitTime= 0.0
		self.DamageFactorNone  = 0.1
		self.DamageFactorLight = 0.2
		self.ImplosionPeriod = 2.5
		self.DeathBallPeriod = 3.5
		me.AddAnmEventFunc("Spit", self.StartSpit)
		me.AddAnmEventFunc("Disappear", self.Disappear)
		me.AddAnmEventFunc("EndZig", self.EndZig)
		me.AddAnmEventFunc("EndZag", self.EndZag)
		

	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosLittleDemon(EntityName)
		
	def ResetCombat (self,EntityName):
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.AttackList = BCopy.deepcopy(Combat.LittleDemonAttackData)
			me.BlockingPropensity= 0.4
	
	
	def FadeOut (self,EntityName):
		self.Fader.FadeOut(self.FadeOutTime)
	
	
	def FadeIn (self,EntityName):
		self.Fader.FadeIn(self.FadeInTime)


	def Disappear (self,EntityName,EventName):
		#print "Disappearing..."
		me = Bladex.GetEntity(EntityName)
		# May wish to make all attacks pass through...
		self.FadeOut(EntityName)
		time= Bladex.GetTime()
		Bladex.AddScheduledFunc(time+self.FadeOutTime+self.TransitTime, self.Reappear, (EntityName,), EntityName+" Reappear")


	def IntersectCircleWithVector (self,V, P, C, r):
		PminusC= P[0]-C[0], P[1]-C[1], P[2]-C[2]
		
		a= V[0]*V[0] + V[1]*V[1] + V[2]*V[2]
		b= V[0]*2.0*PminusC[0] + V[1]*2.0*PminusC[1] + V[2]*2.0*PminusC[2]
		c= (PminusC[0]*PminusC[0] + PminusC[1]*PminusC[1] + PminusC[2]*PminusC[2]) - r*r
		
		sq_term= b*b-4*a*c
		if sq_term < 0.0:
			#print "Vector doesnt intersect circle"
			return P[0]+V[0], P[1]+V[1], P[2]+V[2]
		else:
			sq_term= math.sqrt(sq_term)
			t= (-b-sq_term)/(2.0*a)
			#print "Vector intersects circle at t="+`t`
			return P[0]+V[0]*t, P[1]+V[1]*t, P[2]+V[2]*t
				
				
	def Reappear (self,EntityName):
		#print "Reappearing..."
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.Enemy= Bladex.GetEntity(me.GetEnemyName())
			
			if me.AnimName=="g_jumpl":
				angle= -56.0/180.0 * Actions.PI
				closest_distance= Combat.GetMoveMinDist(Combat.ATTACK, ("G27",), me.AttackList)
			elif me.AnimName=="g_jumpr":
				angle=  56.0/180.0 * Actions.PI
				closest_distance= Combat.GetMoveMinDist(Combat.ATTACK, ("G22",), me.AttackList)
			else:
				angle=  0.0
				closest_distance= 3000.0
				#raise NameError, 'Reappearing in incorrect animation'
				#return
			startpos=me.Position
			enemypos= self.Enemy.Position
			SQoriginal_distance= me.SQDistance2(self.Enemy)
			teletransported= 0
			if SQoriginal_distance > closest_distance*closest_distance:
				relative_vector= -math.sin(angle), 0.0, math.cos(angle)
				DisplacementDistances= [2000.0, 1750.0, 1500.0, 1250.0, 1000.0, 750.0, 500.0, 2500.0, 3000.0, 3500.0, 4000.0]
				
				me.Angle=B3DLib.GetEntity2EntityAngle(me.Name, me.GetEnemyName())
				for distance in DisplacementDistances:
					position= me.Rel2AbsPoint(distance*relative_vector[0], -distance*relative_vector[2],0.0)
					newx= position[0]-enemypos[0]
					newy= position[1]-enemypos[1]
					newz= position[2]-enemypos[2]
					SQnew_distance=  newx*newx + newy*newy + newz*newz
					
					# set position as the intersection of circle
					if SQnew_distance < closest_distance*closest_distance:
						#pdb.set_trace()
						V= position[0]-startpos[0], position[1]-startpos[1],position[2]-startpos[2]
						position= self.IntersectCircleWithVector (V, startpos, enemypos, closest_distance)
					
					YOffset=1500.0
					max_fall= 1000.0
					if me.TestPos (position[0],position[1],position[2], me.ActionAreaMax, max_fall):
						
						if  SQnew_distance <= SQoriginal_distance:
							old_position= me.Position
							me.Position= position[0],position[1],position[2]
							old_angle= me.Angle
							me.Angle= B3DLib.GetEntity2EntityAngle(EntityName, me.GetEnemyName())
							if me.CanISee(self.Enemy)and me.Dist2Floor<max_fall+YOffset:
								teletransported= 1
								#print "teletransported "+`distance`+" metres"
								me.SetOnFloor()
								break
							#print "cant see"
							me.Position= old_position[0], old_position[1], old_position[2]							
							me.Angle= old_angle
							dist2Floor= me.Dist2Floor
						else:
							pass
							#print "further"
					
					elif me.TestPos (position[0],position[1]-YOffset,position[2], me.ActionAreaMax, max_fall+YOffset):
						
						if  SQnew_distance <= SQoriginal_distance:
							old_position= me.Position
							me.Position= position[0],position[1]-YOffset,position[2]
							old_angle= me.Angle
							me.Angle= B3DLib.GetEntity2EntityAngle(EntityName, me.GetEnemyName())
							if me.CanISee(self.Enemy) and me.Dist2Floor<max_fall+YOffset:
								teletransported= 1
								#print "teletransported up and "+`distance`+" metres"
								me.SetOnFloor()
								break
							me.Position= old_position[0], old_position[1], old_position[2]							
							me.Angle= old_angle
							dist2Floor= me.Dist2Floor
			if not teletransported: 
				me.SetOnFloor()
				pass
			# Maybe break enemies facing mode
			if self.Enemy.InCombat and self.Enemy.ActiveEnemy==me.Name and not self.Enemy.CanISee(me):
				self.Enemy.SetActiveEnemy(None)
			self.FadeIn(EntityName)
			Bladex.CheckPyErrors()
			
		
		
	def EndZig (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		self.Enemy= Bladex.GetEntity(me.GetEnemyName())		
		enm_angle= B3DLib.GetEntity2EntityAngle(EntityName, me.GetEnemyName())
		diff_angle= B3DLib.DiffAngle(me.Angle, enm_angle)
		if abs (diff_angle) <= Actions.PI:
			distance= math.sqrt(me.SQDistance2(self.Enemy))
			if distance > Combat.GetMoveMaxDist(Combat.ATTACK, ("G27",), me.AttackList):
				if distance > Combat.GetMoveMaxDist(Combat.ATTACK, ("ZAG",), me.AttackList):
					me.SetActiveEnemy(None)
					me.Angle= enm_angle
				else:
					if diff_angle > 0.0:
						#print "Will Zag next"
						res= me.SetNextAttack("ZAG")
					else:
						#print "Will Zig next"
						res= me.SetNextAttack("ZIG")
			else:
				#print "Cannot Zag, will attack"
				res= me.SetNextAttack("G27")
		else:
			#print "Not facing, Angle: "+`diff_angle`
			#print "Distance: "+`math.sqrt(me.SQDistance2(self.Enemy))`
			pass
		Bladex.CheckPyErrors()
		

	def EndZag (self,EntityName,EventName):
		#print "Ending Zag"		
		# Decide to Zag if not close enough to the player, or to launch an attack
		me = Bladex.GetEntity(EntityName)
		self.Enemy= Bladex.GetEntity(me.GetEnemyName())
		enm_angle= B3DLib.GetEntity2EntityAngle(EntityName, me.GetEnemyName())
		diff_angle= B3DLib.DiffAngle(me.Angle, enm_angle)
		if abs (diff_angle) <= Actions.PI:
			distance= math.sqrt(me.SQDistance2(self.Enemy))
			if distance > Combat.GetMoveMaxDist(Combat.ATTACK, ("G22",), me.AttackList):
				if distance > Combat.GetMoveMaxDist(Combat.ATTACK, ("ZIG",), me.AttackList):
					me.SetActiveEnemy(None)
					me.Angle= enm_angle
				else:
					if  diff_angle> 0.0:
						#print "Will Zag next"
						res= me.SetNextAttack("ZAG")
					else:
						#print "Will Zig next"
						res= me.SetNextAttack("ZIG")
			else:
				#print "Cannot Zig, will attack"
				res= me.SetNextAttack("G22")
		else:
			#print "Not facing, Angle: "+`diff_angle`
			#print "Distance: "+`math.sqrt(me.SQDistance2(self.Enemy))`
			pass
		Bladex.CheckPyErrors()
		
				
	def FirePrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Little_Demon":
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,  1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Fire", +6.0]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Fire", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]

					# Generate a smoke effect
					smoke=Bladex.CreateEntity("FireballSmoke", "Entity Particle System D1", x, y, z)
					smoke.ParticleType="DarkSmoke"
					smoke.YGravity=-3000.0
					smoke.Friction=0.05
					smoke.PPS=8
					smoke.Velocity=0.0, -80.0, 0.0
					smoke.RandomVelocity=5.0
					smoke.DeathTime=Bladex.GetTime()+0.5
					node= 0
					victim.LinkToNode(smoke,node)
					
					# Override hurt anim
					if victim.Life>0:
						if victim.InCombat:
							Damage.DropInvalidObjectsOnImpact (victim.Name)
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
						else:
							Damage.DropInvalidObjectsOnImpact (victim.Name)
							victim.Wuea=Reference.WUEA_ENDED
							victim.InterruptCombat()
							victim.LaunchAnmType("hurt_f_big")
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has been converted to smoke
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()
			
		
	def SpitFunc(self, fireball_name,end_time,period):		
		fireball=Bladex.GetEntity(fireball_name)
		if(fireball):
			prtl=fireball.GetParticleEntity()
			prtl.HitFunc=self.FirePrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.SpitFunc,(fireball_name,end_time,period))
				
	def StartSpit (self,EntityName,EventName):		
		me = Bladex.GetEntity(EntityName)
		if me.InCombat: 
			SQDistance= me.SQDistance2(Bladex.GetEntity(me.GetEnemyName()))
			max_firefan_dist= 4000.0			
			
			# Get an angle to the target
			target= Bladex.GetEntity(me.GetEnemyName())
			target_pos= target.Position
			x,y,z= me.GraspPos("ViewPoint")
			angle= -B3DLib.GetYAngle(target_pos[0]-x,target_pos[1]-y,target_pos[2]-z)
			if  SQDistance < (max_firefan_dist*max_firefan_dist):
				# fan out spit
				duration= 0.3
				self.AGE_Number=self.AGE_Number+1
				end_time=Bladex.GetTime()+duration
				period= duration/10.0
				fireball=Bladex.CreateEntity(EntityName+"_Firefanl_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
				fireball.ParticleType="Flame"
				fireball.Time2Live=20
				fireball.YGravity=-500.0
				fireball.Friction=0.12
				fireball.PPS=512
				fireball.DeathTime=end_time;
				F= 7000.0             # Vector magnitude
				vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F, -math.sin(angle)*F)
				fireball.Velocity=vx,vy,vz
				fireball.RandomVelocity=55.0
				node= me.GetNodeIndex("Head")
				me.LinkToNode(fireball,node)
			else:
				# fireball spit
				nparticles= 70
				duration= 1.0/60.0 # I think this is a minimum
				
				self.AGE_Number=self.AGE_Number+1
				end_time=Bladex.GetTime()+duration
				period= duration/7.0				
				fireball=Bladex.CreateEntity(EntityName+"_Fireball_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
				fireball.ParticleType="LargeFire"
				fireball.Time2Live=31
				fireball.YGravity=-2400.0
				fireball.Friction=0.075
				fireball.PPS=nparticles/duration
				fireball.DeathTime=end_time;
				F= 25000.0             # Vector magnitude
				vx,vy,vz=me.Rel2AbsVector(0.0, -math.cos(angle)*F,-math.sin(angle)*F)
				fireball.Velocity=vx,vy,vz
				fireball.RandomVelocity=25.0
			
			self.SpitFunc(fireball.Name, end_time, period)		


	def RemoveMe (self,EntityName):
		me  = Bladex.GetEntity(EntityName)
		if me:
			me.Alpha=0.0
			me.TimerFunc=""
			me.SubscribeToList("Pin")
		
	def DeathBall (self,EntityName):
		me  = Bladex.GetEntity(EntityName)
		if me:
			alfa=me.Angle+3.14159/2.0
			x=me.Position[0]+500.0*math.cos(alfa)
			y=me.Position[1]+250.0
			z=me.Position[2]+500.0*math.sin(alfa)
			me.RasterMode="Read"
			self.deathball_particle_system=Bladex.CreateEntity("BolaFuego", "Entity Particle System D1", x, y, z)
			self.deathball_particle_system.ParticleType="FuegoInvocacion"
			self.deathball_particle_system.PPS=250
			self.deathball_particle_system.YGravity=0.0
			self.deathball_particle_system.Friction=0.1
			self.deathball_particle_system.Velocity=0.0, 0.0, 0.0
			self.deathball_particle_system.RandomVelocity=50.0
			self.deathball_particle_system.Time2Live=40
			self.deathball_particle_system.DeathTime= Bladex.GetTime()+self.DeathBallPeriod
			self.FadeOutTime=self.DeathBallPeriod*0.8
			#pdb.set_trace()
			self.FadeOut(EntityName)
			# After the fade out, remove me from the world
			Bladex.AddScheduledFunc(Bladex.GetTime()+self.DeathBallPeriod*0.9, self.RemoveMe, (EntityName,))


	def ImplosionDemonio (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		impl=Bladex.CreateEntity("ImplosionDemonio", "Entity Particle System D1", me.Position[0], me.Position[1], me.Position[2])
		impl.ParticleType="Energia3"
		impl.YGravity=0.0
		impl.Friction=0.0
		impl.PPS=300
		impl.Velocity=0.0, 0.0, 0.0
		impl.RandomVelocity=-30.0
		impl.Time2Live=70
		impl.DeathTime=Bladex.GetTime()+(self.ImplosionPeriod*0.5)

	def ImDeadFunc (self,EntityName):
		#Ally_Def.NPCAlly.StdImDead(self,EntityName)
		MasklinMagic.DeathDisappears(EntityName)



	def NewMutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+7, MasklinMagic.DissolveLimb,(obj_name,))

	def InteruptActions(self,EntityName):
		me = Bladex.GetEntity(EntityName)
		me.Wuea=Reference.WUEA_ENDED
		me.InterruptCombat()
		me.Data.Fader.Stop()
		Bladex.RemoveScheduledFunc(me.Name+" Reappear")
		
		
########################################################################################################################################################

class Cos (Ally_Demon):

	HitImpulse = [0.0,0.0,0.0]
	last_hit_in_air= FALSE

	def __init__(self, me):
		# base class init		
		Ally_Demon.__init__(self, me)
		me.ImDeadFunc=self.NewImDeadFunc
		me.MutilateFunc=self.NewMutilateFunc
		me.AddAnmEventFunc("CollisionsOff", self.CollisionsOff)		
		me.InflictHitFunc = self.InflictHitFunc

		# anims
		#me.AnmTranFunc=AuxTran.AuxTranKnightLivingDead

		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = -1.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 20.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0
		self.NoFXOnHit= TRUE

	
	def __getstate__(self):		
		NPCAlly_state=Ally_Demon.__getstate__(self)
		if(NPCAlly_state[0]!=1):
			print "ERROR: Cos.__getstate__(): Base class version differs."			
			return NPCAlly_state
		NPCAlly_state[1]["Cos"]=(self.HitImpulse,self.last_hit_in_air)
		return NPCAlly_state		

	def __setstate__(self,parm):
		Ally_Demon.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Cos"]			
			self.HitImpulse=parms[0]
			self.last_hit_in_air=parms[1]
		me=Bladex.GetEntity(self.Name)
		me.AddAnmEventFunc("CollisionsOff", self.CollisionsOff)
		self.NoFXOnHit= TRUE
		
		
	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosCosita(EntityName)


	def ResetCombat (self,EntityName):
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.BlockingPropensity = 0.0
			me.AttackList = BCopy.deepcopy(Combat.CosAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0


	def InflictHitFunc (self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		me = Bladex.GetEntity(EntityName)
		me.Wuea=Reference.WUEA_ENDED
		me.InterruptCombat()
		me.SetTmpAnmFlags(1,1,1,1,Ally_Def.BM_XYZ,Ally_Def.HEADF_ENG)
		me.LaunchAnmType("jmp_back1")
		# this should encourage the others to attack
		self.CallGroupMemberFunc(EntityName, Combat.TempMoveInProc, 0)
		Actions.Stop_Weapon(EntityName, "Stop_Weapon")		
		
		
	def NewImDeadFunc (self,EntityName):
		#Ally_Def.NPCAlly.StdImDead(self,EntityName)
		MasklinMagic.DeathDisappears(EntityName)
		EntityName+": I am DED"
		
		
	def NewMutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+7, MasklinMagic.DissolveLimb,(obj_name,))
		
		
		

	def HitFunc (self, EntityName, WeaponName, Cx, Cy, Cz, Px, Py, Pz,wcx,wcy,wcz,wdx,wdy,wdz):
		Ally_Def.NPCAlly.HitFunc(self, EntityName, WeaponName, Cx, Cy, Cz, Px, Py, Pz,wcx,wcy,wcz,wdx,wdy,wdz)
		me = Bladex.GetEntity(EntityName)
		self.HitImpulse[0]= Px*0.20;
		self.HitImpulse[1]= Py*0.20;
		self.HitImpulse[2]= Pz*0.20;
		
		
		
				
		self.last_hit_in_air= (not me.OnFloor) or me.AnimName=="g_01" or me.AnimName=="G_01"
		if self.last_hit_in_air:
			me.Angle= B3DLib.GetXZAngle(-self.HitImpulse[0], 0.0, -self.HitImpulse[2])
			me.SetActiveEnemy(None)
			
		# launch appropriate hurt anim
		if me and me.Life > 0:
			me.Wuea=Reference.WUEA_ENDED	
			me.InterruptCombat()	
			if self.last_hit_in_air:	
				me.LaunchAnmType("fly")
			else:
				me.LaunchAnmType("hurt_lite")

	def CollisionsOff (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		#print "Collisions Off in animation "+me.AnimName
		enemy=Bladex.GetEntity(me.GetEnemyName())
		me.ExcludeHitInAnimationFor(enemy)
		

	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		me = Bladex.GetEntity(EntityName)
		
		# launch appropriate hurt anim
		if me and me.Life > 0:
			damage_factor = DamagePoints / (me.Life+DamagePoints)
			if damage_factor > self.DamageFactorNone:
				if DamageZone >= 0 and DamageZone < 32:
					me.SetWoundedZone(DamageZone, 1)
		# Consider getting furious
		if AttackerName and AttackerName != 'BWorld':
			me = Bladex.GetEntity(EntityName)
			if me and me.Life > 0:
				# consider getting furious
				if whrandom.random() < self.ChanceOfFuryOnHurt:
					self.GetFurious (EntityName)


	def Explode (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		me.DelAnmEventFunc(EventName)
		###Reference.debugprint(EntityName+": in Explode")
		#pdb.set_trace()
		# Check valid event type
		if EventName != "Explode":		
			print(EntityName+":-( Explode has unhandled event")
			return
		me_pos = me.Position
		for limb_id in range (1, 6):
			limb= me.SeverLimb(limb_id)
			if limb:
				# explode outward 
				limb_pos = limb.Position
				OutImpulse= B3DLib.Normalize ((limb_pos[0]-me_pos[0], limb_pos[1]-me_pos[1], limb_pos[2]-me_pos[2]))
				B3DLib.Scale (OutImpulse, 5000.0)
				limb.Impulse(OutImpulse[0], OutImpulse[1], OutImpulse[2])

				# we want backward impulse as well...  get this from the weapon
				limb.Impulse(self.HitImpulse[0], self.HitImpulse[1], self.HitImpulse[2])


##########################################################################################################################################################

class Spidersmall (Ally_Demon):

	HitImpulse = [0.0,0.0,0.0]
	last_hit_in_air= FALSE
	AGE_Number=0


	def __init__(self, me):
		# base class init
		Ally_Demon.__init__(self, me)
		self.HitImpulse = [0.0,0.0,0.0]

		me.ImDeadFunc=self.ImDeadFunc
		me.MutilateFunc=self.NewMutilateFunc
		me.AddAnmEventFunc("Spit", self.StartSpit)
		me.InflictHitFunc = self.InflictHitFunc

		# Set up specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = -1.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 20.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0


	
	def __getstate__(self):	
		NPCAlly_state=Ally_Demon.__getstate__(self)
		if(NPCAlly_state[0]!=1):
			print "ERROR: Spidersmall.__getstate__(): Base class version differs."			
			return NPCAlly_state
		NPCAlly_state[1]["Spidersmall"]=(self.AGE_Number,self.last_hit_in_air,self.HitImpulse)
		return NPCAlly_state		

	def __setstate__(self,parm):
		Ally_Demon.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["Spidersmall"]
			self.AGE_Number=parms[0]
			self.last_hit_in_air=parms[1]
			self.HitImpulse=parms[2]
		me=Bladex.GetEntity(self.Name)
		me.AddAnmEventFunc("Spit", self.StartSpit)
		

	def ResetSounds(self, EntityName):
		AniSound.AsignarSonidosAranita(EntityName)


	def ResetCombat (self,EntityName):
		Ally_Def.NPCAlly.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)	
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			me.BlockingPropensity = 0.0
			me.AttackList = BCopy.deepcopy(Combat.SpiderSmallAttackData)
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.0
	
	
	def InflictHitFunc (self, EntityName, VictimName, ImpX, ImpY, ImpZ):
		me = Bladex.GetEntity(EntityName)		
		# this should encourage the others to attack
		me.Data.CallGroupMemberFunc(EntityName, Combat.TempMoveInProc, 0)
		
		
	def ImDeadFunc (self,EntityName):
		#Ally_Def.NPCAlly.StdImDead(self,EntityName)
		MasklinMagic.DeathDisappears(EntityName)
		

	def NewMutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+7, MasklinMagic.DissolveLimb,(obj_name,))
		

	def HitFunc (self, EntityName, WeaponName, Cx, Cy, Cz, Px, Py, Pz,wcx,wcy,wcz,wdx,wdy,wdz):
		Ally_Def.NPCAlly.HitFunc(self, EntityName, WeaponName, Cx, Cy, Cz, Px, Py, Pz,wcx,wcy,wcz,wdx,wdy,wdz)
		me = Bladex.GetEntity(EntityName)
		self.HitImpulse[0]= Px*0.20;
		self.HitImpulse[1]= Py*0.20;
		self.HitImpulse[2]= Pz*0.20;
		print EntityName+": Im hit"
		
		# discourage the others from attacking
		if me and me.Life>0:
			me.Data.CallGroupMemberFunc(EntityName, Combat.TempMoveOutProc, 0)

		self.last_hit_in_air= Py<0
		if self.last_hit_in_air:
			me.Angle= B3DLib.GetXZAngle(-self.HitImpulse[0], 0.0, -self.HitImpulse[2])
			me.SetActiveEnemy(None)
		

	def VenomPrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Spidersmall":
					# Need to check immunity
					#ptcl=Bladex.GetEntity(prtl_name)
					#print (hit_entity+" was hit by "+prtl_name+ " of type "+ptcl.Kind)
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,   1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Venom", +2.0]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Poison", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]

					# Generate a smoke effect
					smoke=Bladex.CreateEntity("FuegoVerde", "Entity Particle System D1", x, y, z)
					smoke.ParticleType="VenomSmoke"
					smoke.YGravity=-100.0
					smoke.Friction=0.05
					smoke.PPS=8
					smoke.Velocity=0.0, -80.0, 0.0
					smoke.RandomVelocity=5.0
					smoke.DeathTime=Bladex.GetTime()+1.0
					node= 0
					victim.LinkToNode(smoke,node)
					
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has been converted to smoke
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()
			
		
	def SpitFunc(self, venom_name,end_time,period):
		venom=Bladex.GetEntity(venom_name)
		if(venom):
			prtl=venom.GetParticleEntity()
			prtl.HitFunc=self.VenomPrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.SpitFunc,(venom_name,end_time,period))	
				
	def StartSpit (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		self.AGE_Number=self.AGE_Number+1
		end_time=Bladex.GetTime()+0.5
		period= 0.125
		node= 0		
		x,y,z= me.GraspPos("ViewPoint")
		venom=Bladex.CreateEntity(EntityName+"_Venom_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
		venom.ParticleType="Venom"
		venom.YGravity=9800.0
		venom.Friction=0.075
		venom.PPS=512
		venom.DeathTime=end_time+1.0/60.0;
		vx,vy,vz=me.Rel2AbsVector(0,-14000.0,6500.0)
		venom.Velocity=vx,vy,vz
		venom.RandomVelocity=5.0
		me.LinkToNode(venom,node)
		self.SpitFunc(venom.Name, end_time, period)
	
	def RespondToHit(self, EntityName, AttackerName, DamagePoints, DamageType, DamageZone, Shielded):
		me = Bladex.GetEntity(EntityName)
				
		if me and me.Life > 0:
			damage_factor = DamagePoints / (me.Life+DamagePoints)
			if damage_factor > self.DamageFactorNone:
				if DamageZone >= 0 and DamageZone < 32:
					me.SetWoundedZone(DamageZone, 1)

		# Consider getting furious
		if AttackerName and AttackerName != 'BWorld':
			me = Bladex.GetEntity(EntityName)
			if me and me.Life > 0:
				# consider getting furious
				if whrandom.random() < self.ChanceOfFuryOnHurt:
					self.GetFurious (EntityName)
		
		# launch appropriate hurt anim
		if me and me.Life > 0:
			me.Wuea=Reference.WUEA_ENDED	
			me.InterruptCombat()	
			damage_factor = DamagePoints / (me.Life+DamagePoints)
			if damage_factor > self.DamageFactorNone:
				if damage_factor < self.DamageFactorHeavy:	
					me.LaunchAnmType("hurt_lite")
				else:
					me.LaunchAnmType("hurt_big")
		
		
########################################################################################################################################################

classes_defined= dir()
def DemonDefaultFuncs (pers):		
	if pers.CharType in classes_defined:	
		exec_string = 'pers.Data=' + pers.CharType + '(pers)'
		exec (exec_string)		
		Bladex.CheckPyErrors()
		if not pers.Data:
			raise NameError, 'CharType must not have valid associated class'
		Bladex.CheckPyErrors()	
	else:
		print "WARNING: "+pers.CharType+" is an unrecognised class in AllyTypes.py!"
		pers.Data= Ally_Def.NPCAlly (pers)		