import Bladex
import Enm_Def
import Reference
import AuxTran
import AniSound
import pdb
import BCopy
import math
import whrandom
import Actions
import Interpolator
import CharStats
import ItemTypes
import AuxFuncs
import Sparks
import Objects
import InitDataField
import Blood
import dust
import B3DLib
import Damage
import darfuncs
import GenFX
import ObjStore
import GameText
import ScorerActions
import Basic_Funcs
import Enm_Def
import Ally_Def
import Combat
import EnemyTypes
import Auras
import Sounds
import GameStateAux
import dust
import pocimac
import MenuText
import AniSoundSkelette
import AniSoundSklDRTP

TRUE = 1==1
FALSE = not TRUE



class SkeletonDRTP(Enm_Def.NPCPerson):

	
	def __init__(self, me):
				
		Enm_Def.NPCPerson.__init__(self, me)

		# Set up skeleton specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   =  1.0
		self.SoundPriorities[Reference.SND_HIT]     =  1.0
		self.SoundPriorities[Reference.SND_NPC]     = -1.0
		self.SoundPriorities[Reference.SND_NOISYPC] =  3.0
		self.SoundPriorities[Reference.SND_PC]      =  2.0
		
		me.ImDeadFunc=self.ImDeadFunc
		

	def ResetSounds(self, EntityName):
		
		me=Bladex.GetEntity(EntityName)
		if me.Kind=="SkeletonDRTP":
			AniSoundSklDRTP.AsignarSonidosSkeletonDRTP(EntityName)
			Bladex.ReadBitMap("../../Maps/WizardsDomain/NUFiles/NUSkeletonDRTPStuff/SklDRTPIcon.bmp","SkltpIcon")
			Reference.EnemiesScorerData[self.Name]=("SkltpIcon","Stp")
		else:
			AniSoundSkelette.AsignarSonidosSkelette(EntityName)
			Bladex.ReadBitMap("../../Maps/WizardsDomain/NUFiles/NUSkeletonDRTPStuff/SCLIcon.bmp","SclIcon")
			Reference.EnemiesScorerData[self.Name]=("SclIcon","Scl")


	# Functions for loading and saving state
	def __getstate__(self):
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)		
		if(NPCPerson_state[0]!=1):
			return NPCPerson_state
		NPCPerson_state[1]["SkeletonDRTP"]=()
		return NPCPerson_state
		

	def __setstate__(self,parm):
		# Toma como parmetro lo que devuelve __getstate__() y debe recrear la clase
		Enm_Def.NPCPerson.__setstate__(self,parm)
		version=parm[0]
		if version==1:
			parms=parm[1]["SkeletonDRTP"]
			
			

	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			me.BlockingPropensity = 0.0
			me.AttackList = BCopy.deepcopy(SkeletonDRTPAttackData)
			
			
		
	def ImDeadFunc (self,EntityName):
		me = Bladex.GetEntity(EntityName)
		rwp=Bladex.GetEntity(me.InvRight)
		if rwp and rwp.Kind=='ProSklScythe1':
			if not rwp.TestHit:
				Actions.RemoveFromInventory (me, rwp,"DropRightEvent")
				rwp.Impulse(0.0, 0.0, 0.0) 
				Bladex.AddScheduledFunc(Bladex.GetTime()+12, dust.EnPolvoObjeto,(rwp.Name,100,0,))
				
		print EntityName," ->dusted"
		Bladex.AddScheduledFunc(Bladex.GetTime()+10, dust.EnPolvoPerson,(EntityName,100,0,))
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		
		
	
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+10, dust.EnPolvoObjeto,(obj_name,100,0,))
		
		
		

SkeletonDRTPAttackData = [
           # inner zone blocks:
            [Combat.BLOCK,  0.30, (),                   500.0, 1000.0, 3000.0, 0.35],
            [Combat.BLOCK,  0.08, "tr",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.08, "tl",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.08, "tb",                 750.0, 1500.0, 3500.0, 0.50],
            [Combat.BLOCK,  0.20, "tf",                 750.0, 1500.0, 3500.0, 0.50],

           # outer zone blocks:
            [Combat.BLOCK,  0.05, "tr",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tl",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.10, "tb",                3500.0, 7000.0, 9000.0, 0.50],
            [Combat.BLOCK,  0.05, "tf",                3500.0, 7000.0, 9000.0, 0.50],
            
           # attacks:
            [Combat.ATTACKDOWN, 1.00, ("STAIRS",),         1200.0, 1600.0, 2500.0, 0.35],
            
            [Combat.ATTACK, 0.00, ("GA","GA","GA","GM1",), 1200.0, 1400.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.50, ("GA",),             1200.0, 1400.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.40, ("GM2",),               0.0, 1600.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.40, ("GA", "GA"),        1200.0, 1600.0, 2500.0, 0.35],
            [Combat.ATTACK, 0.20, ("GA", "GA", "GM1"),    0.0, 1600.0, 3000.0, 0.35],
            [Combat.ATTACK, 0.25, ("GM2",),            1200.0, 1800.0, 2500.0, 0.35],
            #[Combat.ATTACK, 0.25, ("G22",),            2014.0, 3000.0, 5327.0, 0.35],
            [Combat.ATTACK, 1.00, "RespectDistance",      0.0,  500.0, 1200.0, 0.30,1],
            
           
            
            
           # inner zone moves:
            [Combat.MOVE,   0.05, "tr",                   0.0, 2000.0, 5000.0, 0.50],
            [Combat.MOVE,   0.05, "tl",                   0.0, 2000.0, 5000.0, 0.50],
            [Combat.MOVE,   0.10, "tb",                   0.0, 2000.0, 5000.0, 0.50],
            [Combat.MOVE,   0.25, "tf",                   0.0, 2000.0, 5000.0, 0.50],

           # outer zone moves:
            [Combat.MOVE,   0.01, "tr",                5000.0, 7000.0, 9000.0, 0.50],
            [Combat.MOVE,   0.01, "tl",                5000.0, 7000.0, 9000.0, 0.50],
            [Combat.MOVE,   0.05, "tb",                5000.0, 7000.0, 9000.0, 0.50],
            [Combat.MOVE,   0.02, "tf",                5000.0, 7000.0, 9000.0, 0.50],
            [Combat.MOVE,   0.06, Combat.TempMoveInProc,      3000.0, 7000.0, 9000.0, 0.35],
            
]