import Bladex
import Enm_Def
import Reference
import Combat
import AuxTran
import AniSound
import pdb
import BCopy
import math
import whrandom
import Actions
import Interpolator
import CharStats
import ItemTypes
import AuxFuncs
import Sparks
import Objects
import InitDataField
import Blood
import dust
import B3DLib
import Damage
import darfuncs
import GenFX
import OnOff
import DMusic
import ObjStore
import AniSoundZmb


#
# Boolean value
#
TRUE = 1==1
FALSE = not TRUE







class Zomby (Enm_Def.NPCPerson):

	AGE_Number=0
	RightWeapon=None
	LeftWeapon=None
	def __init__(self, me):

		# base class init
		Enm_Def.NPCPerson.__init__(self, me)

		# Set up traitor knight specific sound priorities
		self.SoundPriorities[Reference.SND_ARROW]   = 10.0
		self.SoundPriorities[Reference.SND_HIT]     = 50.0
		self.SoundPriorities[Reference.SND_NPC]     = 25.0
		self.SoundPriorities[Reference.SND_NOISYPC] = 30.0
		self.SoundPriorities[Reference.SND_PC]      = 80.0

		

		self.DamageFactorLight = 0.25
		self.DamageFactorHeavy = 0.25
		
		self.RightWeapon=None
		self.LeftWeapon=None
		
		
		# Set up sounds made
		me.ImDeadFunc=self.ImDeadFunc
		me.AddAnmEventFunc("Spit", self.StartSpit)
		self.NoFXOnHit= TRUE

	# Functions for loading and saving state
	def __getstate__(self):		
		NPCPerson_state=Enm_Def.NPCPerson.__getstate__(self)
		if(NPCPerson_state[0]!=1):
			
			return NPCPerson_state
		NPCPerson_state[1]["Zomby"]=(self.AGE_Number,self.RightWeapon, self.LeftWeapon)
		return NPCPerson_state		

	def __setstate__(self,parm):
		Enm_Def.NPCPerson.__setstate__(self,parm)
		
		me=Bladex.GetEntity(self.Name)
		self.NoFXOnHit= TRUE
		
		version=parm[0]
		if version==1:
			parms=parm[1]["Zomby"]
			self.AGE_Number= parms[0]
			self.RightWeapon= parms[1]
			self.LeftWeapon= parms[2]
		me.AddAnmEventFunc("Spit", self.StartSpit)
		
		
		
	def ResetSounds(self, EntityName):
		me = Bladex.GetEntity(EntityName)
		AniSoundZmb.AsignarSonidosZomby(me.Name)
		Bladex.ReadBitMap("../../Maps/WizardsDomain/NUFiles/NUZombyStuff/ZombyIcon.bmp","ZombyIcon")
		Reference.EnemiesScorerData[self.Name]=("ZombyIcon","Zmb")


	def ResetCombat (self,EntityName):
		Enm_Def.NPCPerson.ResetCombat(self, EntityName)
		me = Bladex.GetEntity(EntityName)
		if me and me.Life>0:
			self.AttacksOwnKind=FALSE
			self.AttackNPCTime = 10.0
			me.BlockingPropensity = 0.0	
			self.ChanceOfFuryOnHurt = 0.0
			self.ChanceOfFuryOnLeaderDeath = 0.00
			me.AttackList = BCopy.deepcopy(ZombyAttackData)
			self.RightWeapon=me.InvRight
			self.LeftWeapon=me.InvLeft
			
			
			
	def RemoveWeapon2(self, weapon):
		wp=Bladex.GetEntity(weapon)
		wp.Position=0,50000,0
		print "Zomby weapon removed"

			
	def RemoveWeapon(self, weapon):
		wp=Bladex.GetEntity(weapon)
		if wp and not wp.Parent:
			Reference.EntitiesSelectionData[weapon]=(0.0,0.0,"")
			AuxFuncs.FadeObject(weapon, 1.0,0.0,3.0)
			Bladex.AddScheduledFunc(Bladex.GetTime()+3.0, self.RemoveWeapon2,(wp.Name,))
			
			
			
		
	def ImDeadFunc (self,EntityName):
		Enm_Def.NPCPerson.StdImDead(self,EntityName)
		me = Bladex.GetEntity(EntityName)
		Bladex.AddScheduledFunc(Bladex.GetTime()+10, dust.EnPolvoPerson,(EntityName,100,0,))
		if self.RightWeapon:
			rwp=Bladex.GetEntity(self.RightWeapon)
			Bladex.AddScheduledFunc(Bladex.GetTime()+12, self.RemoveWeapon,(rwp.Name,))
		if self.LeftWeapon:
			lwp=Bladex.GetEntity(self.LeftWeapon)
			Bladex.AddScheduledFunc(Bladex.GetTime()+12.5, dust.RemoveWeapon,(lwp.Name,))
		
		
		
		
		
	def MutilateFunc(self,EntityName,obj_name,x,y,z,nx,ny,nz,node):
		#Blood.Mutilate (EntityName,obj_name,x,y,z,nx,ny,nz,node)
		limb= Bladex.GetEntity(obj_name)
		InitDataField.Initialise(limb)
		Bladex.AddScheduledFunc(Bladex.GetTime()+10, dust.EnPolvoObjeto,(obj_name,100,0,))



	def VomitPrtlHit(self,prtl_name,hit_entity,x,y,z,vx,vy,vz,wcx,wcy,wcz,wdx,wdy,wdz):
		if hit_entity != "BWorld":
			victim=Bladex.GetEntity(hit_entity)
			if victim: 
				if victim.Person and not victim.Kind=="Zomby":
					# Need to check immunity
					#ptcl=Bladex.GetEntity(prtl_name)
					#print (hit_entity+" was hit by "+prtl_name+ " of type "+ptcl.Kind)
					Reference.EntitiesObjectData[prtl_name]= [Reference.OBJ_WEAPON, 0, 0,  1.0,  Reference.THR_STRAIGHT, Reference.W_FLAG_1H, ["Venom", +2.0]]
					victim.DamageFunc(hit_entity, self.Name, prtl_name, "Vomit", 1, -1, x, y, z, 0)
					if Reference.EntitiesObjectData.has_key(prtl_name):
						del Reference.EntitiesObjectData[prtl_name]
				elif victim.Weapon:
					pass
		# This particle should be removed, as it has collided
		ptcl=Bladex.GetEntity(prtl_name)
		ptcl.RemoveFromWorld()


	def SpitFunc(self, vomit_name,end_time,period):
		vomit=Bladex.GetEntity(vomit_name)
		if(vomit):
			prtl=vomit.GetParticleEntity()
			prtl.HitFunc=self.VomitPrtlHit
			prtl.ObjCTest= 1
			if(Bladex.GetTime()<end_time):
				Bladex.AddScheduledFunc(Bladex.GetTime()+period,self.SpitFunc,(vomit_name,end_time,period))	
				
				
				
	def StartSpit (self,EntityName,EventName):
		me = Bladex.GetEntity(EntityName)
		self.AGE_Number=self.AGE_Number+1
		end_time=Bladex.GetTime()+0.5
		period= 0.125
		node= me.GetNodeIndex("Head")
		x,y,z= me.GraspPos("ViewPoint")
		vomit=Bladex.CreateEntity(EntityName+"_Vomit_"+`self.AGE_Number`,"Entity Particle System D1",x,y,z)
		vomit.ParticleType="Vomit"
		vomit.YGravity=9800.0
		vomit.Friction=0.075
		vomit.PPS=512
		vomit.DeathTime=end_time+1.0/60.0;
		vx,vy,vz=me.Rel2AbsVector(0,-9000.0,6500.0)
		vomit.Velocity=vx,vy,vz
		vomit.RandomVelocity=5.0
		me.LinkToNode(vomit,node)
		
		self.SpitFunc(vomit.Name, end_time, period)

	
	
ZombyAttackData =[  
	     [Combat.ATTACKDOWN, 1.00, ("G18",),        2610.0, 3109.0, 3608.0, 0.35],
	     [Combat.ATTACK, 0.35, ("G12",),            2610.0, 3109.0, 3608.0, 0.35],
	     [Combat.ATTACK, 0.20, ("G13",),            1526.0, 1831.0, 2136.0, 0.35],
	     [Combat.ATTACK, 0.35, ("G16",),             750.0, 1610.0, 1965.0, 0.35],
	     [Combat.ATTACK, 0.20, ("G18",),            2418.0, 2763.0, 3108.0, 0.35],
	     [Combat.ATTACKDOWN, 1.00, ("C3",),         1000.0, 2195.0, 2356.0, 0.35],
	     [Combat.ATTACK, 0.10, ("C1",),             1000.0, 2195.0, 2261.0, 0.35],
	     [Combat.ATTACK, 0.05, ("C3",),             1000.0, 2195.0, 2356.0, 0.35],
	     [Combat.ATTACK, 0.10, ("C2",),             1596.0, 2105.0, 2220.0, 0.35],
	     [Combat.ATTACK, 0.05, ("C3",),             1000.0, 2195.0, 2356.0, 0.35],
	     [Combat.ATTACK, 0.05, ("SP1",),             750.0, 3000.0, 4000.0, 3.00]
]