import Bladex
import GameState
import MemPersistence
import BBLib
import string
import Reference
import ObjStore








class MainCharState(GameState.EntityPersonState):
	"Clase para grabar el estado del jugador"

	def __init__(self,ent_name="Player1",cam_name="Camera"):
		import CharStats
		entity=Bladex.GetEntity(ent_name)
		cam= Bladex.GetEntity(cam_name)

		if not entity or not cam:
			return

		import Actions

		self.Props={}
		self.Props["Life"]=CharStats.GetCharMaxLife(entity.Kind,entity.Level)
		self.Props["Level"]=entity.Level
		self.Props["PartialLevel"]=entity.PartialLevel
		self.Props["Energy"]=entity.Energy
		self.Props["Magiclevel"]=entity.Data.MagicLevel
		self.Props["Armor"]=(entity.MeshName,entity.Data.armour_level,entity.Data.armour_prot_factor)
		self.Props["Saves"]=Reference.TimesSaved
		self.Props["Combos"]=Bladex.GetCombos("Player1")
		self.Props["PViewType"]=cam.PViewType
		self.Props["ObjectsTaken"]=entity.Data.ObjectsTaken
		self.Props["Spellbook"]=entity.Data.SpellBook
		self.Props["Swordpowers"]=entity.Data.SwordPowers
		self.Props["Swordpowers"]=entity.Data.SwordPowers
		self.Props["Staffname"]=entity.Data.StaffName
		self.Props["Swordname"]=entity.Data.SwordName
		self.Props["Skin"]=entity.Data.OrigMeshName
		
		
		
		
		
		GameState.EntityPersonState.__init__(self,entity)
		inv=entity.GetInventory()
		self.Inventory={}
		self.Inventory["Objects"]=[]
		for i in range(inv.nKindObjects):
			for name in Actions.GetListOfObjectsAt(inv,i):
				self.Inventory["Objects"].append(self.__GetObjAux(name))

		self.Inventory["maxWeapons"]=inv.maxWeapons
		self.Inventory["Weapons"]=[]
		for i in range(inv.nWeapons):
			self.Inventory["Weapons"].append(self.__GetObjAux(inv.GetWeapon(i)))

		self.Inventory["Shields"]=[]
		for i in range(inv.nShields):
			self.Inventory["Shields"].append(self.__GetObjAux(inv.GetShield(i)))

		self.Inventory["Quivers"]=[]
		for i in range(inv.nQuivers):
			try: narrows= Bladex.GetEntity(inv.GetQuiver(i)).Data.NumberOfArrows()
			except: narrows=0
			self.Inventory["Quivers"].append((self.__GetObjAux(inv.GetQuiver(i)),narrows))

		self.Inventory["Keys"]=[]
		for i in range(inv.nKeys):
			self.Inventory["Keys"].append(self.__GetObjAux(inv.GetKey(i)))

		self.Inventory["SpecialKeys"]=[]
		for i in range(inv.nSpecialKeys):
			self.Inventory["SpecialKeys"].append(self.__GetObjAux(inv.GetSpecialKey(i)))

		self.Inventory["Tablets"]=[]
		for i in range(inv.nTablets):
			self.Inventory["Tablets"].append(self.__GetObjAux(inv.GetTablet(i)))

		self.Inventory["InvLeft"]=self.__GetObjAux(entity.InvLeft)
		self.Inventory["InvLeft2"]=self.__GetObjAux(entity.InvLeft2)
		#Avoid to carry standard objects to another map( chairs and similars)
		if Actions.IsRightHandWeaponObject(entity.Name)==0:
			if entity.InvRight:
				print "Not taking right hand object to next map cause its not a weapon!"
			self.Inventory["InvRight"]=None
		else:
			self.Inventory["InvRight"]=self.__GetObjAux(entity.InvRight)
		self.Inventory["InvLeftBack"]=self.__GetObjAux(entity.InvLeftBack)
		self.Inventory["InvRightBack"]=self.__GetObjAux(entity.InvRightBack)


	def __GetBOD(self,ent_kind):
		RM=BBLib.GetResourceManager()
		for i in range(RM.NResources(BBLib.B_CID_OBJDSCR)):
			if RM.IsResourceLoaded(BBLib.B_CID_OBJDSCR,i):
				if RM.GetResourceName(BBLib.B_CID_OBJDSCR,i)==ent_kind:
					return RM.GetResourceFile(BBLib.B_CID_OBJDSCR,i)
		return None

	def __GetObjAux(self,obj):
		if not obj:
			return None
		objKind=Bladex.GetEntity(obj).Kind
		return (obj,objKind,self.__GetBOD(objKind))





	def GetProps(self):
		temp={}
		temp["Life"]=self.Props["Life"]
		temp["Level"]=self.Props["Level"]
		temp["PartialLevel"]=self.Props["PartialLevel"]
		temp["Energy"]=self.Props["Energy"]
		temp["Magiclevel"]=self.Props["Magiclevel"]
		temp["Armor"]=self.Props["Armor"]
		temp["Combos"]=self.Props["Combos"]
		temp["Saves"]=self.Props["Saves"]
		temp["PViewType"]=self.Props["PViewType"]
		temp["ObjectsTaken"]=self.Props["ObjectsTaken"]
		temp["Spellbook"]=self.Props["Spellbook"]
		temp["Swordpowers"]=self.Props["Swordpowers"]
		temp["Spellbook"]=self.Props["Spellbook"]
		temp["Swordpowers"]=self.Props["Swordpowers"]
		temp["Staffname"]=self.Props["Staffname"]
		temp["Swordname"]=self.Props["Swordname"]
		temp["Skin"]=self.Props["Skin"]
		return (self.CreationProps,temp,self.Inventory)


#######################################################################################################################################################


def CreateEntAux(obj_tuple,obj_kind,props=1):
	import ItemTypes
	import MasklinMagic
	obj=Bladex.GetEntity(obj_tuple[0])
	if not obj:
		BBLib.ReadBOD(obj_tuple[2])
		
		obj=Bladex.CreateEntity(obj_tuple[0],obj_tuple[1],0,0,0,obj_kind)
		if props:
			if Reference.DefaultObjectData.has_key(obj.Kind):
				if obj_tuple[1]=="ProStaff1":
					obj.Data=MasklinMagic.WizardStaff(obj)
				elif obj_tuple[1]=="WizardSword":
					obj.Data=MasklinMagic.WizardSword(obj)
				elif obj_tuple[1]=="ProWizShield1":
					obj.Data=MasklinMagic.WizardShield(obj)
				elif obj_tuple[1]=="WizBow1":
					obj.Data=MasklinMagic.WizardBow(obj)
				elif obj_tuple[1]=="CarcajWizarddrug":
					obj.Data=MasklinMagic.CarcajWizarddrug(obj)
				elif obj_tuple[1]=="ProAmulet1":
					obj.Data=MasklinMagic.AmuletoInvisibility(obj)
				elif obj_tuple[1]=="ProHealPot1":
					obj.Data=MasklinMagic.HealingPotion(obj)
				elif obj_tuple[1]=="ProMagicPot2":
					MasklinMagic.CreateMagicPotion(obj.Name)
				elif obj_tuple[1]=="ProHealPot1":
					obj.Data=MasklinMagic.HealingPotion(obj)
				else:
					ItemTypes.ItemDefaultFuncs(obj)
	return obj


def CreateMainCharWithProps(props):
	print "Creating main char with props...."
	CreationProps=props[0]
	Props=props[1]
	Inventory=props[2]

	import MasklinData ########## Init non-RAS char
	import Reference
	import Sparks
	import Breakings
	import Actions

	char=Bladex.CreateEntity("Player1","Wizard_A",0,0,0,"Person")
	cam=Bladex.GetEntity("Camera")
	import MasklinTypes
	char.Data=MasklinTypes.Wizard(char)#####
	inv=char.GetInventory()
	inv.maxObjects = 30
	inv.maxQuivers = 5 
	#AniSound.AsignarSonidosCaballero('Player1')

	char.Level=Props["Level"]
	char.PartialLevel=Props["PartialLevel"]
	char.Life=Props["Life"]
	char.Data.ObjectsTaken=Props["ObjectsTaken"]
	char.Data.SpellBook=Props["Spellbook"]
	char.Data.Swordpowers=Props["Swordpowers"]
	char.Data.StaffName=Props["Staffname"]
	char.Data.SwordName=Props["Swordname"]
	char.Energy=Props["Energy"]
	char.Data.MagicLevel=Props["Magiclevel"]
	char.SetMesh(Props["Armor"][0])
	#char.MeshName=Props["Skin"]
	char.Data.OrigMeshName=(Props["Armor"][0])
	char.Data.armour_level       = Props["Armor"][1]
	char.Data.armour_prot_factor = Props["Armor"][2]
	Reference.TimesSaved         = Props["Saves"]
	Bladex.SetCombos("Player1",Props["Combos"])
	if cam: cam.PViewType=Props["PViewType"]
	else: print "Camera not available for setting PViewType"

	char.SendTriggerSectorMsgs=1

	for i in Inventory["Objects"]:
		CreateEntAux(i,"Physic")
		Actions.ExtendedTakeObject(inv,i[0])

	inv.maxWeapons=Inventory["maxWeapons"]
	for i in Inventory["Weapons"]:
		obj=CreateEntAux(i,"Weapon")
		object_flag=Reference.GiveObjectFlag(i[0])
		if object_flag == Reference.OBJ_BOW:
			inv.AddBow(i[0])
		else:
			flag=Reference.GiveWeaponFlag(i[0])
			inv.AddWeapon(i[0],flag)


	for i in Inventory["Shields"]:
		CreateEntAux(i,"Weapon")
		inv.AddShield(i[0])

	for i in Inventory["Quivers"]:
		obj=CreateEntAux(i[0],"Physic")
		try: obj.Data.SetNumberOfArrows(i[1])
		except: pass
		inv.AddQuiver(i[0][0])

	for i in Inventory["Keys"]:
		CreateEntAux(i,"Physic",0)
		inv.AddKey(i[0])

	for i in Inventory["SpecialKeys"]:
		CreateEntAux(i,"Physic",0)
		inv.AddSpecialKey(i[0])

	for i in Inventory["Tablets"]:
		CreateEntAux(i,"Physic",0)
		inv.AddTablet(i[0])

	if Inventory["InvLeft"]:
		CreateEntAux(Inventory["InvLeft"],"Physic")
		inv.LinkLeftHand(Inventory["InvLeft"][0])

	if Inventory["InvLeft2"]:
		CreateEntAux(Inventory["InvLeft2"],"Physic")
		inv.LinkLeftHand2(Inventory["InvLeft2"][0])

	if Inventory["InvRight"]:
		CreateEntAux(Inventory["InvRight"],"Physic")
		inv.LinkRightHand(Inventory["InvRight"][0])

	if Inventory["InvRightBack"]:
		CreateEntAux(Inventory["InvRightBack"],"Physic")
		inv.LinkRightBack(Inventory["InvRightBack"][0])

	if Inventory["InvLeftBack"]:
		CreateEntAux(Inventory["InvLeftBack"],"Physic")
		inv.LinkLeftBack(Inventory["InvLeftBack"][0])



def RestoreMainCharState(key):
  	props=MemPersistence.Get(key)
  	if props:
		CreateMainCharWithProps(props)
    		return 1
  	return 0



########################################################################################################

# Formerly picked weapons
PWeapons= []

# Formerly picked Items
PItems	= []

# Weapon is a string with the internal name of the weapon

def PickedWeapon(Weapon):
	PWeapons.append(Weapon)

# Item is a string with the internal name of the item

def PickedItems(Item):
	PItems.append(Item)


def Set2DMapValuesAux():
	return [PWeapons,PItems]


def Get2DMapValuesAux(vals):
	if vals:
		global PWeapons
		global PItems
		PWeapons=vals[0]
		PItems=vals[1]
		return 1
	return 0




def Get2DMapValues():
	print "GetWiz2DMapValues()"
	vals=MemPersistence.Get('2DMapValues')
	if vals:
		return Get2DMapValuesAux(vals)
	else:
		print "Get2DMapValues() -> can't find vals."
	return 0


####
def BeginLevel():
	pj=RestoreMainCharState('MainChar')
	if pj:
		return Get2DMapValues()
	return 0



# Saving stuff.......


def SaveMainCharState(key):
  	ent_state=MainCharState('Player1')
 	props=ent_state.GetProps()
  	MemPersistence.Store(key,props)
  	
  	
  	

def StoreCharInfo():
	
	try:
		MemPersistence.Store('2DMapValues',Set2DMapValuesAux())
	except Exception,exc:
		print "Exception in WizStoreCharInfo",exc

	SaveMainCharState('MainChar')



# StartNextMap from this func

def EndOfLevel(NextMapName):

	# Do some python garbage collection
	ObjStore.CheckStore()

	import Language
	import SplashImage
	scr_name="../../Data/Menu/Save/"+Language.Current+"/Cerrando.jpg"
	SplashImage.ShowImage(scr_name,0)

	print "EndOfWizardLevel()"

	print "Preparing main char for the travel."
	import Actions

	print 'Actions.PutAllInBack("Player1")'
	Actions.PutAllInBack("Player1")

	print 'Actions.RemoveAllKeys("Player1")'
	Actions.RemoveAllKeys("Player1")

	print 'RemoveNoTravelObjects( "Player1" )'
	RemoveNoTravelObjects( "Player1" )
	StoreCharInfo()
	Bladex.LoadLevel(NextMapName)


def RemoveNoTravelObjects(EntityName):
	me        = Bladex.GetEntity(EntityName)
	inv       = me.GetInventory()
	objname   = inv.GetObject(0)
	counterid = 0

	while objname:
		obj     = Bladex.GetEntity(objname)
		WizTravelObjects=["ProMagicPot2","ProHealPot1"]
		if obj.Kind in Reference.TravelObjects or obj.Kind in WizTravelObjects:
			counterid = counterid + 1
		else:
			inv.RemoveObject(objname)
		objname = inv.GetObject(counterid)
		
		
		
		

### Is This actually used?

def CreatePJ_PY():
	print "YES IT IS"
	global PWeapons
	global PItems
	

	SaveMainCharState('MainChar')

	cfgfile = open("pj.py",'w')
	cfgfile.write("import GotoMapVars\n")
	cfgfile.write("GotoMapVars.VisitedMaps             = "+`VisitedMaps`+'\n')
	cfgfile.write("GotoMapVars.PlacedTablets           = "+`PlacedTablets`+'\n')
	cfgfile.write("GotoMapVars.MText                   = "+`MText`+'\n')
	cfgfile.write("GotoMapVars.PWeapons                = "+`PWeapons`+'\n')
	cfgfile.write("GotoMapVars.PItems                  = "+`PItems`+'\n')
	cfgfile.write("GotoMapVars.BaList                  = "+`BaList`+'\n')

	cfgfile.write("charprops = "+`MemPersistence.Get('MainChar')`+'\n')
	cfgfile.write("GotoMapVars.CreateMainCharWithProps(charprops)"+'\n')


	cfgfile.close()