import Bladex
import Reference
import Doors
import Levers
import Locks
import Sounds
import Objects
import Button

loopelevador=Sounds.CreateEntitySound("..\\..\\Sounds\\drawbridge-loop.wav", "LoopElevador")
golpeelevador=Sounds.CreateEntitySound("..\\..\\Sounds\\metal-lever3.wav", "GolpeElevador")

sdoor1d=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-madera-deslizando.wav","StoneDesliz")
sdoor1d.MaxDistance=20000
sdoor1d.MinDistance=1000
sdoor1d.Volume=1

sdoor1g=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-madera-golpe.wav","StoneGolpe")
sdoor1g.MaxDistance=20000
sdoor1g.MinDistance=2000
sdoor1g.Volume=1


sdoor2d=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-piedra-deslizando-2.wav","StoneDesliz2")
sdoor2d.MaxDistance=20000
sdoor2d.MinDistance=1000
sdoor2d.Volume=1

sdoor2g=Sounds.CreateEntitySound("..\\..\\Sounds\\puerta-piedra-golpe2.wav","StoneGolpe2")
sdoor2g.MaxDistance=20000
sdoor2g.MinDistance=2000
sdoor2g.Volume=1

sdoor3d=Sounds.CreateEntitySound("..\\..\\Sounds\\drawbridge-loop.wav","BridgeDesliz")
sdoor3d.MaxDistance=20000
sdoor3d.MinDistance=1000
sdoor3d.Volume=1

sdoor3g=Sounds.CreateEntitySound("..\\..\\Sounds\\dist-dungeon-door2.wav","BridgeGolpe")
sdoor3g.MaxDistance=20000
sdoor3g.MinDistance=2000
sdoor3g.Volume=1



deslizrasanexo=Sounds.CreateEntitySound("..\\..\\Sounds\\rastrillo.wav", "DeslizRasanexo")
deslizrasanexo.Volume=0.8
deslizrasanexo.MinDistance=5000
deslizrasanexo.MaxDistance=20000

golperasanexo=Sounds.CreateEntitySound("..\\..\\Sounds\\golpe-metal-mediano.wav", "GolpeRasanexo")
golperasanexo.Volume=0.8
golperasanexo.MinDistance=5000
golperasanexo.MaxDistance=20000

golpebloque=Sounds.CreateEntitySound("..\\..\\Sounds\\trap-trigger1.wav", "GolpeBloque")
golpebloque.Volume=0.8
golpebloque.MinDistance=5000
golpebloque.MaxDistance=20000


#################################################################################################################################################
# big Door To Tomb


tombdoor=Doors.CreateDoor("TombDoor", (78000,16000,68000), (0,1,0), 1000, 6000, Doors.CLOSED)
tombdoor.opentype=Doors.UNIF
tombdoor.o_med_vel=-300 #-400
tombdoor.o_med_displ=5000
tombdoor.closetype=Doors.AC
tombdoor.c_init_displ=5000
tombdoor.c_med_vel=2200


tombdoor.SetWhileOpenSound(sdoor2d)
tombdoor.SetEndOpenSound(sdoor2g)
tombdoor.SetWhileCloseSound(sdoor2d)
tombdoor.SetEndCloseSound(sdoor2g)


secttombdoor=Bladex.GetSector(75000,0,60000)
secttombdoor.OnEnter=OpenTombDoor


################################################################################################################################################
# big stone door across bridge


bridgedoor1=Doors.CreateDoor("BridgeDoor1", (21000,6000,51500), (0,1,0), 1900, 6900, Doors.CLOSED)
bridgedoor1.opentype=Doors.UNIF
bridgedoor1.o_med_vel=-200 
bridgedoor1.o_med_displ=5000
bridgedoor1.closetype=Doors.AC
bridgedoor1.c_init_displ=5000
bridgedoor1.c_med_vel=2200


bridgedoor1.SetWhileOpenSound(sdoor2d)
bridgedoor1.SetEndOpenSound(sdoor2g)
bridgedoor1.SetWhileCloseSound(sdoor2d)
bridgedoor1.SetEndCloseSound(sdoor2g)


bloque1=Bladex.CreateEntity("Bloque_1684","Bloque",17380,8100,53081)
bloque1.Scale=1.0
bloque1.Orientation=(0.707106769085,0.0,-0.707106769085,0.0)
darfuncs.SetHint(bloque1,"Trigger")

bloque2=Bladex.CreateEntity("Bloque_1685","Bloque",25580,8100,53081)
bloque2.Scale=1.0
bloque2.Orientation=(0.707106769085,0.0,-0.707106769085,0.0)
darfuncs.SetHint(bloque1,"Trigger")



bridgedoor1button=Button.CreateButtonCombination(0,AbreBridgeDoor1,"")
bridgedoor1button.AddButton("Bloque_1684",3,(0,0,-1),400,0,0,1)
bridgedoor1button.AddButton("Bloque_1685",3,(0,0,-1),400,0,0,1)


################################################################################################################################################

frontdoor=Doors.CreateDoor("FrontDoor", (22000,4000,-16125), (-1,0,0), 200, 2500, Doors.CLOSED)
frontdoor.opentype=Doors.UNIF
frontdoor.o_med_vel=-400
frontdoor.o_med_displ=2300
frontdoor.closetype=Doors.AC
frontdoor.c_init_displ=2300
frontdoor.c_med_vel=2200



frontdoor.SetWhileOpenSound(sdoor1d)
frontdoor.SetEndOpenSound(sdoor1g)
frontdoor.SetWhileCloseSound(sdoor1d)
frontdoor.SetEndCloseSound(sdoor1g)


frontdoorlever=Levers.PlaceLever("FrontDoorLever",Levers.LeverType3,(20360,5336,-15680),(0.0,1.27967922481e-007,0.707,-0.707),0.8)
frontdoorlever.mode=1
frontdoorlever.OnTurnOnFunc=OpenFrontDoor
frontdoorlever.OnTurnOnArgs=()
frontdoorlever.OnTurnOffFunc=CloseFrontDoor
frontdoorlever.OnTurnOffArgs=()

################################################################################################################################################

bedroomdoor=Doors.CreateDoor("BedroomDoor", (22000,-2000,-16250), (1,0,0), 400, 3500, Doors.CLOSED)
bedroomdoor.opentype=Doors.UNIF
bedroomdoor.o_med_vel=-400
bedroomdoor.o_med_displ=3100
bedroomdoor.closetype=Doors.AC
bedroomdoor.c_init_displ=3100
bedroomdoor.c_med_vel=2200



bedroomdoor.SetWhileOpenSound(sdoor1d)
bedroomdoor.SetEndOpenSound(sdoor1g)
bedroomdoor.SetWhileCloseSound(sdoor1d)
bedroomdoor.SetEndCloseSound(sdoor1g)


bedroomdoorlever=Levers.PlaceLever("BedRoomDoorLever",Levers.LeverType3,(24120,-992,-14568),(0.5,0.5,0.5,-0.5),0.8)
bedroomdoorlever.mode=1
bedroomdoorlever.OnTurnOnFunc=OpenBedroomDoor
bedroomdoorlever.OnTurnOnArgs=()
bedroomdoorlever.OnTurnOffFunc=CloseBedroomDoor
bedroomdoorlever.OnTurnOffArgs=()


################################################################################################################################################


bathroomdoor=Doors.CreateDoor("BathRoomDoor", (11000,-2000, 2875), (-1,0,0), 400, 3500, Doors.CLOSED)
bathroomdoor.opentype=Doors.UNIF
bathroomdoor.o_med_vel=-400
bathroomdoor.o_med_displ=3100
bathroomdoor.closetype=Doors.AC
bathroomdoor.c_init_displ=3100
bathroomdoor.c_med_vel=2200



bathroomdoor.SetWhileOpenSound(sdoor1d)
bathroomdoor.SetEndOpenSound(sdoor1g)
bathroomdoor.SetWhileCloseSound(sdoor1d)
bathroomdoor.SetEndCloseSound(sdoor1g)


bathroomdoorlever=Levers.PlaceLever("BathroomDoorLever",Levers.LeverType3,(9391,-1322,2415),(0.707,0.707,0.0,0.0),0.8)
bathroomdoorlever.mode=1
bathroomdoorlever.OnTurnOnFunc=OpenBathRoomDoor
bathroomdoorlever.OnTurnOnArgs=()
bathroomdoorlever.OnTurnOffFunc=OpenBathRoomDoor
bathroomdoorlever.OnTurnOffArgs=()


bathroomdoorinlever=Levers.PlaceLever("BathroomDoorInsideLever",Levers.LeverType3,(9177,-1046,3561),(0.0,1.24002369262e-007,0.707,-0.707),0.8)
bathroomdoorinlever.mode=1
bathroomdoorinlever.OnTurnOnFunc=OpenBathRoomDoor
bathroomdoorinlever.OnTurnOnArgs=()
bathroomdoorinlever.OnTurnOffFunc=OpenBathRoomDoor
bathroomdoorinlever.OnTurnOffArgs=()

#########################################################################################################################################################

o=Bladex.CreateEntity("CellarKey","Llavecutre",13097.6950892,6679.12591436,526.674303628, Reference.ObjType("Llavecutre"))
o.Scale=1.0
o.Orientation=(0.85783213377,0.018349474296,-0.513295710087,0.0177428368479)
darfuncs.SetHint(o,"Cellar Key")


cellardoor=Doors.CreateDoor("CellarDoor", (8250,4000, 0), (0,1,0), 2000, 5400, Doors.CLOSED)
cellardoor.opentype=Doors.UNIF
cellardoor.o_med_vel=-400
cellardoor.o_med_displ=3400
cellardoor.closetype=Doors.AC
cellardoor.c_init_displ=3400
cellardoor.c_med_vel=2200



cellardoor.SetWhileOpenSound(sdoor1d)
cellardoor.SetEndOpenSound(sdoor1g)
cellardoor.SetWhileCloseSound(sdoor1d)
cellardoor.SetEndCloseSound(sdoor1g)


cellardoorloc=Locks.PlaceLock("CellarLock","Cerraduracutre",(9007,6224,2550),(0.707,0.707,0.0,0.0),1.8)
cellardoorloc.Scale=2.6
cellardoorloc.Frozen=1
cellardoorloc.key="CellarKey"
darfuncs.SetHint(cellardoorloc.obj,"Cellar Lock")
cellardoorloc.OnUnLockFunc=AbreCellarDoor
cellardoorloc.OnUnLockArgs=()


o=Bladex.CreateEntity("Zocalo3_1616","Zocalo3",6393.11213566,5915.01871681,2885.48911723, Reference.ObjType("Zocalo3"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.707106769085,0.0,0.0)

cellardoorlvr=Levers.PlaceLever("CellarDoorLever",Levers.LeverType3,(6393,5915,2885),(0.707,0.707,0.0,0.0),0.8)
cellardoorlvr.mode=0
cellardoorlvr.OnTurnOnFunc=AbreCellarDoor
cellardoorlvr.OnTurnOnArgs=()

####### cave tunnel exit near ORCs #####################################################################################################################


gate2=Bladex.CreateEntity("Gate2","Rastrillo10",-28612.8654582,18739.0960108,33713.5086925, Reference.ObjType("Rastrillo10"))
gate2.Scale=0.8
gate2.Orientation=(0.270598113537,0.27059802413,0.653281509876,-0.653281450272)
Sparks.SetMetalSparkling("Gate2")
gate2.Frozen=1
gate2din=Objects.CreateDinamicObject("Gate2")



gate2lvr=Levers.PlaceLever("Gate2Lever",Levers.LeverType3,(-25581.0,19225.0,34322.0),(0.6533,0.6529,0.27,-0.27),0.8)
gate2lvr.mode=0
gate2lvr.OnTurnOnFunc=AbreGate
gate2lvr.OnTurnOnArgs=(gate2din,)



####### door to caverns  ##############################################################################################################################


caverndoor=Doors.CreateDoor("CavernDoor", (22500,4000,5750), (0,1,0), 200, 3500, Doors.CLOSED)
caverndoor.opentype=Doors.UNIF
caverndoor.o_med_vel=-400
caverndoor.o_med_displ=3300
caverndoor.closetype=Doors.AC
caverndoor.c_init_displ=3300
caverndoor.c_med_vel=2200



caverndoor.SetWhileOpenSound(sdoor1d)
caverndoor.SetEndOpenSound(sdoor1g)
caverndoor.SetWhileCloseSound(sdoor1d)
caverndoor.SetEndCloseSound(sdoor1g)


caverndoorlever=Levers.PlaceLever("CavernDoorLever",Levers.LeverType3,(25683,4644,4632),(0.707,0.707,0.0,0.0),0.8)
caverndoorlever.mode=1
caverndoorlever.OnTurnOnFunc=OpenCavernDoor
caverndoorlever.OnTurnOnArgs=()
caverndoorlever.OnTurnOffFunc=CloseCavernDoor
caverndoorlever.OnTurnOffArgs=()


#########################################################################################################################################################
### Cave Bridge

cavernbridge=Doors.CreateDoor("CaveBridge", (58000,8500,78000), (1,0,0), 500, 6500, Doors.OPENED)
cavernbridge.opentype=Doors.UNIF
cavernbridge.o_med_vel=-500
cavernbridge.o_med_displ=6000
cavernbridge.closetype=Doors.AC
cavernbridge.c_init_displ=6000
cavernbridge.c_med_vel=900

cavernbridge.OnEndCloseFunc=GolpeFinCaveGridge

cavernbridge.SetWhileOpenSound(sdoor3d)
cavernbridge.SetEndOpenSound(sdoor3g)
cavernbridge.SetWhileCloseSound(sdoor3d)
cavernbridge.SetEndCloseSound(sdoor3g)



blocN=Bladex.CreateEntity("CaveBridgeBlockN","Bloque",54059.4746832,6637.05893281,79879.6039735)
blocN.Scale=1.2
blocN.Static = 0
blocN.SelfIlum=0.2
blocN.Orientation=(0.707106769085,0.0,0.0,-0.707106769085)
blocNdin=Objects.CreateDinamicObject("CaveBridgeBlockN")
blocN.HitFunc = CloseCaveBridge


blocS=Bladex.CreateEntity("CaveBridgeBlockS","Bloque",54059.4746832,6637.05893281,76679.6039735)
blocS.Scale=1.2
blocS.Static = 0
blocS.SelfIlum=0.2
blocS.Orientation=(0.707106769085,0.0,0.0,-0.707106769085)
blocSdin=Objects.CreateDinamicObject("CaveBridgeBlockS")
blocS.HitFunc = CloseCaveBridge


#########################################################################################################################################################
## 2nd upper exit from underworld.


gate1=Bladex.CreateEntity("Gate1","Rastrillo102",39485,5944,13007,"Physic")
gate1.Scale=0.6
gate1.Orientation=(0.707,0.707,0.0,0.0)
Sparks.SetMetalSparkling("Gate1")
gate1.Frozen=1
gate1din=Objects.CreateDinamicObject("Gate1")


gate1lvr=Levers.PlaceLever("Gate1Lever",Levers.LeverType3,(41181,6744,14679),(0.5,0.5,0.5,-0.5),0.8)
gate1lvr.mode=0
gate1lvr.OnTurnOnFunc=AbreGate
gate1lvr.OnTurnOnArgs=(gate1din,)

##########################################################################################################################################################
#### Freezer


o=Bladex.CreateEntity("Zocalo2_1496","Zocalo2",34924.8447848,2093.57890068,-52765.8769855, Reference.ObjType("Zocalo2"))
o.Scale=1.0
o.Orientation=(0.5,0.5,0.5,-0.5)


freezerdoor=Doors.CreateDoor("FreezerDoor", (37500,1500,-54250), (0,1,0), 0, 3000, Doors.CLOSED)
freezerdoor.Squezze=1
freezerdoor.opentype=Doors.UNIF
freezerdoor.o_med_vel=-400
freezerdoor.o_med_displ=3000
freezerdoor.closetype=Doors.AC
freezerdoor.c_init_displ=3000
freezerdoor.c_med_vel=3000

freezerlvr=Levers.PlaceLever("FreezerDoorLever",Levers.LeverType2,(34924,2093,-52765),(0.5,0.5,0.5,-0.5),0.8)
freezerlvr.mode=1
freezerlvr.OnTurnOnFunc=AbreFreezerDoor
freezerlvr.OnTurnOnArgs=()


freezerdoor.SetWhileOpenSound(sdoor2d)
freezerdoor.SetEndOpenSound(sdoor2g)
freezerdoor.SetWhileCloseSound(sdoor2d)
freezerdoor.SetEndCloseSound(sdoor2g)

freezerdoor.OnEndOpenFunc=CheckFreezerDoor

##########################################################################################################################################################

o=Bladex.CreateEntity("Zocalo3_1558","Zocalo3",47912.7321132,6145.30208467,-1433.28623287, Reference.ObjType("Zocalo3"))
o.Scale=1.0
o.Orientation=(0.0,1.46570172888e-007,0.70710682869,-0.707106769085)


washhousedoor=Doors.CreateDoor("WashHouseDoor", (46375,5500,750), (0,0,-1), 500, 3000, Doors.CLOSED)
washhousedoor.opentype=Doors.UNIF
washhousedoor.o_med_vel=-400
washhousedoor.o_med_displ=2500
washhousedoor.closetype=Doors.AC
washhousedoor.c_init_displ=2500
washhousedoor.c_med_vel=2200

washhousedoor.SetWhileOpenSound(sdoor1d)
washhousedoor.SetEndOpenSound(sdoor1g)
washhousedoor.SetWhileCloseSound(sdoor1d)
washhousedoor.SetEndCloseSound(sdoor1g)

washhouselvr=Levers.PlaceLever("WashHouseDoorLever",Levers.LeverType3,(47912,6145,-1433),(0.0,0.0,0.707,-0.707),0.8)
washhouselvr.mode=0
washhouselvr.OnTurnOnFunc=AbreWashHouseDoor
washhouselvr.OnTurnOnArgs=()

##########################################################################################################################################################
#### Tower Gate

o=Bladex.CreateEntity("TowerGateBarrier","Rastrillo10",49803,-1182,6433, Reference.ObjType("Rastrillo10"))
o.Scale=1.2
o.Orientation=(1.0,0.0,0.0,0.0)
o.Alpha=0
o.CastShadows=0




o=Bladex.CreateEntity("Garfio_1563","Garfio",5502.18256715,-1915.26263287,-2696.11584296, Reference.ObjType("Garfio"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.0,1.05367119474e-008,1.82501214141e-008,1.0)


towergatekey=Bladex.CreateEntity("TowerKey","Llavepla",5482.18256715,-1735.26263287,-2956.11584296, Reference.ObjType("Llavepla"))
towergatekey.Scale=1.0
towergatekey.Orientation=(0.5,0.5,-0.5,-0.5)
darfuncs.SetHint(towergatekey,"Tower Key")


towergate=Bladex.CreateEntity("TowerGate","Rastrillo102",47455,-1581,5556,"Physic")
towergate.Scale=0.65
towergate.Orientation=(0.5,0.5,0.5,-0.5)
Sparks.SetMetalSparkling("TowerGate")
towergate.Frozen=1
towergatedin=Objects.CreateDinamicObject("TowerGate")



towergateloc=Locks.PlaceLock("TowerGateLock","Cerraduracutre",(46745,-1246,3954),(0.0,0.0,0.707,-0.707),2.6)
towergateloc.Scale=2.6
towergateloc.Frozen=1
towergateloc.key="TowerKey"
darfuncs.SetHint(towergateloc.obj,"Tower Lock")
towergateloc.OnUnLockFunc=AbreGate
towergateloc.OnUnLockArgs=(towergatedin,)



####### Tomb outer entrance ############################################################################################################################

tombgate1=Bladex.CreateEntity("TombGate1","Rastrillo10",87070,17061,75983, "Physic")
tombgate1.Scale=0.6
tombgate1.Orientation=(0.707,0.707,0.0,0.0)
tombgate1=Sparks.SetMetalSparkling("TombGate1")
tombgate1.Frozen=1
tombgate1din=Objects.CreateDinamicObject("TombGate1")



est1=Bladex.CreateEntity("Estaca1","EstacaFernando",79707.6200595,17044.7373651,69911.1800094)
est1.Scale=1.0
est1.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
est1din=Objects.CreateDinamicObject("Estaca1")

est2=Bladex.CreateEntity("Estaca2","EstacaFernando",78907.6200595,17044.7373651,69911.1800094)
est2.Scale=1.0
est2.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
est2din=Objects.CreateDinamicObject("Estaca2")

est3=Bladex.CreateEntity("Estaca3","EstacaFernando",78107.6200595,17044.7373651,69911.1800094)
est3.Scale=1.0
est3.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
est3din=Objects.CreateDinamicObject("Estaca3")

est4=Bladex.CreateEntity("Estaca4","EstacaFernando",77307.6200595,17044.7373651,69911.1800094)
est4.Scale=1.0
est4.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
est4din=Objects.CreateDinamicObject("Estaca4")

est5=Bladex.CreateEntity("Estaca5","EstacaFernando",76307.6200595,17044.7373651,69911.1800094)
est5.Scale=1.0
est5.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
est5din=Objects.CreateDinamicObject("Estaca5")



o=Bladex.CreateEntity("LapidaBarbaro_1586","LapidaBarbaro",77707.6200595,16844.7373651,70511.1800094)
o.Static=1
o.Scale=1.6
o.Orientation=(0.707106769085,0.0,0.0,-0.707106769085)
o.Alpha=0
o.CastShadows=0



secttombexit=Bladex.GetSector(82500,4000,86000)
secttombexit.OnEnter=""


tombexitdoor=Doors.CreateDoor("TombExitDoor", (76750,4000,86000), (0,1,0), 3000, 8000, Doors.CLOSED)
tombexitdoor.opentype=Doors.UNIF
tombexitdoor.o_med_vel=-300
tombexitdoor.o_med_displ=5000
tombexitdoor.closetype=Doors.AC
tombexitdoor.c_init_displ=5000
tombexitdoor.c_med_vel=2200


tombexitdoor.SetWhileOpenSound(sdoor2d)
tombexitdoor.SetEndOpenSound(sdoor2g)
tombexitdoor.SetWhileCloseSound(sdoor2d)
tombexitdoor.SetEndCloseSound(sdoor2g)

##########################################################################################################################################################


exitestaca1=Bladex.CreateEntity("ExitEstaca1","EstacaFernando",165190.284466,14641.8382046,-12419.2570557)
exitestaca1.Scale=1.0
exitestaca1.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
exitestaca1din=Objects.CreateDinamicObject("ExitEstaca1")

exitestaca2=Bladex.CreateEntity("ExitEstaca2","EstacaFernando",165190.284466,14641.8382046,-11819.2570557)
exitestaca2.Scale=1.0
exitestaca2.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
exitestaca2din=Objects.CreateDinamicObject("ExitEstaca2")

exitestaca3=Bladex.CreateEntity("ExitEstaca3","EstacaFernando",165190.284466,14641.8382046,-11219.2570557)
exitestaca3.Scale=1.0
exitestaca3.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
exitestaca3din=Objects.CreateDinamicObject("ExitEstaca3")

exitestaca4=Bladex.CreateEntity("ExitEstaca4","EstacaFernando",165190.284466,14641.8382046,-10619.2570557)
exitestaca4.Scale=1.0
exitestaca4.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
exitestaca4din=Objects.CreateDinamicObject("ExitEstaca4")

exitestaca5=Bladex.CreateEntity("ExitEstaca5","EstacaFernando",165190.284466,14641.8382046,-10019.2570557)
exitestaca5.Scale=1.0
exitestaca5.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
exitestaca5din=Objects.CreateDinamicObject("ExitEstaca5")

exitestaca6=Bladex.CreateEntity("ExitEstaca6","EstacaFernando",165190.284466,14641.8382046,-9419.25705572)
exitestaca6.Scale=1.0
exitestaca6.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
exitestaca6din=Objects.CreateDinamicObject("ExitEstaca6")

exitestaca7=Bladex.CreateEntity("ExitEstaca7","EstacaFernando",165190.284466,14641.8382046,-8819.25705572)
exitestaca7.Scale=1.0
exitestaca7.Orientation=(0.701057374477,0.701057374477,0.0922959595919,-0.0922959521413)
exitestaca7din=Objects.CreateDinamicObject("ExitEstaca7")

exitestaca8=Bladex.CreateEntity("ExitEstaca8","EstacaFernando",165190.284466,14641.8382046,-8219.25705572)
exitestaca8.Scale=1.0
exitestaca8.Orientation=(0.707106769085,0.707106769085,0.0,0.0)
exitestaca8din=Objects.CreateDinamicObject("ExitEstaca8")


o=Bladex.CreateEntity("Altar_1779","Altar",157857.44223,16361.9886463,-14906.4872279, Reference.ObjType("Altar"))
o.Static=1
o.Scale=1.0
o.Orientation=(0.707106769085,-0.707106769085,-9.52907974749e-009,9.52907974749e-009)


o=Bladex.CreateEntity("PiedraInformativa_1786","PiedraInformativa",157857.44223,15161.9886463,-14706.4872279, Reference.ObjType("PiedraInformativa"))
o.Static=1
o.Scale=1.2
o.Orientation=(0.0,1.45810730601e-007,0.707,-0.707)


orcalepointer=Bladex.CreateEntity("OraclePointer","GhostPointer", 157857,15000,-14300)
orcalepointer.Static=1
orcalepointer.UseFunc= AmIWorthy
darfuncs.SetHint(orcalepointer,"Oracle")


o=Bladex.CreateEntity("WizFace","TestSheet1",157857,14000,-15100)
o.Scale=12.5
o.Orientation=(0.0,0.0,0.0,1.0)
o.RasterMode  ="AdditiveAlpha"
o.RasterMode  ="Read"
o.CastShadows = 0
o.Alpha=0


exitbar1=Bladex.CreateEntity("ExitBarrier1","Rastrillo10",168906.858115,15464.7038223,-14600.0698514, Reference.ObjType("Rastrillo10"))
exitbar1.Scale=1.6
exitbar1.Orientation=(1.0,0.0,0.0,0.0)
exitbar1.Alpha=0
exitbar1.CastShadows=0

exitbar2=Bladex.CreateEntity("ExitBarrier2","Rastrillo10",168906.858115,15464.7038223,-6000.06985144, Reference.ObjType("Rastrillo10"))
exitbar2.Scale=1.6
exitbar2.Orientation=(1.0,0.0,0.0,0.0)
exitbar2.Alpha=0
exitbar2.CastShadows=0

#########################################################################################################################################################
### Cliff back room

cliffbackroomgate=Bladex.CreateEntity("CliffBackRoomGate","Rastrillo102",40252,-14494,48094,"Physic")
cliffbackroomgate.Scale=0.8
cliffbackroomgate.Orientation=(0.707,0.707,0.0,0.0)
Sparks.SetMetalSparkling("CliffBackRoomGate")
cliffbackroomgate.Frozen=1
cliffbackroomgatedin=Objects.CreateDinamicObject("CliffBackRoomGate")

cliffbackroomgatelvr=Levers.PlaceLever("CliffBackRoomGateLever",Levers.LeverType3,(41552,-13594,48394),(0.0,0.0,0.707,-0.707),0.8)
cliffbackroomgatelvr.mode=0
cliffbackroomgatelvr.OnTurnOnFunc=AbreGate
cliffbackroomgatelvr.OnTurnOnArgs=(cliffbackroomgatedin,)



o=Bladex.CreateEntity("CliffBackRoomBarrier","Rastrillo10",40446,-14000,50394, Reference.ObjType("Rastrillo10"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.0,-0.707106769085,0.0)
o.Alpha=0
o.CastShadows=0
o.RasterMode="AdditiveAlpha"
o.RasterMode="Read"


o=Bladex.CreateEntity("CliffBackRoomBarrier2","Rastrillo10",43000,-14000,50394, Reference.ObjType("Rastrillo10"))
o.Scale=1.0
o.Orientation=(0.707106769085,0.0,-0.707106769085,0.0)
o.Alpha=0
o.CastShadows=0
o.RasterMode="AdditiveAlpha"
o.RasterMode="Read"


#########################################################################################################################################################
### Elevator


elevador=Doors.CreateDoor("Elevador", (34500, 0, 50000), (0, -1, 0), 0, 21800, Doors.OPENED)
elevador.opentype=Doors.UNIF
elevador.o_med_vel=-500
elevador.o_med_displ=21800

elevador.closetype=Doors.AC
elevador.c_init_displ=21800
elevador.c_med_vel=2000


elevador.OnEndOpenFunc=ElevatorIsDown
elevador.OnEndCloseFunc=ElevatorIsUp

elevador.SetWhileOpenSound(loopelevador)
elevador.SetEndOpenSound(golpeelevador)
elevador.SetWhileCloseSound(loopelevador)
elevador.SetEndCloseSound(golpeelevador)


elevadorlowerlvr=Levers.PlaceLever("ElevadorLowerLever", Levers.LeverType3, (34498.2191072,8419.2492516,48575.0382767), (0.0,1.45620262515e-007,0.70710682869,-0.707106769085), 1.0)
elevadorlowerlvr.mode=1
elevadorlowerlvr.OnTurnOnFunc=UpElevator
elevadorlowerlvr.OnTurnOnArgs=()


elevadorupperlvr=Levers.PlaceLever("ElevadorUpperLever", Levers.LeverType3, (37480.3875966,-13599.9957756,48853.4792485), (0.0,1.27967922481e-007,0.707,-0.707), 1.0)
elevadorupperlvr.mode=1
elevadorupperlvr.OnTurnOnFunc=UpElevator
elevadorupperlvr.OnTurnOnArgs=()